/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for GLR parsing with Bison,
   Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* This is the parser code for GLR (Generalized LR) parser. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <setjmp.h>

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     prec_id = 258,
     prec_if = 259,
     prec_lower_than_error = 260,
     prec_import = 261,
     p_operator = 262,
     p_destructor = 263,
     p_constructor = 264,
     p_implementation = 265,
     p_initialization = 266,
     p_uses = 267,
     p_else = 268,
     p_and = 269,
     p_array = 270,
     p_begin = 271,
     p_case = 272,
     p_div = 273,
     p_do = 274,
     p_downto = 275,
     p_end = 276,
     p_file = 277,
     p_for = 278,
     p_function = 279,
     p_goto = 280,
     p_if = 281,
     p_in = 282,
     p_label = 283,
     p_mod = 284,
     p_nil = 285,
     p_not = 286,
     p_of = 287,
     p_or = 288,
     p_packed = 289,
     p_procedure = 290,
     p_to = 291,
     p_program = 292,
     p_record = 293,
     p_repeat = 294,
     p_set = 295,
     p_then = 296,
     p_type = 297,
     p_until = 298,
     p_var = 299,
     p_while = 300,
     p_with = 301,
     p_absolute = 302,
     p_abstract = 303,
     p_and_then = 304,
     p_as = 305,
     p_asm = 306,
     p_attribute = 307,
     p_bindable = 308,
     p_const = 309,
     p_external = 310,
     p_far = 311,
     p_finalization = 312,
     p_forward = 313,
     p_import = 314,
     p_inherited = 315,
     p_is = 316,
     p_near = 317,
     p_object = 318,
     p_only = 319,
     p_otherwise = 320,
     p_or_else = 321,
     p_pow = 322,
     p_restricted = 323,
     p_shl = 324,
     p_shr = 325,
     p_unit = 326,
     p_value = 327,
     p_virtual = 328,
     p_xor = 329,
     p_asmname = 330,
     p_c = 331,
     p_c_language = 332,
     p_Addr = 333,
     p_Assigned = 334,
     p_Dispose = 335,
     p_FormatString = 336,
     p_New = 337,
     p_Return = 338,
     p_Exit = 339,
     LEX_ID = 340,
     LEX_BUILTIN_PROCEDURE = 341,
     LEX_BUILTIN_PROCEDURE_WRITE = 342,
     LEX_BUILTIN_FUNCTION = 343,
     LEX_BUILTIN_FUNCTION_VT = 344,
     LEX_BUILTIN_VARIABLE = 345,
     LEX_INTCONST = 346,
     LEX_INTCONST_BASE = 347,
     LEX_STRCONST = 348,
     LEX_REALCONST = 349,
     LEX_CARET_WHITE = 350,
     LEX_STRUCTOR = 351,
     LEX_CARET_LETTER = 352,
     LEX_CONST_EQUAL = 353,
     LEX_BPPLUS = 354,
     LEX_BPMINUS = 355,
     LEX_RANGE = 356,
     LEX_ELLIPSIS = 357,
     LEX_RENAME = 358,
     LEX_SYMDIFF = 359,
     LEX_ASSIGN = 360,
     LEX_NE = 361,
     LEX_GE = 362,
     LEX_LE = 363,
     LEX_POWER = 364,
     LEX_CEIL_PLUS = 365,
     LEX_CEIL_MINUS = 366,
     LEX_FLOOR_PLUS = 367,
     LEX_FLOOR_MINUS = 368,
     LEX_CEIL_MULT = 369,
     LEX_CEIL_DIV = 370,
     LEX_FLOOR_MULT = 371,
     LEX_FLOOR_DIV = 372
   };
#endif
#define prec_id 258
#define prec_if 259
#define prec_lower_than_error 260
#define prec_import 261
#define p_operator 262
#define p_destructor 263
#define p_constructor 264
#define p_implementation 265
#define p_initialization 266
#define p_uses 267
#define p_else 268
#define p_and 269
#define p_array 270
#define p_begin 271
#define p_case 272
#define p_div 273
#define p_do 274
#define p_downto 275
#define p_end 276
#define p_file 277
#define p_for 278
#define p_function 279
#define p_goto 280
#define p_if 281
#define p_in 282
#define p_label 283
#define p_mod 284
#define p_nil 285
#define p_not 286
#define p_of 287
#define p_or 288
#define p_packed 289
#define p_procedure 290
#define p_to 291
#define p_program 292
#define p_record 293
#define p_repeat 294
#define p_set 295
#define p_then 296
#define p_type 297
#define p_until 298
#define p_var 299
#define p_while 300
#define p_with 301
#define p_absolute 302
#define p_abstract 303
#define p_and_then 304
#define p_as 305
#define p_asm 306
#define p_attribute 307
#define p_bindable 308
#define p_const 309
#define p_external 310
#define p_far 311
#define p_finalization 312
#define p_forward 313
#define p_import 314
#define p_inherited 315
#define p_is 316
#define p_near 317
#define p_object 318
#define p_only 319
#define p_otherwise 320
#define p_or_else 321
#define p_pow 322
#define p_restricted 323
#define p_shl 324
#define p_shr 325
#define p_unit 326
#define p_value 327
#define p_virtual 328
#define p_xor 329
#define p_asmname 330
#define p_c 331
#define p_c_language 332
#define p_Addr 333
#define p_Assigned 334
#define p_Dispose 335
#define p_FormatString 336
#define p_New 337
#define p_Return 338
#define p_Exit 339
#define LEX_ID 340
#define LEX_BUILTIN_PROCEDURE 341
#define LEX_BUILTIN_PROCEDURE_WRITE 342
#define LEX_BUILTIN_FUNCTION 343
#define LEX_BUILTIN_FUNCTION_VT 344
#define LEX_BUILTIN_VARIABLE 345
#define LEX_INTCONST 346
#define LEX_INTCONST_BASE 347
#define LEX_STRCONST 348
#define LEX_REALCONST 349
#define LEX_CARET_WHITE 350
#define LEX_STRUCTOR 351
#define LEX_CARET_LETTER 352
#define LEX_CONST_EQUAL 353
#define LEX_BPPLUS 354
#define LEX_BPMINUS 355
#define LEX_RANGE 356
#define LEX_ELLIPSIS 357
#define LEX_RENAME 358
#define LEX_SYMDIFF 359
#define LEX_ASSIGN 360
#define LEX_NE 361
#define LEX_GE 362
#define LEX_LE 363
#define LEX_POWER 364
#define LEX_CEIL_PLUS 365
#define LEX_CEIL_MINUS 366
#define LEX_FLOOR_PLUS 367
#define LEX_FLOOR_MINUS 368
#define LEX_CEIL_MULT 369
#define LEX_CEIL_DIV 370
#define LEX_FLOOR_MULT 371
#define LEX_FLOOR_DIV 372




/* Copy the first part of user declarations.  */
#line 69 "parse.y"

#include "gpc.h"

/* A few keywords of some dialects can be parsed as regular identifiers
   and checked from the parser actions => fewer special tokens. */
#define ASSERT_ID(id, location, pseudo_keyword) \
  do if (!IDENTIFIER_IS_BUILT_IN (id, pseudo_keyword) || !PD_ACTIVE (IDENTIFIER_BUILT_IN_VALUE (id))) \
    { yyerror_id (id, &location); YYERROR; } while (0)

/* Keep track of parenthesized expressions in case they're actually
   structured initializers. */
static tree iso_no_parentheses PARAMS ((tree));

enum { od_none, od_uses, od_label, od_const, od_type, od_var, od_routine };
static int check_decl_order PARAMS ((int, int));

extern int main_yyparse PARAMS ((void));
#define yyparse main_yyparse

union yyGLRStackItem;
static void locations PARAMS ((YYLTYPE *, const union yyGLRStackItem *, int));
#define YYLLOC_DEFAULT(DEST, SRC, N) locations (&DEST, SRC, N)
#ifndef GCC_3_4
#define LOCATION_NOTE(LOC) if (current_function_decl) emit_line_note ((LOC).first_file, (LOC).first_line)
#else
#define LOCATION_NOTE(LOC) if (current_function_decl) \
  { \
    location_t loc_aux; \
    loc_aux.file = (LOC).first_file; \
    loc_aux.line = (LOC).first_line; \
    emit_line_note (loc_aux); \
  }
#endif
#define COPYLOC(D, S) /* @@ ? (* (YYLTYPE *) memcpy (&(D), &(S), sizeof (YYLTYPE))) */ (S)

#define YYASSERT assert
#define YYMALLOC (void *) xmalloc
#define YYREALLOC (void *) xrealloc


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 118 "parse.y"
typedef union YYSTYPE {
  enum tree_code code;
  long itype;
  tree ttype;
} YYSTYPE;
/* Line 186 of glr.c.  */
#line 349 "parse.c"
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{

  int first_line;
  int first_column;
  int last_line;
  int last_column;

} YYLTYPE;
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template,
   here we set the default value of $$ to a zeroed-out value.
   Since the default value is undefined, this behavior is
   technically correct. */
static YYSTYPE yyval_default;

/* Copy the second part of user declarations.  */


/* Line 217 of glr.c.  */
#line 379 "parse.c"

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#ifdef __cplusplus
   typedef bool yybool;
#else
   typedef unsigned char yybool;
#endif
#define yytrue 1
#define yyfalse 0

/*-----------------.
| GCC extensions.  |
`-----------------*/

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if !defined (__GNUC__) || __GNUC__ < 2 || \
(__GNUC__ == 2 && __GNUC_MINOR__ < 5) || __STRICT_ANSI__
#  define __attribute__(Spec) /* empty */
# endif
#endif

#ifndef YYASSERT
# define YYASSERT(condition) ((void) ((condition) || (abort (), 0)))
#endif

#ifndef ATTRIBUTE_UNUSED
# define ATTRIBUTE_UNUSED __attribute__ ((__unused__))
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  69
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8414

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  137
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  289
/* YYNRULES -- Number of rules. */
#define YYNRULES  788
/* YYNRULES -- Number of states. */
#define YYNSTATES  1305
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule. */
#define YYMAXRHS 12
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule. */
#define YYMAXLEFT 0

/* YYTRANSLATE(X) -- Bison symbol number corresponding to X.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   372

#define YYTRANSLATE(YYX)						\
  ((YYX <= 0) ? YYEOF :							\
   (unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   136,     2,
     120,   122,   130,   128,   121,   129,     4,   131,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   123,   119,
     132,   133,   134,     2,   126,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   124,     2,   125,   127,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   135,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     6,     7,     8,    17,    19,    20,
      25,    30,    31,    34,    36,    38,    39,    42,    43,    46,
      50,    52,    55,    58,    59,    64,    67,    68,    69,    82,
      84,    86,    87,    91,    92,    93,   103,   104,   111,   112,
     113,   122,   123,   131,   132,   140,   141,   146,   148,   152,
     154,   157,   158,   161,   163,   165,   167,   168,   171,   173,
     174,   177,   179,   180,   181,   188,   189,   192,   194,   196,
     197,   204,   205,   212,   214,   215,   219,   220,   224,   226,
     227,   232,   234,   236,   240,   242,   244,   248,   252,   256,
     259,   261,   265,   267,   271,   273,   277,   281,   285,   286,
     288,   292,   294,   299,   301,   303,   307,   309,   313,   317,
     320,   324,   328,   330,   334,   336,   339,   340,   341,   345,
     348,   350,   354,   358,   363,   365,   367,   369,   373,   378,
     382,   384,   388,   392,   395,   397,   400,   402,   406,   408,
     412,   416,   419,   421,   425,   427,   431,   435,   438,   440,
     442,   444,   446,   448,   450,   453,   455,   460,   469,   471,
     475,   477,   481,   485,   488,   494,   495,   502,   506,   507,
     517,   521,   525,   527,   531,   535,   539,   542,   546,   548,
     551,   554,   556,   559,   561,   564,   567,   569,   571,   573,
     575,   577,   580,   582,   584,   586,   588,   592,   596,   600,
     602,   606,   608,   612,   616,   618,   620,   624,   628,   630,
     634,   638,   642,   645,   649,   654,   657,   660,   663,   667,
     669,   671,   673,   676,   680,   687,   689,   694,   698,   702,
     706,   708,   710,   714,   718,   721,   723,   725,   727,   729,
     733,   735,   736,   739,   747,   749,   752,   754,   758,   762,
     766,   769,   774,   778,   782,   784,   786,   788,   789,   795,
     797,   801,   805,   807,   810,   816,   818,   822,   826,   830,
     833,   835,   839,   843,   847,   851,   853,   855,   857,   861,
     865,   867,   870,   872,   874,   877,   881,   886,   890,   896,
     900,   904,   906,   909,   911,   913,   915,   918,   919,   928,
     930,   932,   936,   938,   941,   942,   948,   950,   954,   957,
     959,   964,   966,   970,   972,   974,   976,   980,   985,   992,
     994,   996,   998,  1000,  1003,  1006,  1008,  1009,  1013,  1016,
    1020,  1024,  1025,  1026,  1036,  1038,  1040,  1044,  1050,  1056,
    1062,  1070,  1076,  1082,  1084,  1086,  1090,  1093,  1097,  1098,
    1105,  1112,  1119,  1123,  1126,  1129,  1131,  1135,  1139,  1141,
    1143,  1145,  1147,  1149,  1152,  1154,  1155,  1157,  1160,  1162,
    1164,  1167,  1169,  1171,  1174,  1178,  1182,  1188,  1192,  1194,
    1198,  1202,  1206,  1210,  1215,  1220,  1224,  1228,  1234,  1236,
    1238,  1239,  1242,  1244,  1246,  1248,  1250,  1257,  1265,  1267,
    1269,  1271,  1275,  1279,  1283,  1289,  1293,  1295,  1297,  1303,
    1305,  1309,  1310,  1312,  1313,  1318,  1319,  1321,  1323,  1325,
    1328,  1330,  1332,  1334,  1335,  1340,  1342,  1345,  1347,  1352,
    1357,  1359,  1364,  1366,  1367,  1372,  1373,  1374,  1383,  1384,
    1385,  1386,  1396,  1397,  1398,  1407,  1408,  1420,  1421,  1431,
    1434,  1437,  1439,  1443,  1445,  1449,  1453,  1455,  1459,  1460,
    1466,  1467,  1472,  1474,  1476,  1477,  1480,  1482,  1486,  1488,
    1492,  1496,  1497,  1504,  1506,  1508,  1510,  1512,  1515,  1517,
    1519,  1522,  1524,  1529,  1532,  1537,  1543,  1549,  1557,  1567,
    1579,  1583,  1585,  1586,  1591,  1593,  1597,  1599,  1603,  1605,
    1609,  1613,  1617,  1619,  1623,  1629,  1630,  1632,  1634,  1636,
    1638,  1642,  1647,  1649,  1653,  1655,  1657,  1659,  1663,  1665,
    1667,  1670,  1674,  1678,  1679,  1684,  1686,  1690,  1694,  1695,
    1700,  1702,  1706,  1710,  1714,  1718,  1722,  1725,  1728,  1730,
    1732,  1734,  1736,  1738,  1740,  1742,  1744,  1746,  1748,  1750,
    1752,  1754,  1757,  1759,  1761,  1763,  1765,  1767,  1769,  1771,
    1773,  1775,  1777,  1779,  1781,  1783,  1785,  1787,  1789,  1791,
    1793,  1795,  1798,  1800,  1803,  1805,  1807,  1809,  1812,  1816,
    1820,  1823,  1828,  1833,  1837,  1838,  1844,  1849,  1854,  1855,
    1861,  1866,  1871,  1874,  1879,  1885,  1889,  1891,  1893,  1896,
    1900,  1904,  1906,  1908,  1910,  1914,  1918,  1920,  1927,  1932,
    1937,  1941,  1943,  1946,  1950,  1954,  1958,  1960,  1964,  1968,
    1970,  1972,  1976,  1978,  1980,  1984,  1986,  1990,  1994,  1996,
    1998,  2002,  2005,  2009,  2011,  2015,  2019,  2023,  2025,  2029,
    2031,  2033,  2035,  2037,  2039,  2041,  2043,  2045,  2047,  2049,
    2051,  2053,  2055,  2057,  2059,  2061,  2063,  2065,  2067,  2069,
    2071,  2073,  2075,  2077,  2079,  2082,  2084,  2086,  2088,  2091,
    2093,  2095,  2097,  2099,  2101,  2103,  2105,  2107,  2109,  2111,
    2113,  2115,  2117,  2119,  2121,  2123,  2125,  2127,  2129,  2131,
    2133,  2135,  2137,  2139,  2141,  2143,  2145,  2147,  2149,  2151,
    2153,  2155,  2157,  2159,  2161,  2163,  2165,  2167,  2169,  2171,
    2173,  2175,  2177,  2179,  2181,  2183,  2185,  2187,  2189,  2191,
    2193,  2195,  2197,  2199,  2201,  2203,  2205,  2207,  2209,  2211,
    2213,  2215,  2217,  2219,  2221,  2223,  2225,  2227,  2229,  2231,
    2233,  2235,  2237,  2239,  2241,  2243,  2245,  2247,  2249,  2251,
    2253,  2255,  2257,  2259,  2261,  2263,  2265,  2267,  2269,  2271,
    2273,  2275,  2277,  2279,  2281,  2283,  2285,  2287,  2289,  2291,
    2293,  2295,  2296,  2297,  2298,  2299,  2301,  2302,  2304,  2306,
    2308,  2310,  2312,  2314,  2316,  2318,  2320,  2322,  2323
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     138,     0,    -1,    -1,   139,    -1,    -1,    -1,   142,   168,
     140,   203,   143,   141,   311,   423,    -1,   151,    -1,    -1,
      38,   405,   188,   119,    -1,    38,     1,   188,   119,    -1,
      -1,   143,   144,    -1,   208,    -1,   146,    -1,    -1,   145,
     146,    -1,    -1,   147,   148,    -1,    29,   214,   119,    -1,
     282,    -1,   416,   149,    -1,    55,   218,    -1,    -1,    43,
     150,   220,   119,    -1,    45,   266,    -1,    -1,    -1,    72,
     405,   119,   168,    86,   152,   203,   169,   153,   165,    22,
     423,    -1,   158,    -1,   163,    -1,    -1,   158,   154,   163,
      -1,    -1,    -1,   166,   405,   167,   155,   161,   119,   156,
     174,   423,    -1,    -1,   166,   405,   167,   157,   174,   423,
      -1,    -1,    -1,   166,   405,    86,   159,   167,   160,   161,
     423,    -1,    -1,    86,   162,   192,   119,   203,   169,    22,
      -1,    -1,   166,   405,    11,   119,   164,   174,   423,    -1,
      -1,    11,   202,   143,   185,    -1,    86,    -1,   188,   119,
     168,    -1,   424,    -1,   274,   119,    -1,    -1,   169,   170,
      -1,   208,    -1,   148,    -1,   281,    -1,    -1,   171,   172,
      -1,   208,    -1,    -1,   173,   148,    -1,   282,    -1,    -1,
      -1,   175,   203,   171,   176,   177,    22,    -1,    -1,   178,
     180,    -1,   178,    -1,   180,    -1,    -1,    37,    17,    20,
     179,   316,   119,    -1,    -1,    37,    22,    20,   181,   316,
     119,    -1,   312,    -1,    -1,    12,   184,   182,    -1,    -1,
      17,   186,   182,    -1,   183,    -1,    -1,   183,    58,   187,
     312,    -1,   177,    -1,   424,    -1,   120,   189,   422,    -1,
     190,    -1,   405,    -1,   190,   121,   405,    -1,   190,     1,
     405,    -1,   190,   121,     1,    -1,   190,     1,    -1,   409,
      -1,   191,   121,   409,    -1,   193,    -1,   192,   119,   193,
      -1,     1,    -1,   192,     1,   193,    -1,   192,   119,     1,
      -1,   409,   194,   195,    -1,    -1,   421,    -1,   120,   197,
     122,    -1,   196,    -1,   196,   120,   197,   122,    -1,    86,
      -1,   198,    -1,   197,   121,   198,    -1,     1,    -1,   197,
       1,   198,    -1,   197,   121,     1,    -1,   199,   200,    -1,
     199,   102,   199,    -1,   418,   199,   200,    -1,   405,    -1,
     405,     4,   405,    -1,   424,    -1,   104,   405,    -1,    -1,
      -1,    60,   204,   119,    -1,   201,   202,    -1,   205,    -1,
     204,   119,   205,    -1,   204,     1,   205,    -1,   405,   206,
     207,   211,    -1,   424,    -1,    86,    -1,   424,    -1,   120,
     212,   122,    -1,    65,   120,   212,   122,    -1,    13,   209,
     119,    -1,   210,    -1,   209,   121,   210,    -1,   209,     1,
     210,    -1,   405,   211,    -1,   424,    -1,    28,   359,    -1,
     213,    -1,   212,   121,   213,    -1,     1,    -1,   212,     1,
     213,    -1,   212,   121,     1,    -1,   405,   200,    -1,   215,
      -1,   214,   121,   215,    -1,     1,    -1,   214,     1,   215,
      -1,   214,   121,     1,    -1,   214,     1,    -1,   217,    -1,
     405,    -1,   217,    -1,   412,    -1,    92,    -1,   219,    -1,
     218,   219,    -1,     1,    -1,   409,   421,   356,   119,    -1,
     409,   417,   123,   227,    99,   385,   272,   119,    -1,   221,
      -1,   220,   119,   221,    -1,     1,    -1,   220,     1,   221,
      -1,   220,   119,     1,    -1,   220,     1,    -1,   409,   417,
     421,   227,   278,    -1,    -1,   407,   224,   421,   222,   227,
     278,    -1,   407,   224,     1,    -1,    -1,   409,   417,   421,
     223,   261,    64,   262,   263,    22,    -1,   120,   225,   122,
      -1,   120,     1,   122,    -1,   226,    -1,   225,   119,   226,
      -1,   225,     1,   226,    -1,   225,   119,     1,    -1,   225,
       1,    -1,   189,   123,   233,    -1,   228,    -1,   227,   274,
      -1,   416,   229,    -1,   230,    -1,    54,   230,    -1,   232,
      -1,    69,   232,    -1,   233,   235,    -1,   260,    -1,   237,
      -1,   241,    -1,   243,    -1,   244,    -1,   231,   244,    -1,
      35,    -1,   233,    -1,   234,    -1,   412,    -1,   412,     4,
     412,    -1,   120,   236,   122,    -1,   124,   359,   125,    -1,
     359,    -1,   236,   121,   359,    -1,     1,    -1,   236,     1,
     359,    -1,   236,   121,     1,    -1,   238,    -1,   240,    -1,
     120,   239,   122,    -1,   120,     1,   122,    -1,   405,    -1,
     239,   121,   405,    -1,   239,     1,   405,    -1,   239,   121,
       1,    -1,   239,     1,    -1,   359,   102,   359,    -1,   231,
     359,   102,   359,    -1,   126,   242,    -1,   127,   242,    -1,
      96,   242,    -1,   420,    55,   242,    -1,   405,    -1,   243,
      -1,   248,    -1,    36,   299,    -1,    25,   299,   298,    -1,
      16,   124,   245,   125,    33,   228,    -1,   248,    -1,    23,
     247,    33,   228,    -1,    41,    33,   228,    -1,    39,   249,
      22,    -1,    39,     1,    22,    -1,   425,    -1,   246,    -1,
     245,   121,   246,    -1,   245,     1,   246,    -1,   245,     1,
      -1,     1,    -1,   237,    -1,   233,    -1,   424,    -1,   124,
     246,   125,    -1,    23,    -1,    -1,   251,   419,    -1,   250,
      18,   253,    33,   256,   419,   255,    -1,   424,    -1,   251,
     119,    -1,   252,    -1,   251,   119,   252,    -1,   251,     1,
     252,    -1,   251,   119,     1,    -1,   251,     1,    -1,   189,
     123,   228,   278,    -1,   405,   123,   233,    -1,   405,   123,
     254,    -1,   412,    -1,   254,    -1,   237,    -1,    -1,   336,
     120,   249,   122,   419,    -1,   257,    -1,   256,   119,   257,
      -1,   256,     1,   257,    -1,     1,    -1,   256,     1,    -1,
     258,   123,   120,   249,   122,    -1,   259,    -1,   258,   121,
     259,    -1,   258,   121,     1,    -1,   258,     1,   259,    -1,
     258,     1,    -1,   356,    -1,   356,   102,   356,    -1,   356,
       1,   356,    -1,   356,   102,     1,    -1,    43,    33,   359,
      -1,   424,    -1,    49,    -1,   424,    -1,   120,   233,   122,
      -1,   120,     1,   122,    -1,   264,    -1,   264,   265,    -1,
       1,    -1,   424,    -1,   264,    86,    -1,   264,   265,   119,
      -1,   189,   123,   228,   278,    -1,    36,   405,   299,    -1,
      25,   405,   299,   295,   298,    -1,    10,   405,   299,    -1,
       9,   405,   299,    -1,    74,    -1,    74,   359,    -1,    49,
      -1,   274,    -1,   267,    -1,   266,   267,    -1,    -1,   191,
     417,   123,   227,   268,   279,   269,   119,    -1,     1,    -1,
     424,    -1,   269,   119,   270,    -1,   273,    -1,    56,   368,
      -1,    -1,    56,   368,    86,   271,   359,    -1,   424,    -1,
     272,   119,   273,    -1,    76,   359,    -1,   274,    -1,    53,
     120,   275,   122,    -1,   276,    -1,   275,   121,   276,    -1,
     424,    -1,    55,    -1,   405,    -1,   405,   421,   359,    -1,
     405,   120,   359,   122,    -1,   405,   120,   412,   121,   359,
     122,    -1,    73,    -1,   106,    -1,    99,    -1,   424,    -1,
     277,   385,    -1,   277,     1,    -1,   278,    -1,    -1,    48,
     280,   359,    -1,    48,     1,    -1,   286,   119,   288,    -1,
     285,   119,   289,    -1,    -1,    -1,   285,   119,   292,   283,
     202,   145,   284,   311,   119,    -1,   286,    -1,   287,    -1,
      36,   405,   299,    -1,    25,   405,   299,   295,   298,    -1,
       8,   294,   299,   297,   298,    -1,    36,   405,     4,   405,
     299,    -1,    25,   405,     4,   405,   299,   295,   298,    -1,
      10,   405,     4,   405,   299,    -1,     9,   405,     4,   405,
     299,    -1,   292,    -1,   289,    -1,   292,   290,   292,    -1,
      59,   119,    -1,    56,   368,   119,    -1,    -1,    56,   368,
      86,   291,   359,   119,    -1,    56,   368,   119,    76,   359,
     119,    -1,    76,   359,   119,    56,   368,   119,    -1,    76,
     359,   119,    -1,    77,   119,    -1,    78,   119,    -1,   424,
      -1,   292,   274,   119,    -1,   292,   293,   119,    -1,    57,
      -1,    63,    -1,   405,    -1,   404,    -1,   424,    -1,   296,
     405,    -1,   421,    -1,    -1,   405,    -1,   421,   405,    -1,
     424,    -1,   315,    -1,   123,   232,    -1,   425,    -1,   424,
      -1,   120,   122,    -1,   120,   300,   122,    -1,   120,   103,
     122,    -1,   120,   300,   119,   103,   122,    -1,   120,     1,
     122,    -1,   301,    -1,   300,   119,   301,    -1,   300,     1,
     301,    -1,   300,   119,     1,    -1,   189,   123,   304,    -1,
     418,   189,   123,   304,    -1,   302,    45,   189,   303,    -1,
      55,   189,   303,    -1,    36,   405,   299,    -1,    25,   405,
     299,   295,   298,    -1,   424,    -1,   418,    -1,    -1,   123,
     304,    -1,   310,    -1,   260,    -1,   305,    -1,   309,    -1,
      16,   124,   307,   125,    33,   306,    -1,   231,    16,   124,
     308,   125,    33,   233,    -1,   233,    -1,   305,    -1,   308,
      -1,   307,   119,   308,    -1,   307,     1,   308,    -1,   307,
     119,     1,    -1,   405,   102,   405,   123,   233,    -1,    16,
      33,   310,    -1,   233,    -1,   248,    -1,    17,   414,   312,
     415,    22,    -1,   313,    -1,   312,   119,   313,    -1,    -1,
     317,    -1,    -1,    45,   267,   314,   313,    -1,    -1,   315,
      -1,   317,    -1,   330,    -1,   330,   318,    -1,   318,    -1,
     311,    -1,   342,    -1,    -1,   342,   319,   343,   359,    -1,
      84,    -1,    84,   359,    -1,    85,    -1,    85,   120,    38,
     122,    -1,    85,   120,    86,   122,    -1,   344,    -1,    47,
     331,    20,   316,    -1,   333,    -1,    -1,   333,    14,   320,
     316,    -1,    -1,    -1,    18,   359,    33,   321,   337,   322,
     335,    22,    -1,    -1,    -1,    -1,    40,   323,   414,   312,
      44,   324,   357,   325,   415,    -1,    -1,    -1,    46,   326,
     414,   357,   327,    20,   316,   415,    -1,    -1,    24,   372,
     343,   359,   341,   359,   328,    20,   414,   316,   415,    -1,
      -1,    24,   372,    28,   359,   329,    20,   414,   316,   415,
      -1,    26,   216,    -1,   216,   123,    -1,   332,    -1,   331,
     121,   332,    -1,     1,    -1,   331,     1,   332,    -1,   331,
     121,     1,    -1,   358,    -1,   358,   123,   405,    -1,    -1,
      27,   357,    42,   334,   316,    -1,    -1,   336,   414,   312,
     415,    -1,    14,    -1,    66,    -1,    -1,   338,   419,    -1,
     339,    -1,   338,   119,   339,    -1,     1,    -1,   338,     1,
     339,    -1,   338,   119,     1,    -1,    -1,   258,   123,   340,
     414,   316,   415,    -1,    37,    -1,    21,    -1,     1,    -1,
     373,    -1,   126,   373,    -1,   106,    -1,   421,    -1,   403,
     346,    -1,    88,    -1,    88,   120,   349,   422,    -1,   345,
     422,    -1,   345,   121,   348,   422,    -1,   345,   121,    97,
     346,   422,    -1,    52,   351,   120,   371,   122,    -1,    52,
     351,   120,   371,   123,   352,   122,    -1,    52,   351,   120,
     371,   123,   352,   123,   352,   122,    -1,    52,   351,   120,
     371,   123,   352,   123,   352,   123,   355,   122,    -1,    81,
     120,   359,    -1,   424,    -1,    -1,   347,   120,   348,   422,
      -1,   359,    -1,   348,   121,   359,    -1,     1,    -1,   348,
     121,     1,    -1,   350,    -1,   349,   121,   350,    -1,   349,
       1,   350,    -1,   349,   121,     1,    -1,   359,    -1,   359,
     123,   359,    -1,   359,   123,   359,   123,   359,    -1,    -1,
      86,    -1,   424,    -1,   353,    -1,   354,    -1,   353,   121,
     354,    -1,   367,   120,   359,   122,    -1,   367,    -1,   355,
     121,   367,    -1,   359,    -1,   359,    -1,   359,    -1,   360,
     396,   360,    -1,   360,    -1,   362,    -1,   394,   362,    -1,
     360,   397,   362,    -1,   360,   401,   362,    -1,    -1,   360,
     399,   361,   362,    -1,   364,    -1,   362,   398,   364,    -1,
     362,   402,   364,    -1,    -1,   362,   400,   363,   364,    -1,
     365,    -1,   364,   412,   365,    -1,   365,    68,   365,    -1,
     365,   110,   365,    -1,   364,    62,   233,    -1,   364,    51,
     233,    -1,   395,   365,    -1,   126,   365,    -1,   367,    -1,
     366,    -1,    31,    -1,   391,    -1,   373,    -1,    92,    -1,
      93,    -1,    95,    -1,   371,    -1,   424,    -1,   367,    -1,
      94,    -1,    96,    -1,   127,   370,    -1,    98,    -1,   121,
      -1,     4,    -1,   123,    -1,   119,    -1,   120,    -1,   122,
      -1,   124,    -1,   125,    -1,   128,    -1,   129,    -1,   130,
      -1,   131,    -1,   132,    -1,   133,    -1,   134,    -1,   126,
      -1,   127,    -1,   369,    -1,   371,   369,    -1,   373,    -1,
      89,   346,    -1,    91,    -1,   374,    -1,   411,    -1,    61,
     405,    -1,   372,     4,   405,    -1,   120,   359,   122,    -1,
     372,   420,    -1,   372,   124,   389,   125,    -1,   372,   124,
     379,   125,    -1,   374,   120,   122,    -1,    -1,   374,   120,
     375,   348,   422,    -1,   248,   120,   359,   122,    -1,    82,
     120,   349,   122,    -1,    -1,    80,   376,   120,   359,   122,
      -1,    79,   120,   373,   122,    -1,    90,   120,   378,   122,
      -1,   377,   122,    -1,   377,   121,   348,   122,    -1,   377,
     121,    97,   346,   122,    -1,    83,   120,   378,    -1,   373,
      -1,   248,    -1,   380,   419,    -1,   380,   119,   382,    -1,
     380,   419,   384,    -1,   382,    -1,   384,    -1,   381,    -1,
     380,   119,   381,    -1,   389,   123,   385,    -1,   385,    -1,
      18,   405,   123,   359,    33,   383,    -1,    18,   359,    33,
     383,    -1,   124,   379,   125,   419,    -1,    66,   385,   419,
      -1,   359,    -1,   120,   122,    -1,   120,   386,   122,    -1,
     124,   379,   125,    -1,   124,     1,   125,    -1,   388,    -1,
     386,   387,   388,    -1,   386,     1,   388,    -1,   119,    -1,
     121,    -1,   390,   123,   385,    -1,   385,    -1,   390,    -1,
     389,   121,   390,    -1,     1,    -1,   389,     1,   390,    -1,
     389,   121,     1,    -1,   405,    -1,   359,    -1,   359,   102,
     359,    -1,   124,   125,    -1,   124,   392,   125,    -1,   393,
      -1,   392,   121,   393,    -1,   392,     1,   393,    -1,   392,
     121,     1,    -1,   359,    -1,   359,   102,   359,    -1,   128,
      -1,   129,    -1,   100,    -1,   101,    -1,    32,    -1,   107,
      -1,   109,    -1,   108,    -1,   133,    -1,   132,    -1,   134,
      -1,    28,    -1,   128,    -1,   100,    -1,   129,    -1,   101,
      -1,    75,    -1,   105,    -1,   130,    -1,   131,    -1,    19,
      -1,    30,    -1,    70,    -1,    71,    -1,    34,    -1,    34,
      14,    -1,    67,    -1,   135,    -1,    15,    -1,    15,    42,
      -1,    50,    -1,   136,    -1,   111,    -1,   112,    -1,   113,
      -1,   114,    -1,   115,    -1,   116,    -1,   117,    -1,   118,
      -1,    87,    -1,    15,    -1,    34,    -1,    32,    -1,    75,
      -1,    70,    -1,    71,    -1,   128,    -1,   100,    -1,   129,
      -1,   101,    -1,   130,    -1,   131,    -1,    19,    -1,    30,
      -1,   110,    -1,    28,    -1,   132,    -1,   421,    -1,   134,
      -1,   107,    -1,   108,    -1,   109,    -1,    15,    -1,   136,
      -1,    34,    -1,   135,    -1,   105,    -1,   402,    -1,   401,
      -1,   406,    -1,   408,    -1,    10,    -1,     9,    -1,    56,
      -1,    11,    -1,    60,    -1,    12,    -1,     8,    -1,    13,
      -1,   408,    -1,   409,    -1,    76,    -1,    53,    -1,   410,
      -1,    86,    -1,   413,    -1,    57,    -1,    59,    -1,    63,
      -1,    89,    -1,    91,    -1,    87,    -1,    88,    -1,    90,
      -1,    84,    -1,    85,    -1,    79,    -1,    80,    -1,    83,
      -1,    81,    -1,    82,    -1,    48,    -1,    49,    -1,    50,
      -1,    51,    -1,    52,    -1,    54,    -1,    77,    -1,    78,
      -1,    58,    -1,    61,    -1,    62,    -1,    64,    -1,    65,
      -1,    67,    -1,    66,    -1,    68,    -1,    69,    -1,    70,
      -1,    71,    -1,    72,    -1,    73,    -1,    74,    -1,    75,
      -1,   412,    -1,    86,    -1,   413,    -1,    57,    -1,    59,
      -1,    63,    -1,    98,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,   119,    -1,   127,    -1,    96,    -1,   126,    -1,
     133,    -1,    99,    -1,   122,    -1,     1,    -1,     4,    -1,
       1,    -1,    -1,     1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   245,   245,   246,   258,   260,   257,   263,   269,   270,
     272,   278,   279,   284,   285,   290,   291,   296,   296,   299,
     301,   306,   316,   319,   318,   322,   328,   330,   327,   333,
     334,   336,   335,   344,   346,   343,   352,   351,   358,   360,
     357,   367,   366,   374,   373,   379,   380,   384,   389,   394,
     395,   400,   401,   406,   407,   408,   414,   415,   420,   421,
     421,   424,   429,   431,   429,   435,   437,   438,   439,   444,
     443,   451,   450,   457,   463,   462,   469,   468,   471,   473,
     472,   476,   480,   481,   486,   491,   493,   495,   501,   503,
     507,   509,   514,   515,   517,   519,   521,   526,   532,   533,
     537,   539,   540,   545,   550,   551,   553,   555,   557,   562,
     564,   566,   571,   572,   577,   578,   585,   588,   590,   594,
     598,   599,   600,   605,   610,   611,   616,   617,   619,   624,
     629,   630,   631,   636,   641,   642,   647,   648,   650,   652,
     654,   659,   666,   668,   670,   672,   674,   676,   680,   681,
     688,   689,   693,   700,   701,   702,   706,   708,   719,   720,
     722,   723,   725,   727,   731,   742,   741,   753,   756,   755,
     766,   768,   773,   774,   776,   778,   780,   784,   789,   790,
     797,   807,   808,   813,   814,   816,   818,   819,   820,   821,
     823,   824,   829,   834,   846,   860,   861,   866,   868,   876,
     881,   886,   888,   894,   901,   902,   906,   908,   913,   915,
     917,   919,   921,   925,   927,   937,   939,   941,   943,   951,
     953,   959,   965,   967,   972,   974,   975,   977,   979,   981,
     983,   987,   988,   990,   992,   994,   999,  1001,  1006,  1007,
    1012,  1018,  1019,  1021,  1026,  1027,  1031,  1032,  1034,  1036,
    1038,  1042,  1047,  1049,  1051,  1053,  1058,  1064,  1065,  1070,
    1071,  1073,  1075,  1077,  1081,  1086,  1087,  1089,  1091,  1093,
    1097,  1099,  1104,  1110,  1115,  1122,  1123,  1127,  1128,  1130,
    1135,  1136,  1138,  1143,  1144,  1146,  1151,  1153,  1155,  1157,
    1159,  1161,  1163,  1165,  1167,  1173,  1174,  1179,  1178,  1203,
    1208,  1209,  1214,  1215,  1218,  1217,  1224,  1225,  1230,  1232,
    1237,  1242,  1243,  1248,  1249,  1251,  1253,  1255,  1257,  1262,
    1263,  1265,  1270,  1271,  1273,  1278,  1280,  1279,  1287,  1294,
    1305,  1308,  1311,  1307,  1323,  1324,  1328,  1330,  1332,  1342,
    1344,  1346,  1348,  1353,  1354,  1358,  1363,  1365,  1368,  1367,
    1371,  1373,  1375,  1377,  1379,  1384,  1385,  1387,  1395,  1396,
    1400,  1401,  1405,  1406,  1411,  1413,  1417,  1418,  1420,  1425,
    1427,  1429,  1433,  1434,  1439,  1441,  1443,  1445,  1450,  1451,
    1453,  1455,  1459,  1461,  1463,  1465,  1467,  1469,  1474,  1475,
    1480,  1481,  1486,  1487,  1488,  1489,  1493,  1495,  1504,  1505,
    1509,  1510,  1512,  1514,  1518,  1526,  1534,  1535,  1541,  1546,
    1547,  1551,  1553,  1555,  1554,  1560,  1564,  1566,  1571,  1572,
    1573,  1580,  1581,  1584,  1583,  1587,  1589,  1591,  1593,  1595,
    1597,  1598,  1600,  1603,  1602,  1611,  1616,  1610,  1632,  1634,
    1636,  1631,  1640,  1642,  1639,  1646,  1645,  1650,  1649,  1653,
    1658,  1663,  1664,  1666,  1668,  1670,  1675,  1677,  1683,  1682,
    1693,  1700,  1705,  1707,  1712,  1713,  1718,  1719,  1721,  1723,
    1725,  1731,  1730,  1737,  1739,  1741,  1746,  1747,  1752,  1753,
    1758,  1760,  1762,  1764,  1766,  1774,  1776,  1778,  1780,  1782,
    1787,  1792,  1793,  1793,  1799,  1801,  1803,  1805,  1810,  1811,
    1813,  1815,  1821,  1823,  1825,  1831,  1832,  1837,  1838,  1842,
    1843,  1848,  1853,  1855,  1862,  1879,  1890,  1895,  1897,  1902,
    1903,  1905,  1907,  1910,  1909,  1916,  1917,  1919,  1922,  1921,
    1928,  1929,  1931,  1933,  1935,  1937,  1942,  1944,  1949,  1950,
    1951,  1953,  1954,  1969,  1970,  1971,  1975,  1980,  1981,  1985,
    1986,  1987,  1992,  1993,  1993,  1993,  1993,  1993,  1993,  1993,
    1993,  1994,  1994,  1994,  1994,  1994,  1994,  1994,  1994,  1994,
    1998,  2000,  2005,  2010,  2012,  2014,  2018,  2019,  2021,  2023,
    2025,  2027,  2029,  2031,  2034,  2033,  2040,  2042,  2045,  2044,
    2051,  2053,  2055,  2057,  2068,  2073,  2078,  2079,  2084,  2085,
    2087,  2089,  2090,  2094,  2095,  2100,  2102,  2107,  2109,  2114,
    2119,  2124,  2126,  2128,  2130,  2132,  2137,  2138,  2140,  2145,
    2146,  2151,  2153,  2158,  2159,  2161,  2163,  2165,  2170,  2172,
    2174,  2179,  2181,  2186,  2187,  2189,  2191,  2196,  2198,  2205,
    2206,  2210,  2211,  2212,  2216,  2217,  2218,  2219,  2220,  2221,
    2222,  2226,  2227,  2228,  2229,  2230,  2231,  2235,  2236,  2237,
    2238,  2239,  2240,  2244,  2245,  2246,  2247,  2251,  2252,  2253,
    2254,  2258,  2259,  2260,  2261,  2265,  2266,  2267,  2268,  2274,
    2277,  2278,  2279,  2280,  2281,  2282,  2288,  2289,  2290,  2291,
    2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,  2301,
    2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,  2314,
    2319,  2320,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2332,
    2337,  2338,  2339,  2344,  2349,  2350,  2351,  2352,  2353,  2354,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
    2365,  2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,
    2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,  2383,  2384,
    2385,  2386,  2387,  2388,  2392,  2397,  2398,  2399,  2400,  2401,
    2405,  2413,  2418,  2423,  2433,  2437,  2443,  2444,  2449,  2450,
    2451,  2455,  2456,  2460,  2461,  2466,  2467,  2473,  2477
};
#endif

#if (YYDEBUG) || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "prec_id", "'.'", "prec_if",
  "prec_lower_than_error", "prec_import", "p_operator", "p_destructor",
  "p_constructor", "p_implementation", "p_initialization", "p_uses",
  "p_else", "p_and", "p_array", "p_begin", "p_case", "p_div", "p_do",
  "p_downto", "p_end", "p_file", "p_for", "p_function", "p_goto", "p_if",
  "p_in", "p_label", "p_mod", "p_nil", "p_not", "p_of", "p_or", "p_packed",
  "p_procedure", "p_to", "p_program", "p_record", "p_repeat", "p_set",
  "p_then", "p_type", "p_until", "p_var", "p_while", "p_with",
  "p_absolute", "p_abstract", "p_and_then", "p_as", "p_asm", "p_attribute",
  "p_bindable", "p_const", "p_external", "p_far", "p_finalization",
  "p_forward", "p_import", "p_inherited", "p_is", "p_near", "p_object",
  "p_only", "p_otherwise", "p_or_else", "p_pow", "p_restricted", "p_shl",
  "p_shr", "p_unit", "p_value", "p_virtual", "p_xor", "p_asmname", "p_c",
  "p_c_language", "p_Addr", "p_Assigned", "p_Dispose", "p_FormatString",
  "p_New", "p_Return", "p_Exit", "LEX_ID", "LEX_BUILTIN_PROCEDURE",
  "LEX_BUILTIN_PROCEDURE_WRITE", "LEX_BUILTIN_FUNCTION",
  "LEX_BUILTIN_FUNCTION_VT", "LEX_BUILTIN_VARIABLE", "LEX_INTCONST",
  "LEX_INTCONST_BASE", "LEX_STRCONST", "LEX_REALCONST", "LEX_CARET_WHITE",
  "LEX_STRUCTOR", "LEX_CARET_LETTER", "LEX_CONST_EQUAL", "LEX_BPPLUS",
  "LEX_BPMINUS", "LEX_RANGE", "LEX_ELLIPSIS", "LEX_RENAME", "LEX_SYMDIFF",
  "LEX_ASSIGN", "LEX_NE", "LEX_GE", "LEX_LE", "LEX_POWER", "LEX_CEIL_PLUS",
  "LEX_CEIL_MINUS", "LEX_FLOOR_PLUS", "LEX_FLOOR_MINUS", "LEX_CEIL_MULT",
  "LEX_CEIL_DIV", "LEX_FLOOR_MULT", "LEX_FLOOR_DIV", "';'", "'('", "','",
  "')'", "':'", "'['", "']'", "'@'", "'^'", "'+'", "'-'", "'*'", "'/'",
  "'<'", "'='", "'>'", "'|'", "'&'", "$accept", "program_component",
  "program_component_1", "@1", "@2", "optional_program_heading",
  "declarations_and_uses", "declaration_or_uses", "any_declaration_part",
  "any_decl", "@3", "simple_decl", "simple_decl_1", "@4",
  "module_declaration", "@5", "@6", "@7", "@8", "@9", "@10",
  "interface_module", "@11", "@12", "module_interface", "@13",
  "implementatation_module", "@14", "optional_unit_implementation",
  "module", "optional_module_parameters", "optional_module_attributes",
  "interface_decl_part", "interface_decl", "implementation_decls",
  "implementation_decl", "@15", "module_block", "@16", "@17",
  "optional_init_and_final_part", "module_constructor", "@18",
  "module_destructor", "@19", "rest_of_unit_constructor",
  "unit_initialization", "@20", "optional_unit_init_and_final_part", "@21",
  "@22", "optional_par_id_list", "id_list", "id_list1", "id_list_limited",
  "export_part_list", "export_part", "equals_or_error",
  "export_list_or_all", "export_all", "export_list", "export_list_item",
  "new_quid", "optional_rename", "extra_import_part",
  "optional_import_part1", "optional_import_part",
  "import_specification_list", "import_specification",
  "optional_qualified", "optional_import_qualifier", "uses_part",
  "uses_list", "uses_specification", "optional_unit_filename",
  "import_clause_list", "import_clause", "label_list", "new_label",
  "label", "num_label", "constant_definition_list", "constant_definition",
  "type_definition_list", "type_definition", "@23", "@24",
  "formal_schema_discriminants", "discriminant_specification_list",
  "discriminant_specification", "type_denoter_with_attributes",
  "type_denoter", "type_denoter_1", "type_denoter_0", "packed",
  "typename_or_string255", "typename", "typename_1",
  "actual_schema_discriminants", "discriminant_expression_list",
  "new_ordinal_type", "enumerated_type", "enum_list", "subrange_type",
  "new_pointer_type", "pointer_domain_type", "new_procedural_type",
  "unpacked_structured_type", "array_index_list", "ordinal_index_type",
  "direct_access_index_type", "untyped_file", "record_field_list",
  "optional_fixed_part", "fixed_part", "record_section",
  "variant_selector", "new_ordinal_type_non_iso", "rest_of_variant",
  "variant_list", "variant", "case_constant_list", "one_case_constant",
  "type_inquiry", "optional_abstract", "object_parent",
  "object_field_list", "object_field_list_1", "object_section",
  "variable_declaration_list", "variable_declaration", "@25",
  "optional_variable_directive_list", "variable_directive", "@26",
  "optional_variable_directive_list_no_external",
  "variable_directive_no_external", "attributes", "attribute_list",
  "attrib", "var_init", "optional_value_specification",
  "absolute_or_value_specification", "@27", "routine_interface_decl",
  "routine_declaration", "@28", "@29", "routine_or_method_heading",
  "routine_heading", "method_heading",
  "optional_routine_interface_directive_list", "remote_directive_list",
  "remote_directive", "@30", "optional_routine_directive_list",
  "bp_directive", "operator_identifier", "optional_result_def",
  "optional_result_equals", "operator_result_def", "resulttype",
  "optional_formal_parameter_list", "formal_parameter_list",
  "formal_parameter", "optional_protected", "optional_parameter_form",
  "parameter_form", "conformant_array", "typename_or_conformant_array",
  "index_type_specification_list", "index_type_specification",
  "open_array", "typename_or_untyped_file", "compound_statement",
  "statement_sequence", "optional_statement_vd", "@31", "empty_lte",
  "optional_statement", "statement", "unlabelled_statement", "@32", "@33",
  "@34", "@35", "@36", "@37", "@38", "@39", "@40", "@41", "@42",
  "set_label", "with_list", "with_variable", "if_then", "@43",
  "optional_case_completer", "otherwise", "optional_case_element_list",
  "case_element_list", "case_element", "@44", "for_direction",
  "start_of_assignment_or_call", "assign", "builtin_procedure_statement",
  "start_of_dispose", "optional_actual_parameter_list", "@45",
  "actual_parameter_list", "write_actual_parameter_list",
  "write_actual_parameter", "asm_qualifier", "asm_operands",
  "nonempty_asm_operands", "asm_operand", "asm_clobbers",
  "static_expression", "boolean_expression", "expression_no_par",
  "expression", "simple_expression", "@46", "term", "@47", "factor",
  "primary", "unsigned_number", "combined_string",
  "optional_combined_string", "string_constant", "caret_chars",
  "string_constants", "variable_or_routine_access_no_parentheses",
  "variable_or_routine_access",
  "variable_or_routine_access_no_builtin_function", "@48", "@49",
  "start_of_new", "variable_or_typename", "structured_constructor_list",
  "field_value_list", "field_value", "variant_part_value",
  "variant_part_value0", "array_value_completer", "component_value",
  "bp_constructor_list", "initializer_separator", "bp_field_value",
  "index_expression_list", "index_expression_item", "set_constructor",
  "set_constructor_element_list", "member_designator", "sign",
  "unary_operator", "relational_operator", "adding_operator",
  "multiplying_operator", "or_operator", "and_operator",
  "pxsc_adding_operator", "pxsc_multiplying_operator", "builtin_proc",
  "operator_symbol", "new_identifier", "new_identifier_1",
  "new_identifier_limited_par", "new_identifier_limited_par_1",
  "new_identifier_limited", "new_identifier_limited_1", "identifier", "id",
  "caret_letter", "pushlevel", "poplevel", "setspecs", "enable_lce",
  "i_protected", "optional_semicolon", "pointer_char", "equals",
  "rpar_or_error", "dot_or_error", "null", "err", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   137,   138,   138,   140,   141,   139,   139,   142,   142,
     142,   143,   143,   144,   144,   145,   145,   147,   146,   146,
     146,   148,   149,   150,   149,   149,   152,   153,   151,   151,
     151,   154,   151,   155,   156,   151,   157,   151,   159,   160,
     158,   162,   161,   164,   163,   165,   165,   166,   167,   168,
     168,   169,   169,   170,   170,   170,   171,   171,   172,   173,
     172,   172,   175,   176,   174,   177,   177,   177,   177,   179,
     178,   181,   180,   182,   184,   183,   186,   185,   185,   187,
     185,   185,   188,   188,   189,   190,   190,   190,   190,   190,
     191,   191,   192,   192,   192,   192,   192,   193,   194,   194,
     195,   195,   195,   196,   197,   197,   197,   197,   197,   198,
     198,   198,   199,   199,   200,   200,   201,   202,   202,   203,
     204,   204,   204,   205,   206,   206,   207,   207,   207,   208,
     209,   209,   209,   210,   211,   211,   212,   212,   212,   212,
     212,   213,   214,   214,   214,   214,   214,   214,   215,   215,
     216,   216,   217,   218,   218,   218,   219,   219,   220,   220,
     220,   220,   220,   220,   221,   222,   221,   221,   223,   221,
     224,   224,   225,   225,   225,   225,   225,   226,   227,   227,
     228,   229,   229,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   231,   232,   233,   234,   234,   235,   235,   236,
     236,   236,   236,   236,   237,   237,   238,   238,   239,   239,
     239,   239,   239,   240,   240,   241,   241,   241,   241,   242,
     242,   242,   243,   243,   244,   244,   244,   244,   244,   244,
     244,   245,   245,   245,   245,   245,   246,   246,   247,   247,
     248,   249,   249,   249,   250,   250,   251,   251,   251,   251,
     251,   252,   253,   253,   253,   253,   254,   255,   255,   256,
     256,   256,   256,   256,   257,   258,   258,   258,   258,   258,
     259,   259,   259,   259,   260,   261,   261,   262,   262,   262,
     263,   263,   263,   264,   264,   264,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   266,   266,   268,   267,   267,
     269,   269,   270,   270,   271,   270,   272,   272,   273,   273,
     274,   275,   275,   276,   276,   276,   276,   276,   276,   277,
     277,   277,   278,   278,   278,   279,   280,   279,   279,   281,
     282,   283,   284,   282,   285,   285,   286,   286,   286,   287,
     287,   287,   287,   288,   288,   289,   290,   290,   291,   290,
     290,   290,   290,   290,   290,   292,   292,   292,   293,   293,
     294,   294,   295,   295,   296,   296,   297,   297,   297,   298,
     298,   298,   299,   299,   299,   299,   299,   299,   300,   300,
     300,   300,   301,   301,   301,   301,   301,   301,   302,   302,
     303,   303,   304,   304,   304,   304,   305,   305,   306,   306,
     307,   307,   307,   307,   308,   309,   310,   310,   311,   312,
     312,   313,   313,   314,   313,   315,   316,   316,   317,   317,
     317,   318,   318,   319,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   320,   318,   321,   322,   318,   323,   324,
     325,   318,   326,   327,   318,   328,   318,   329,   318,   318,
     330,   331,   331,   331,   331,   331,   332,   332,   334,   333,
     335,   335,   336,   336,   337,   337,   338,   338,   338,   338,
     338,   340,   339,   341,   341,   341,   342,   342,   343,   343,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     345,   346,   347,   346,   348,   348,   348,   348,   349,   349,
     349,   349,   350,   350,   350,   351,   351,   352,   352,   353,
     353,   354,   355,   355,   356,   357,   358,   359,   359,   360,
     360,   360,   360,   361,   360,   362,   362,   362,   363,   362,
     364,   364,   364,   364,   364,   364,   365,   365,   365,   365,
     365,   365,   365,   366,   366,   366,   367,   368,   368,   369,
     369,   369,   370,   370,   370,   370,   370,   370,   370,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   370,
     371,   371,   372,   373,   373,   373,   374,   374,   374,   374,
     374,   374,   374,   374,   375,   374,   374,   374,   376,   374,
     374,   374,   374,   374,   374,   377,   378,   378,   379,   379,
     379,   379,   379,   380,   380,   381,   381,   382,   382,   383,
     384,   385,   385,   385,   385,   385,   386,   386,   386,   387,
     387,   388,   388,   389,   389,   389,   389,   389,   390,   390,
     390,   391,   391,   392,   392,   392,   392,   393,   393,   394,
     394,   395,   395,   395,   396,   396,   396,   396,   396,   396,
     396,   397,   397,   397,   397,   397,   397,   398,   398,   398,
     398,   398,   398,   399,   399,   399,   399,   400,   400,   400,
     400,   401,   401,   401,   401,   402,   402,   402,   402,   403,
     403,   403,   403,   403,   403,   403,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   405,
     406,   406,   406,   406,   406,   406,   406,   406,   406,   407,
     408,   408,   408,   409,   410,   410,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   410,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   410,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   410,   410,   410,   410,   410,
     410,   410,   410,   410,   411,   412,   412,   412,   412,   412,
     413,   414,   415,   416,   417,   418,   419,   419,   420,   420,
     420,   421,   421,   422,   422,   423,   423,   424,   425
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     0,     0,     8,     1,     0,     4,
       4,     0,     2,     1,     1,     0,     2,     0,     2,     3,
       1,     2,     2,     0,     4,     2,     0,     0,    12,     1,
       1,     0,     3,     0,     0,     9,     0,     6,     0,     0,
       8,     0,     7,     0,     7,     0,     4,     1,     3,     1,
       2,     0,     2,     1,     1,     1,     0,     2,     1,     0,
       2,     1,     0,     0,     6,     0,     2,     1,     1,     0,
       6,     0,     6,     1,     0,     3,     0,     3,     1,     0,
       4,     1,     1,     3,     1,     1,     3,     3,     3,     2,
       1,     3,     1,     3,     1,     3,     3,     3,     0,     1,
       3,     1,     4,     1,     1,     3,     1,     3,     3,     2,
       3,     3,     1,     3,     1,     2,     0,     0,     3,     2,
       1,     3,     3,     4,     1,     1,     1,     3,     4,     3,
       1,     3,     3,     2,     1,     2,     1,     3,     1,     3,
       3,     2,     1,     3,     1,     3,     3,     2,     1,     1,
       1,     1,     1,     1,     2,     1,     4,     8,     1,     3,
       1,     3,     3,     2,     5,     0,     6,     3,     0,     9,
       3,     3,     1,     3,     3,     3,     2,     3,     1,     2,
       2,     1,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     3,     3,     3,     1,
       3,     1,     3,     3,     1,     1,     3,     3,     1,     3,
       3,     3,     2,     3,     4,     2,     2,     2,     3,     1,
       1,     1,     2,     3,     6,     1,     4,     3,     3,     3,
       1,     1,     3,     3,     2,     1,     1,     1,     1,     3,
       1,     0,     2,     7,     1,     2,     1,     3,     3,     3,
       2,     4,     3,     3,     1,     1,     1,     0,     5,     1,
       3,     3,     1,     2,     5,     1,     3,     3,     3,     2,
       1,     3,     3,     3,     3,     1,     1,     1,     3,     3,
       1,     2,     1,     1,     2,     3,     4,     3,     5,     3,
       3,     1,     2,     1,     1,     1,     2,     0,     8,     1,
       1,     3,     1,     2,     0,     5,     1,     3,     2,     1,
       4,     1,     3,     1,     1,     1,     3,     4,     6,     1,
       1,     1,     1,     2,     2,     1,     0,     3,     2,     3,
       3,     0,     0,     9,     1,     1,     3,     5,     5,     5,
       7,     5,     5,     1,     1,     3,     2,     3,     0,     6,
       6,     6,     3,     2,     2,     1,     3,     3,     1,     1,
       1,     1,     1,     2,     1,     0,     1,     2,     1,     1,
       2,     1,     1,     2,     3,     3,     5,     3,     1,     3,
       3,     3,     3,     4,     4,     3,     3,     5,     1,     1,
       0,     2,     1,     1,     1,     1,     6,     7,     1,     1,
       1,     3,     3,     3,     5,     3,     1,     1,     5,     1,
       3,     0,     1,     0,     4,     0,     1,     1,     1,     2,
       1,     1,     1,     0,     4,     1,     2,     1,     4,     4,
       1,     4,     1,     0,     4,     0,     0,     8,     0,     0,
       0,     9,     0,     0,     8,     0,    11,     0,     9,     2,
       2,     1,     3,     1,     3,     3,     1,     3,     0,     5,
       0,     4,     1,     1,     0,     2,     1,     3,     1,     3,
       3,     0,     6,     1,     1,     1,     1,     2,     1,     1,
       2,     1,     4,     2,     4,     5,     5,     7,     9,    11,
       3,     1,     0,     4,     1,     3,     1,     3,     1,     3,
       3,     3,     1,     3,     5,     0,     1,     1,     1,     1,
       3,     4,     1,     3,     1,     1,     1,     3,     1,     1,
       2,     3,     3,     0,     4,     1,     3,     3,     0,     4,
       1,     3,     3,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     1,     1,     2,     3,     3,
       2,     4,     4,     3,     0,     5,     4,     4,     0,     5,
       4,     4,     2,     4,     5,     3,     1,     1,     2,     3,
       3,     1,     1,     1,     3,     3,     1,     6,     4,     4,
       3,     1,     2,     3,     3,     3,     1,     3,     3,     1,
       1,     3,     1,     1,     3,     1,     3,     3,     1,     1,
       3,     2,     3,     1,     3,     3,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     0,     0,     0,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1
};

/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none). */
static const unsigned char yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     2,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     3,     3,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM. */
static const unsigned char yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error.  */
static const unsigned short int yydefact[] =
{
       8,     0,     0,    47,     0,     3,   787,     7,    29,    30,
       0,   787,   717,   712,   711,   714,   716,   718,   741,   742,
     743,   744,   745,   722,   746,   713,   726,   749,   727,   715,
     750,   751,   728,   752,   753,   755,   754,   756,   757,   758,
     759,   760,   761,   762,   763,   721,   747,   748,   736,   737,
     739,   740,   738,   734,   735,   724,   731,   732,   729,   733,
     730,   770,   787,   709,   710,   720,   723,   725,     0,     1,
       0,     4,     0,    49,     0,   787,     0,     0,    82,     0,
     787,   787,   116,    50,    32,     0,     0,    38,    36,     0,
       0,     0,    85,    10,     9,     0,   314,     0,   311,   315,
     313,   117,    11,     0,    43,   787,     0,    62,   787,   784,
     783,    83,    89,     0,    26,   787,   310,   782,     0,   781,
       0,     0,   119,    17,    62,    39,    41,     0,     0,   116,
      48,    87,    88,    86,   116,   312,   240,   540,   643,   767,
     768,     0,   769,     0,   588,     0,     0,   765,   787,     0,
     574,   543,   544,   549,   545,   550,   641,   642,     0,     0,
       0,     0,   639,   640,     0,     0,   518,   519,   525,   530,
     539,   538,   570,   546,     0,   542,   575,     0,   541,     0,
       0,   576,   764,   766,   316,   764,     0,   120,   787,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    14,   773,
      13,    20,     0,   334,   335,     0,     0,     0,    34,   786,
     785,    37,    56,    51,   577,     0,     0,     0,     0,   573,
       0,   491,     0,     0,   631,   637,     0,   633,   537,   554,
     552,   556,   557,   553,   558,   555,   559,   560,   568,   569,
     561,   562,   563,   564,   565,   566,   567,   551,     0,   317,
     650,   663,   665,   655,   652,   654,   656,   644,   646,   645,
     671,   672,   673,   674,   651,   653,   648,   647,   649,   666,
       0,     0,   523,     0,   667,   659,   660,   669,   661,   662,
     675,   676,   677,   678,   657,   658,   670,     0,   528,     0,
       0,     0,     0,     0,     0,   571,     0,   779,     0,   780,
     778,   580,   584,     0,   592,   520,   536,     0,     0,   118,
     125,   787,   124,   702,   692,   695,   693,   704,   687,   689,
     706,   699,   700,   701,   694,   686,   688,   690,   691,   696,
     698,   705,   703,   787,   708,   707,   361,   360,   697,     0,
       0,     0,   130,   787,   787,   144,   152,     0,   142,   148,
     149,   787,   771,     0,    18,     0,   787,    44,     0,    94,
       0,    92,    98,    62,    59,   773,   572,     0,     0,   498,
     502,   597,   572,   595,     0,     0,   579,     0,     0,     0,
     632,     0,   664,   517,   521,     0,   522,   668,   526,     0,
     527,   535,   194,   195,   534,   531,   532,   533,   578,   625,
       0,   767,   768,   750,   769,   755,   736,   737,   740,   738,
     765,   787,   733,   574,     0,     0,   611,     0,   776,   603,
     601,   602,   606,     0,   623,   628,   766,   583,     0,   496,
     492,     0,   494,     0,   122,   121,     0,     0,   787,   126,
       0,   787,   372,     0,     0,     0,   129,     0,     0,   133,
     134,     0,   365,   147,    19,     0,     0,   336,   411,     6,
      23,     0,     0,    21,   330,   331,   355,    40,     0,     0,
       0,    99,     0,    57,   773,    65,    58,    61,     0,     0,
      54,    45,    52,    53,    55,     0,   590,     0,     0,     0,
     587,     0,     0,   591,   638,   635,   636,   634,   586,   524,
     529,     0,     0,     0,   611,   776,   612,   611,   622,     0,
     616,     0,   625,   611,     0,     0,     0,   582,     0,   598,
       0,     0,     0,   581,     0,     0,     0,   593,   318,     0,
     138,     0,   136,   787,   123,     0,     0,     0,     0,   775,
       0,   373,     0,     0,   378,     0,   389,   388,     0,   366,
       0,   368,   787,   787,   132,   131,   135,   787,     0,     0,
     364,   362,   145,   146,   143,   787,   680,     0,     0,     0,
       0,   682,   681,   438,     0,   442,     0,   505,   684,   685,
     683,     0,   425,   427,   679,   481,     0,     0,   150,   421,
     772,   409,   412,   420,   418,   432,   422,   430,     0,   476,
     787,   764,     0,   299,   774,     0,   295,    90,   155,    22,
     153,   774,   787,   358,     0,   359,     0,     0,     0,     0,
     117,   787,     0,    95,    96,    93,    51,   103,     0,    97,
     101,    35,    60,     0,     0,    67,    68,   787,   787,   117,
       0,   787,   589,   500,   501,   499,   503,   493,   196,     0,
       0,   777,   610,     0,   619,   620,   613,     0,     0,   615,
       0,   614,   630,   604,   599,     0,   600,   629,   626,   627,
     624,   605,   585,   594,   497,   495,     0,     0,     0,   127,
       0,   141,   114,   377,   787,   787,   390,   375,     0,   787,
       0,   374,     0,     0,   788,     0,   338,   369,   371,   367,
     342,   341,   365,   337,   363,   339,     0,     0,   572,   449,
     151,     0,   515,   771,   413,   771,   453,     0,   451,   456,
     516,   506,     0,     0,   426,     0,     0,   477,   450,   411,
       0,   419,   433,     0,     0,   483,   480,   160,     0,   158,
       0,   719,   774,     0,     0,   296,   154,     0,     0,   548,
       0,   547,   346,     0,   353,   354,   356,    15,   345,   357,
     773,   106,     0,   104,   787,   112,     0,     0,     0,     0,
      64,     0,    66,    11,     0,   329,   344,   343,     0,     0,
     608,     0,   618,   617,   621,   630,   128,   139,   140,   137,
     115,   365,   386,     0,   385,     0,   192,     0,     0,   406,
     407,   393,   382,   394,   395,   392,   380,   381,     0,   379,
     390,     0,   370,   193,     0,   435,     0,   478,     0,   479,
     458,   411,   411,     0,     0,   415,     0,     0,     0,   490,
       0,     0,     0,   410,   408,   415,     0,   787,     0,   163,
       0,     0,     0,     0,    91,   773,   773,     0,   514,   348,
     347,   352,    17,    42,     0,     0,   100,     0,   109,     0,
     787,     0,    69,    71,    17,    28,   504,     0,     0,     0,
     391,     0,     0,     0,     0,   376,   384,   383,   340,     0,
     447,     0,   415,     0,   414,   443,   454,   416,   431,   417,
     455,   452,   457,     0,   428,   429,   784,   482,   434,   424,
       0,   484,   161,   162,   159,     0,     0,     0,   172,   167,
     165,   773,   297,   178,     0,     0,   156,     0,     0,   787,
      16,     0,   107,   108,   105,   110,   113,   111,   102,   415,
     415,    74,    76,    81,    78,    46,   776,   607,   387,   405,
       0,   400,     0,   274,     0,   468,     0,   265,   436,     0,
     466,     0,     0,   475,   474,   473,     0,   459,   439,     0,
     486,   787,   485,   171,     0,   176,     0,   170,   773,   787,
     787,   787,   179,     0,   240,   787,   787,     0,     0,     0,
       0,   550,     0,   780,   778,   180,   181,     0,   183,   193,
     187,   204,   205,   188,   189,   190,   225,   186,     0,   764,
       0,   230,     0,     0,     0,     0,     0,     0,     0,   411,
     411,    79,   609,     0,     0,     0,     0,     0,   269,     0,
     471,   460,     0,     0,   465,     0,     0,   771,   445,     0,
     415,     0,   508,   509,     0,   507,   177,   174,   175,   173,
     787,   276,     0,   275,   319,   321,   320,     0,   164,   322,
       0,   325,   787,     0,     0,     0,   238,     0,   222,     0,
       0,     0,     0,     0,   246,   244,   773,   182,   184,   217,
     220,   221,   219,     0,     0,   208,   215,   221,   552,   216,
     191,     0,     0,     0,   185,     0,     0,   787,   349,   350,
     351,   333,    70,    72,    75,    73,    77,   411,   402,   403,
     401,     0,     0,     0,   268,   267,   266,   771,   462,   463,
       0,   771,   469,   470,   467,   272,   273,   271,   415,     0,
     440,   772,   487,   787,     0,     0,   166,   787,   324,   323,
     328,     0,     0,   300,   235,     0,   237,   236,     0,   231,
       0,   773,   223,   229,   773,   228,     0,   250,     0,   242,
     227,   207,   212,     0,   206,     0,   201,     0,   199,     0,
     213,   218,     0,   306,    80,     0,   398,   399,   396,     0,
       0,   415,   437,   411,   772,   771,   772,   444,     0,   510,
       0,     0,     0,   277,   327,   298,   234,     0,     0,   239,
     226,   787,   256,     0,   255,     0,   764,   248,   249,   247,
     210,   211,   209,   214,     0,     0,   197,   198,   157,   404,
     397,   772,   772,   448,   415,   441,   488,     0,   511,     0,
       0,   282,     0,   280,   283,   787,     0,   301,   302,   309,
     233,   232,   773,   251,     0,     0,   202,   203,   200,   307,
     472,   461,   772,     0,   512,   279,   278,   169,   712,   711,
       0,     0,   742,   722,   762,   284,     0,   281,   294,   303,
     308,   224,   262,     0,   259,     0,   252,   253,   446,     0,
     489,   787,   787,   787,   787,   292,   773,   285,   304,   263,
     777,   257,     0,   513,   290,   289,   365,   287,   787,     0,
     261,   260,   243,     0,   241,     0,   286,   305,   241,     0,
     288,     0,   264,   776,   258
};

/* YYPDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     4,     5,    82,   196,     6,   123,   197,   852,   198,
     199,   480,   463,   602,     7,   134,   481,    74,   106,   363,
     107,     8,   105,   206,   127,   207,     9,   124,   640,    10,
      88,    71,   365,   482,   364,   473,   474,   128,   129,   475,
     634,   635,   929,   636,   930,  1094,   934,  1009,   935,  1010,
    1097,    89,  1060,    91,   604,   360,   361,   470,   629,   630,
     762,   763,   764,   681,   101,   122,   102,   186,   187,   311,
     438,   200,   341,   342,   449,   531,   532,   347,   348,   587,
     588,   609,   610,   738,   739,   968,   969,   842,   907,   908,
     912,   913,   985,   986,  1135,   988,   799,   392,  1084,  1157,
    1137,   991,  1074,   992,   993,  1069,  1070,   995,  1138,  1139,
    1055,   164,  1061,  1062,  1063,  1064,  1193,  1194,  1292,  1263,
    1264,   946,   947,   801,  1042,  1182,  1222,  1223,  1257,   605,
     606,   971,  1132,  1227,  1289,  1162,  1228,   972,    97,    98,
    1047,  1048,  1052,  1131,   484,   201,   620,   921,   202,   203,
     204,   775,   464,   621,   917,   465,   622,   333,   558,   559,
     548,   696,   452,   543,   544,   545,   794,   802,   803,  1168,
     940,   941,   804,   805,   589,  1095,   591,   822,   887,   888,
     889,   593,   733,   835,   879,  1021,   713,  1029,  1176,   715,
     959,  1119,   952,   594,   717,   718,   595,   882,  1110,  1111,
     948,   949,   950,  1107,   956,   596,   818,   597,   598,   219,
     220,   431,   368,   369,   722,  1031,  1032,  1033,  1243,   951,
     711,   719,   848,   166,   385,   167,   389,   168,   169,   170,
     171,   750,   172,   247,   173,   174,   175,   176,   428,   216,
     177,   373,   417,   418,   419,   420,   780,   421,   422,   509,
     657,   510,   515,   424,   178,   226,   227,   179,   180,   270,
     271,   287,   272,   288,   273,   289,   600,   336,    92,    63,
     740,    64,    65,    66,   181,   185,   183,   458,   730,   914,
     744,   766,   519,   301,   560,   111,   211,   442,   698
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1126
static const short int yypact[] =
{
     493,  6258,  8052, -1126,   159, -1126,   227, -1126,    83, -1126,
    8052,   173, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126,   173, -1126, -1126, -1126, -1126, -1126,   211, -1126,
     300, -1126,   356, -1126,   310,   384,  8052,   378, -1126,   407,
     227,  7793, -1126, -1126, -1126,  8052,   425, -1126,   346,   450,
      75,   226, -1126, -1126, -1126,   426, -1126,   327, -1126,   422,
   -1126,   494, -1126,   564, -1126,   173,   502, -1126,   227, -1126,
   -1126, -1126,  8052,  6349, -1126,  7793, -1126, -1126,  5391, -1126,
    5391,  8052, -1126,  1152, -1126, -1126, -1126,   518,   483, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126,  8052, -1126,   497, -1126,   508,   520, -1126,   522,   533,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,  5391,  5264,
    5518,   754, -1126, -1126,   548,   535,  1709,  1100,   621,    23,
   -1126, -1126, -1126,   162,   213,   264,   562,   461, -1126,  5518,
    5518, -1126,   523, -1126, -1126, -1126,   115, -1126,   612,  2338,
    8052,  8052,  8052,  8052,  6074,  8052,   689, -1126, -1126, -1126,
   -1126, -1126,   614, -1126, -1126,   483,   502,  7274, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126,  1953,   615,  5391,  1953, -1126,
     618, -1126,  1953,   603, -1126,   639,    97, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,  5391, -1126,
   -1126,   736, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
    5391,  5518, -1126,  5518,   712, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126,  5518, -1126,  5518,
     638,   638,  5518,  5518,  5518, -1126,  8052, -1126,  2718, -1126,
   -1126, -1126,   642,  3265, -1126,  1100, -1126,  5391,  8052,  8052,
   -1126,     8, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126,   651, -1126, -1126, -1126, -1126, -1126,   769,
     778,   429, -1126,   758,    57, -1126, -1126,   440, -1126, -1126,
   -1126,   222, -1126,   483, -1126,   382, -1126, -1126,   483, -1126,
     116, -1126,    -2, -1126,   809,   885,   669,  5391,   120, -1126,
     670,   548,   498, -1126,  3447,   679, -1126,  5391,  5391,  3523,
   -1126,   681, -1126,   861,  1100,  5518,  1100, -1126,   621,  5518,
     621, -1126, -1126,   805, -1126, -1126, -1126, -1126, -1126, -1126,
    4606,   956,  1085,  8136,  1173,  5444,   497,   691,   508,   520,
    1218,   819,   533,  1277,  4407,  2474,    58,   688,   697, -1126,
   -1126, -1126, -1126,    87, -1126, -1126,  1402, -1126,  3447, -1126,
     699,   509, -1126,   705, -1126, -1126,   708,  6440,   758, -1126,
    4801,  4315, -1126,  8052,  8052,  8052, -1126,  8052,  5391, -1126,
   -1126,  8052,   114,  7877, -1126,  6166,  8052, -1126,  5070, -1126,
   -1126,  7319,  7373, -1126, -1126,  1359, -1126, -1126,  8316,  7168,
      27, -1126,   483, -1126, -1126,   795, -1126, -1126,  8052,  8052,
   -1126,   822, -1126, -1126, -1126,   716, -1126,   714,  5391,  3576,
   -1126,  5391,   295, -1126, -1126, -1126, -1126, -1126, -1126,  1100,
     621,   638,   810,   724, -1126,   729, -1126,     0, -1126,   302,
   -1126,   726,   725,   128,   730,   129,  5391, -1126,  2596,   785,
    4606,  2820,  5444, -1126,   295,   735,  3652, -1126, -1126,  6440,
   -1126,   313, -1126,   755, -1126,   738,  8052,  8052,  8052,   367,
     739, -1126,   740,   144, -1126,   817,  8052, -1126,   106, -1126,
    8052, -1126,   651,   651, -1126, -1126, -1126,   651,   106,  8052,
   -1126, -1126, -1126, -1126, -1126,   651, -1126,  5391,  1953,   607,
    5391, -1126, -1126, -1126,  7319, -1126,  3705,   779, -1126, -1126,
   -1126,   744,  5391,   746, -1126,   748,  1953,   747, -1126, -1126,
     750, -1126, -1126, -1126,  1599,   875,   515, -1126,   343,   264,
     522,   767,  7220, -1126,   770,  5801, -1126, -1126, -1126,  8316,
   -1126,    -2,   162, -1126,   775, -1126,  5391,   783,   789,   793,
     494, -1126,   796, -1126, -1126, -1126, -1126, -1126,  6531, -1126,
     777, -1126, -1126,   530,   898,   887, -1126,   651,   651,   494,
     904, -1126, -1126, -1126, -1126, -1126,   804, -1126, -1126,   806,
    5391, -1126, -1126,  4705, -1126, -1126, -1126,  4705,  5444, -1126,
    5391, -1126, -1126, -1126, -1126,  5444, -1126,   827, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126,   352,  8052,  6622, -1126,
    8052, -1126, -1126, -1126,   651,   651,   811, -1126,  1008,  7541,
    5614, -1126,  8052,   812, -1126,   638, -1126, -1126, -1126, -1126,
   -1126, -1126,   114, -1126, -1126, -1126,   900,   277, -1126, -1126,
   -1126,   903, -1126, -1126, -1126, -1126, -1126,    66, -1126,   823,
   -1126, -1126,   829,  5391, -1126,    32,  5391,   264, -1126,  5070,
     925, -1126, -1126,   650,  3318, -1126, -1126, -1126,   157, -1126,
     834, -1126,   835,  8316,   833, -1126, -1126,   836,  5391, -1126,
      13, -1126, -1126,   839, -1126, -1126, -1126, -1126,   470, -1126,
    1165, -1126,   364, -1126,    22,   963,  8052,  6531,   940,   949,
   -1126,   957, -1126, -1126,   483, -1126, -1126,  1359,  5391,  2718,
   -1126,   937, -1126, -1126, -1126,   103, -1126, -1126, -1126, -1126,
   -1126,    81, -1126,  1008, -1126,    50, -1126,   951,   970, -1126,
   -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,   869, -1126,
     811,  1008, -1126, -1126,   106, -1126,  5391, -1126,  5391, -1126,
   -1126,  5070,  5070,  5391,  5391,  5148,  3781,  8052,   162, -1126,
     870,   871,   379, -1126, -1126,  5148,  5391,   522,   295,  8271,
    5710,  6713,    65,    -2, -1126, -1126, -1126,   876, -1126, -1126,
     918,   941,  1349, -1126,  8220,  6804, -1126,  8052, -1126,  8052,
     755,   388, -1126, -1126,  1298, -1126, -1126,   873,   806,   152,
   -1126,   606,  8052,  5391,   877, -1126, -1126, -1126, -1126,  1482,
   -1126,   481,  5148,    37, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126,   657, -1126, -1126,  5391, -1126, -1126, -1126,
      75, -1126, -1126, -1126, -1126,   880,   883,   253, -1126, -1126,
   -1126,   417,   227, -1126,  3029,    42, -1126,  5391,  5391,   162,
   -1126,   689, -1126, -1126, -1126, -1126, -1126, -1126, -1126,  5148,
    5148, -1126, -1126, -1126,   945, -1126,   729, -1126, -1126, -1126,
      59, -1126,   897, -1126,  8052, -1126,   138, -1126, -1126,   524,
   -1126,   305,   987, -1126, -1126, -1126,  5391, -1126, -1126,   990,
   -1126,   162, -1126, -1126,   638,  8052,  6895, -1126, -1126,   962,
     503,   512, -1126,   892,    52,   651,   651,  5983,   984,  3136,
     638,  7457,  2922,  4981,  2211, -1126, -1126,  1891, -1126,   246,
   -1126, -1126, -1126, -1126, -1126, -1126,   548, -1126,   916,   915,
     967, -1126,  5444,   906,   907,   908,   911,   913,   914,  5070,
    5070, -1126, -1126,  8052,  6986,  1005,  8052,   919,  5391,  3834,
   -1126,   319,  5391,  3189, -1126,  5391,  3910, -1126, -1126,  5391,
    5148,   537,   902, -1126,   921, -1126, -1126, -1126, -1126, -1126,
     503, -1126,   981, -1126, -1126, -1126, -1126,  3963, -1126, -1126,
    4039, -1126, -1126,  3394,  5317,  1014, -1126,   552, -1126,  1031,
     931,  1042,  1045,   164, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126,   946,   393, -1126, -1126,   548,   686, -1126,
   -1126,   968,  4092,  5391, -1126,  5391,  7625, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126,   750, -1126,  5070, -1126, -1126,
   -1126,  1041,   950,  1036, -1126, -1126, -1126, -1126, -1126, -1126,
    1050, -1126, -1126, -1126, -1126, -1126, -1126, -1126,  5148,  1054,
   -1126, -1126, -1126,   162,   162,  5391, -1126,   960, -1126, -1126,
   -1126,  5391,   969, -1126, -1126,  5391, -1126, -1126,   118, -1126,
     964, -1126, -1126, -1126, -1126, -1126,  4507,  8052,  4897, -1126,
   -1126, -1126,  8052,  7077, -1126,  5391, -1126,   408, -1126,   965,
   -1126, -1126,   972, -1126,   750,   958, -1126, -1126, -1126,   638,
     638,  5148, -1126,  5070, -1126, -1126, -1126, -1126,   539, -1126,
     971,   505,  5892, -1126, -1126,   510,  5317,  5317,  1059, -1126,
   -1126,   435, -1126,  1063, -1126,   976,  1069, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126,  5391,  4168, -1126, -1126,   276, -1126,
   -1126, -1126,   750, -1126,  5148, -1126, -1126,   162, -1126,   983,
     986, -1126,  1065,  7709, -1126,   162,  5391, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126,  4221,  5317, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126,   525, -1126, -1126, -1126, -1126,  8052,  8052,
    8052,  8052,    56,   300,  5190,   169,   980,   993, -1126,  1027,
   -1126, -1126, -1126,   491, -1126,   215, -1126, -1126, -1126,   162,
   -1126,   651,   651,   651,   651, -1126, -1126, -1126, -1126,  5391,
    5391,   319,   998, -1126, -1126, -1126,    86, -1126,   435,  5391,
   -1126, -1126, -1126,  1000,  7968,    88, -1126, -1126,  7968,   999,
   -1126,  1002, -1126,   729, -1126
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
   -1126, -1126, -1126, -1126, -1126, -1126,   349, -1126, -1126,   279,
   -1126,  -149, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126,   922, -1126,  1055, -1126, -1126,  1058,
    1032,   235,   514, -1126, -1126, -1126, -1126,   -76, -1126, -1126,
     280, -1126, -1126,   513, -1126,   133, -1126, -1126, -1126, -1126,
   -1126,    82,   -66, -1126, -1126, -1126,   234, -1126, -1126, -1126,
     386,  -145,  -445,  -591, -1126,  -144,   -85, -1126,   403, -1126,
   -1126,  -307, -1126,   142,   711,   625,    36, -1126,   143,   587,
    -143, -1126,   550, -1126,  -117, -1126, -1126, -1126, -1126,  -234,
    -745,  -992, -1126,   184,  -668,  -648,  -264, -1126, -1126, -1126,
    -876, -1126, -1126, -1126, -1126,  -919,  -822,   179, -1126,  -991,
   -1126,  -177,  -795, -1126, -1126,  -385, -1126,   -68, -1126, -1126,
    -512, -1125,  -249,  -598, -1126, -1126, -1126, -1126, -1126, -1126,
    -212, -1126, -1126, -1126, -1126, -1126,   -40,    -3, -1126,  1057,
   -1126,  -934, -1126, -1126, -1126,   815, -1126, -1126, -1126,  -341,
   -1126, -1126,   534, -1126, -1126,  -223, -1126, -1126,  -691, -1126,
   -1126,  -550,  -321, -1126,    98, -1126,   366,  -489,    84, -1126,
   -1126,  -557, -1126,   312,  -191,  -452,  -650, -1126,  -535,  -792,
    -416,   592, -1126, -1126, -1126, -1126, -1126, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126, -1126,  -227, -1126, -1126, -1126,   -92,
   -1126, -1126,  -246, -1126, -1126, -1126,   460, -1126, -1126,  -399,
   -1126,  -356,   471,  -449, -1126,    73, -1126,    74, -1126,  -702,
    -769, -1126,   977,   929, -1126,  -123, -1126,  -218,  -158, -1126,
    -584,  -884,  -166, -1126,   372,   634,  -186, -1126, -1126, -1126,
   -1126,   989,  -382, -1126,   685,   694,   341,   695,  -380, -1126,
   -1126,   -86,   926,  -359, -1126, -1126,   436, -1126, -1126, -1126,
   -1126, -1126, -1126, -1126,  1024,  1034, -1126, -1126,   605, -1126,
   -1126,  -540,  -111, -1126, -1126,   948,    -1,  -696,  -856,  -183,
    -543,  -388,  -491,  -587,   -95,  -471,  -190,   140,  -455
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -788
static const short int yytable[] =
{
      67,    67,   228,    72,   120,   353,   590,   295,   703,    67,
      90,   814,   441,   697,   652,   357,   355,   821,   492,   823,
     798,   647,   306,   697,   485,   505,   391,   394,   749,   366,
     457,   525,   372,   514,   508,  1005,   372,  1051,   990,   643,
     645,   371,   592,   898,   212,   371,   847,   812,   205,   213,
     354,   349,   546,   672,   885,   511,   305,   476,   483,  -611,
    1013,   451,   741,  1140,  1076,  1079,   909,   824,   747,   388,
     830,   390,   524,   436,  1150,    67,   109,    72,  -293,   833,
      67,   958,  -787,   871,    67,  -787,   825,  -787,   520,   694,
     957,   293,   994,    77,   338,    70,   362,   117,   378,   849,
     869,   915,   516,   990,  -630,    72,  1126,   694,  -787,  1265,
    -415,    67,    67,   627,    67,  -787,   308,   468,   831,  1186,
      67,   488,   376,  -629,   857,   798,   680,   735,   437,  -629,
     520,   119,   850,   294,   395,   396,   397,  1007,  1008,  1018,
      67,  1002,   671,   798,    79,   689,    73,   628,   384,  1190,
     386,    78,  1191,   694,  1265,  1265,   729,   994,   839,    69,
     516,   668,   670,   459,   117,  1147,   970,  1161,   467,   -31,
    -724,   500,   884,   858,   872,  -293,  1054,   440,  1014,  -611,
     117,  -629,   355,  -611,  1015,   117,  -776,   826,    67,    67,
      67,    67,    67,    67,    67,  1230,  1231,   110,   119,   843,
    -787,   736,    78,  -787,  -787,  -787,    67,  -415,   521,  -787,
     522,   695,   523,   117,   119,    78,  1018,   296,   379,   119,
      73,   100,   380,  1040,  -630,  -415,   456,   112,  -638,   695,
     660,   700,   701,  -787,   309,   469,   702,  -787,  1121,  1187,
    1261,   489,   490,  1188,   705,    78,   987,   119,    73,  -629,
     521,  -629,   522,  -611,   965,   100,   153,  1233,   155,  1019,
    1120,  1020,   499,   690,   878,  1177,   691,   471,  -572,   927,
    1192,  -415,   599,   508,  -415,   695,   840,   508,   784,   697,
      70,   296,   631,  1148,  1288,   505,  -776,   472,   221,   161,
    -724,   355,  -724,    76,   511,    67,   109,   426,   511,   741,
     741,   546,   546,   653,   870,   816,  1025,    67,    67,   297,
     349,   987,   349,   592,   677,    95,   997,   457,  1213,   938,
    1215,   860,   877,  1115,  1117,   632,  1174,  1000,   312,    70,
      80,  1118,  1068,  1108,   697,   749,  1019,   298,  1282,   299,
     300,  1259,   440,   130,   109,   -84,   550,   113,   -84,   -84,
     607,   611,  1226,   677,  1296,  1240,  1241,   362,   362,  1192,
    -572,   897,   714,   791,   792,   854,  1082,   901,  -724,   883,
    1083,  -724,   966,   297,   542,   967,   117,  1034,   838,  1211,
     896,   997,   708,   817,   626,  1109,  1268,  1017,  -572,   854,
    -572,  -572,  1000,   745,  1152,    86,     3,   867,   758,   426,
     727,   298,    67,   299,   300,   592,   592,  1026,   599,  1204,
     119,  1171,   925,   426,   426,  1173,   526,   110,   777,   485,
      81,   654,  1242,   655,   656,   460,  -270,   461,  -270,   962,
     445,   813,   -33,   798,   678,   679,    67,   462,   900,    67,
      67,   453,    67,    67,    67,  1012,    67,   643,   115,   116,
      67,   439,    67,   483,    67,    67,  1098,  1100,  1024,  1001,
      67,    67,   619,   607,   734,   110,  -168,    67,    67,  -724,
      87,  -724,   686,   678,   786,    83,   757,    67,    67,  1214,
     693,  -168,   953,   450,   209,   855,   856,   210,  -724,  -724,
    -724,   742,  1279,    -2,   607,   773,   466,    93,   611,  1299,
     489,   110,   954,  1301,    76,  -776,  1219,  1142,  1044,   855,
     928,   800,   114,  -776,  1153,  1154,   748,   426,   955,   426,
     426,   117,   697,    70,  1001,  1022,    94,   613,    67,  1205,
    1206,     1,  1001,   615,  1045,    67,    67,    67,  -776,  1034,
    1034,  1046,   118,   599,   104,    67,  -776,   768,   446,    67,
     447,   221,   769,   694,   121,   119,    70,  -776,    67,   454,
    1050,   455,   139,    70,   140,     2,  1225,   782,   142,   108,
     221,   783,  1149,    67,  -415,    86,  1044,   355,   450,     3,
     547,   551,   303,   304,   865,  1044,  1226,   554,   126,   555,
    -776,   147,   561,   592,   592,  1295,   562,   886,   564,   891,
    -415,    67,  1045,    61,    67,  -415,    62,    68,    67,  1046,
    1280,  1045,   819,  -776,  -423,    75,   800,   215,  1046,  -596,
    -596,  -423,  1087,   542,   542,  -415,   810,    67,   217,   136,
     526,   527,   844,  1244,   800,   599,   599,   208,   819,   599,
     218,   749,  -492,  1023,   307,  1164,  1269,  1270,  -423,   599,
     989,  -415,   426,   222,  1057,  1058,   426,   249,  -415,  1122,
    1123,  1216,  1217,   139,   139,   140,   140,  1129,   248,   142,
     142,  -415,   290,   682,  -415,   695,    67,    67,   139,    67,
     140,   592,   302,   291,   142,  1283,    99,  -770,    67,    67,
     103,    67,   147,   147,   800,   139,   599,   140,   310,   346,
    1036,   142,   623,   625,    61,    61,   352,   147,  -770,   922,
     924,   434,   435,   787,   789,   989,   813,   131,   133,    61,
      99,  1212,   902,   904,   147,   376,   188,   295,   742,   742,
    1006,  1037,  1039,   356,  -770,   367,    61,   996,   374,  -770,
     221,   377,    67,   599,   599,  1300,   214,   910,   911,   117,
     382,   153,   751,   155,   387,   619,   817,   592,   229,  -770,
     697,   466,  1197,  1199,   427,    67,    67,  1290,  1291,  1104,
    1106,   440,  1281,   443,   619,   906,  1112,  1114,   426,   960,
     961,   466,   444,   119,   161,  -770,   448,   806,   809,  1136,
    1136,   486,  -770,   491,   337,   339,   340,   343,   344,   350,
     351,   493,   996,   498,  1071,  -770,  1077,  1071,  -770,   501,
     996,  -588,  1304,   517,   495,   497,   518,   189,   190,   191,
    -729,  -787,   192,   599,   599,   228,    67,   528,   529,   547,
     547,   -63,   633,   639,   193,   641,   642,  1166,    67,    67,
      67,  -729,   561,   649,   599,   195,   -63,   650,   651,   658,
     659,   665,   230,    67,    67,   661,    67,   673,    67,   680,
     683,   687,   692,   688,   723,   721,   725,  -729,   726,   729,
     728,    67,  -729,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   732,
    -151,   743,  -729,   189,   752,   251,   -27,   767,   192,   906,
     906,   398,   754,   425,   682,  1209,  1210,   -27,   755,  1071,
     478,   599,   756,   188,   188,   759,  -195,  1220,  -729,   501,
     770,   479,  1136,  1136,   771,  -729,   774,   778,   252,   516,
     779,   561,   599,   815,   793,   811,   253,  -195,  -729,  -492,
    -729,  -729,  -729,    67,  -729,   820,   827,   834,  -195,   828,
    1284,  1285,  1286,  1287,   841,  -720,   845,  -726,   851,   846,
     862,   254,   255,  -195,    67,    67,   256,   859,  -195,   863,
     868,  1266,   260,   261,   262,   263,    67,   221,  -726,   769,
      67,   426,   426,    67,   873,   599,   874,   599,  -195,   264,
     265,   875,   894,   895,   918,   916,   269,   919,   936,  1016,
     682,   944,   963,  1011,  -726,   503,   964,  1027,   214,  -726,
    1030,  1041,    67,    67,  -195,    67,  1053,  1066,  1085,   425,
     425,  -195,  1086,  1124,   795,  1088,  1089,  1090,   599,  -726,
    1091,   136,  1092,  1093,  -195,  -195,  -195,  -195,  1101,  -195,
    -195,  1125,   533,   796,  1103,  1127,   549,  1141,   552,   553,
     343,   797,   343,  1143,  1144,  -726,   557,  1165,   350,   751,
     350,   565,  -726,  1146,  1145,   139,   182,   140,  1151,  1170,
    1155,   142,  1172,  1169,  1175,  -726,   796,  -726,  -726,  -726,
    1181,  -726,   872,   637,   638,    67,  -727,  1247,  1185,  1189,
    1207,  1208,  1232,  1218,   147,   165,  1234,   184,   139,  1235,
     140,  1035,  -254,  1276,   142,  1245,    61,  -727,  1246,  1043,
    1049,  1049,  1277,  1278,  1056,   274,   292,  1065,  1294,   275,
    1298,  1302,   864,   425,  1303,   425,   425,   147,   358,    84,
     276,   920,    85,  -727,   533,   223,   225,   125,  -727,    61,
     760,   684,   685,  1096,   933,   426,    67,    67,   772,   534,
     277,    67,    67,   861,   676,   699,   709,  1256,  -727,   746,
     189,   190,   191,  1067,   704,   192,  1080,  1267,  1239,    -5,
     278,   279,   135,   189,  -728,   776,   876,   193,   192,   477,
    1049,   194,  1229,   939,  -727,  1167,   731,   853,   195,  1293,
     478,  -727,  1133,   836,   370,  -728,  1178,   832,  1179,   383,
     893,   479,   707,   663,  -727,  1229,  -727,  -727,  -727,   937,
    -727,   375,   664,   334,   666,   280,   281,   282,   283,  -724,
    1258,  -728,    67,   335,   423,   381,  -728,  1163,     0,     0,
     284,   285,     0,   765,     0,     0,   286,     0,   393,   393,
    -724,     0,     0,     0,     0,     0,  -728,    67,    67,    67,
      67,     0,     0,     0,     0,     0,     0,     0,   425,     0,
       0,     0,   425,  1035,     0,     0,  -724,  1183,     0,     0,
       0,  -724,  -728,     0,     0,   416,     0,     0,  -574,  -728,
     432,     0,   533,   533,   433,   790,     0,     0,     0,     0,
       0,  -724,  -728,    67,  -728,  -728,  -728,    67,  -728,  -730,
       0,     0,     0,     0,     0,     0,   189,   190,   191,     0,
     931,   192,     0,     0,     0,   932,     0,  -724,     0,     0,
     -65,     0,  1224,   193,  -724,  -730,     0,   194,     0,     0,
    -730,  1049,     0,     0,   195,   633,   292,  -724,   292,  -724,
    -724,  -724,     0,  -724,   487,     0,     0,     0,     0,     0,
    -730,   432,     0,     0,   494,   225,   225,   189,   190,   191,
       0,     0,     0,     0,     0,   751,  -332,     0,     0,     0,
       0,   765,   765,     0,   193,     0,  -730,   502,   194,     0,
       0,     0,   504,  -730,   425,   195,     0,     0,     0,     0,
       0,   507,   513,     0,     0,     0,  -574,     0,  -574,  -574,
    -574,     0,  -574,  -725,     0,   432,   601,     0,     0,     0,
       0,     0,    70,     0,     0,   612,   613,     0,   614,     0,
       0,     0,   615,     0,  -725,   556,   561,     0,  1049,     0,
       0,     0,   892,     0,  1065,   616,   617,   618,  1065,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   292,   648,
    -725,     0,     0,     0,     0,  -725,     0,     0,     0,   765,
     765,     0,   765,     0,   926,   370,   370,     0,   646,     0,
       0,     0,     0,     0,     0,  -725,     0,   942,     0,     0,
       0,     0,     0,   945,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   662,     0,   416,  -464,   667,   667,   504,
       0,  -725,     0,   675,  -464,   136,     0,     0,  -725,     0,
       0,     0,     0,   137,   138,     0,     0,   710,     0,     0,
       0,  -725,     0,  -725,  -725,  -725,     0,  -725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   139,
       0,   140,     0,   141,   706,   142,     0,   712,  -464,   942,
       0,     0,     0,   720,     0,     0,     0,     0,     0,   724,
       0,   143,   144,     0,   145,   146,     0,     0,   147,     0,
       0,   148,   149,   150,   151,   152,   153,   154,   155,     0,
      61,     0,   156,   157,     0,     0,  1072,  1075,  1072,  1072,
       0,     0,     0,   753,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,   159,     0,   160,   161,
     162,   163,     0,     0,   566,     0,   352,   567,   942,   942,
       0,  1102,   136,   568,     0,   569,   570,   781,     0,     0,
     416,   571,     0,   572,   416,   504,   393,   785,     0,   573,
       0,     0,   504,   393,     0,   575,   576,     0,     0,     0,
       0,   577,     0,     0,     0,     0,   139,     0,   140,     0,
     141,     0,   142,     0,     0,     0,     0,     0,     0,   578,
     579,     0,     0,     0,   580,     0,     0,   601,   143,   144,
     581,   145,   146,   582,   583,   147,   584,   585,   148,   149,
     150,  1072,     0,     0,     0,     0,     0,    61,     0,     0,
     829,     0,     0,   370,     0,     0,     0,     0,     0,     0,
       0,   432,     0,     0,     0,     0,     0,     0,     0,   158,
       0,     0,     0,     0,     0,   586,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   250,     0,     0,
       0,   393,     0,   251,     0,     0,     0,     0,     0,     0,
       0,  1195,     0,     0,     0,   866,   416,  1200,  1202,   393,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   601,
     601,     0,     0,   601,     0,     0,   252,     0,     0,     0,
       0,     0,     0,   601,   253,     0,     0,     0,     0,     0,
       0,     0,     0,   880,     0,   881,     0,     0,     0,     0,
     712,   720,     0,   720,     0,     0,     0,     0,     0,   254,
     255,     0,     0,   899,   256,     0,   257,   258,   259,   393,
     260,   261,   262,   263,     0,     0,     0,     0,     0,     0,
     601,     0,     0,     0,     0,     0,     0,   264,   265,     0,
       0,   266,   267,   268,   269,     0,     0,     0,     0,     0,
     943,     0,     0,  1271,  1272,  1273,  1274,     0,     0,     0,
       0,     0,   999,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   370,     0,     0,     0,   601,   601,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   998,   694,     0,  1003,  1004,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   973,     0,     0,
       0,     0,   393,     0,   974,     0,     0,     0,     0,     0,
       0,     0,   137,   138,     0,     0,     0,   999,   393,     0,
     977,     0,   978,  1028,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   139,     0,
     140,     0,   141,     0,   142,     0,   998,   601,   601,   223,
       0,     0,     0,     0,  1081,     0,     0,     0,     0,     0,
     143,   144,     0,   145,   146,     0,   136,   147,   601,   504,
     148,   149,   150,   151,   152,   153,   154,   155,     0,    61,
       0,   156,   157,     0,     0,     0,     0,     0,     0,     0,
       0,   999,   999,     0,     0,     0,   712,     0,     0,     0,
     139,   158,   140,     0,   141,   159,   142,   160,   161,   162,
     163,     0,     0,     0,   504,     0,     0,     0,     0,     0,
     998,   998,   143,   144,     0,   145,   146,     0,     0,   147,
       0,     0,   148,   149,   150,   601,     0,     0,     0,   393,
       0,    61,     0,     0,     0,     0,     0,     0,     0,  1158,
    1159,     0,  1160,     0,     0,     0,   601,     0,     0,     0,
       0,     0,     0,   158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1196,     0,     0,     0,     0,     0,
       0,     0,  1180,     0,     0,     0,     0,     0,  1184,     0,
       0,     0,  1081,     0,     0,     0,     0,   393,   393,   601,
       0,   601,     0,   998,     0,     0,     0,     0,     0,   393,
       0,     0,  1203,     0,   999,   999,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   601,   998,   998,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1236,  1238,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1260,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,   229,     0,     0,     0,    12,
      13,    14,    15,    16,    17,     0,     0,     0,     0,     0,
       0,  1275,     0,     0,   136,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,    21,    22,    23,    24,  1297,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,     0,     0,     0,     0,     0,     0,  1078,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    12,    13,    14,    15,
      16,    17,     0,   313,     0,     0,     0,   314,     0,     0,
       0,     0,     0,     0,     0,     0,   315,     0,   316,     0,
       0,     0,   317,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
       0,     0,     0,     0,     0,     0,    61,   117,   318,   319,
       0,     0,     0,   320,     0,   321,   322,   323,   324,   260,
     261,   262,   263,   280,   281,   282,   283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   325,   326,   327,   328,
     329,   119,   330,   331,   332,   512,     0,     0,     0,     0,
       0,     0,    12,    13,    14,    15,    16,    17,     0,     0,
       0,     0,   400,     0,     0,     0,     0,   136,     0,     0,
       0,     0,     0,     0,     0,   137,   138,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,   401,    27,   402,    29,   403,    31,   404,    33,    34,
     405,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,   406,   407,    50,   408,   409,    53,    54,
     410,    56,    57,   411,   412,   413,   151,   152,   153,   154,
     155,     0,    61,     0,   156,   157,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   414,     0,     0,   399,   415,   224,
     160,   161,   162,   163,    12,    13,    14,    15,    16,    17,
       0,     0,     0,     0,   400,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,     0,   137,   138,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,   401,    27,   402,    29,   403,    31,   404,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,   406,   407,    50,   408,   409,
      53,    54,   410,    56,    57,   411,   412,   413,   151,   152,
     153,   154,   155,     0,    61,     0,   156,   157,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   414,     0,     0,   399,
     415,  -777,   160,   161,   162,   163,    12,    13,    14,    15,
      16,    17,     0,     0,     0,     0,   400,     0,     0,     0,
       0,   136,     0,     0,     0,     0,     0,     0,     0,   137,
     138,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,   401,    27,   402,    29,   403,
      31,   404,    33,    34,   405,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,   406,   407,    50,
     408,   409,    53,    54,   410,    56,    57,   411,   412,   413,
     151,   152,   153,   154,   155,     0,    61,     0,   156,   157,
       0,   669,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,     0,     0,     0,     0,   414,     0,
       0,     0,   415,   136,   160,   161,   162,   163,     0,     0,
       0,   137,   138,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,   401,    27,   402,
      29,   403,    31,   404,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,   406,
     407,    50,   408,   409,    53,    54,   410,    56,    57,   411,
     412,   413,   151,   152,   153,   154,   155,     0,    61,     0,
     156,   157,     0,  1073,     0,     0,     0,     0,     0,     0,
      12,    13,    14,    15,    16,    17,     0,     0,     0,     0,
     158,     0,     0,     0,   159,   136,   160,   161,   162,   163,
       0,     0,     0,   137,   138,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,   401,
      27,   402,    29,   403,    31,   404,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,   406,   407,    50,   408,   409,    53,    54,   410,    56,
      57,   411,   412,   413,   151,   152,   153,   154,   155,     0,
      61,     0,   156,   157,     0,     0,     0,     0,     0,     0,
     694,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,   973,   159,     0,   160,   161,
     162,   163,   974,     0,   975,     0,     0,     0,     0,     0,
     137,   138,     0,     0,   796,   976,     0,     0,   977,     0,
     978,     0,   797,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   979,     0,     0,   139,     0,   140,     0,
     141,     0,   142,     0,     0,     0,     0,     0,   980,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
       0,   145,   146,     0,     0,   147,     0,     0,   148,   149,
     150,   151,   152,   153,   154,   981,     0,    61,     0,   156,
     157,     0,     0,     0,     0,     0,     0,   694,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   982,
       0,     0,   973,   159,     0,   983,   984,   162,   163,   974,
       0,   975,     0,     0,     0,     0,     0,   137,   138,     0,
       0,   796,   976,     0,     0,   977,     0,   978,     0,   797,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1113,     0,     0,   139,     0,   140,     0,   141,     0,   142,
       0,     0,     0,  -777,     0,   980,     0,     0,     0,     0,
       0,  -777,   136,     0,     0,   143,   144,     0,   145,   146,
     137,   138,   147,     0,     0,   148,   149,   150,   151,   152,
     153,   154,   981,     0,    61,     0,   156,   157,     0,     0,
       0,     0,     0,     0,     0,     0,   139,     0,   140,     0,
     141,     0,   142,     0,     0,  -777,   982,     0,     0,     0,
     159,     0,   983,   984,   162,   163,   429,     0,   143,   144,
       0,   145,   146,     0,     0,   147,     0,     0,   148,   149,
     150,   151,   152,   153,   154,   155,     0,    61,   136,   156,
     157,     0,     0,     0,     0,     0,   137,   138,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   158,
       0,     0,     0,   159,     0,   160,   161,   162,   163,   429,
       0,     0,   139,     0,   140,     0,   141,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   136,     0,     0,   143,   144,     0,   145,   146,   137,
     138,   147,     0,     0,   148,   149,   150,   151,   152,   153,
     154,   155,   430,    61,     0,   156,   157,     0,     0,     0,
       0,     0,     0,     0,     0,   139,     0,   140,     0,   141,
       0,   142,     0,     0,     0,   158,     0,     0,     0,   159,
       0,   160,   161,   162,   163,  1134,     0,   143,   144,     0,
     145,   146,     0,     0,   147,     0,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   837,    61,   136,   156,   157,
       0,     0,     0,     0,     0,   137,   138,     0,     0,   796,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
       0,     0,   159,     0,   160,   161,   162,   163,   429,     0,
       0,   139,     0,   140,     0,   141,     0,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     136,     0,     0,   143,   144,     0,   145,   146,   137,   138,
     147,     0,     0,   148,   149,   150,   151,   152,   153,   154,
     155,     0,    61,     0,   156,   157,     0,     0,     0,     0,
       0,     0,     0,     0,   139,     0,   140,     0,   141,     0,
     142,     0,     0,     0,   982,     0,     0,     0,   159,     0,
     160,   161,   162,   163,   496,     0,   143,   144,     0,   145,
     146,     0,     0,   147,     0,     0,   148,   149,   150,   151,
     152,   153,   154,   155,     0,    61,   136,   156,   157,     0,
       0,     0,     0,     0,   137,   138,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   158,     0,     0,
       0,   159,     0,   160,   161,   162,   163,   644,     0,     0,
     139,     0,   140,     0,   141,     0,   142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   136,
       0,     0,   143,   144,     0,   145,   146,   137,   138,   147,
       0,     0,   148,   149,   150,   151,   152,   153,   154,   155,
       0,    61,     0,   156,   157,     0,     0,     0,     0,     0,
       0,     0,     0,   139,     0,   140,     0,   141,     0,   142,
       0,     0,     0,   158,     0,     0,     0,   159,     0,   160,
     161,   162,   163,   674,     0,   143,   144,     0,   145,   146,
       0,     0,   147,     0,     0,   148,   149,   150,   151,   152,
     153,   154,   155,     0,    61,   136,   156,   157,     0,     0,
       0,     0,     0,   137,   138,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   158,     0,     0,     0,
     159,     0,   160,   161,   162,   163,   716,     0,     0,   139,
       0,   140,     0,   141,     0,   142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   136,     0,
       0,   143,   144,     0,   145,   146,   137,   138,   147,     0,
       0,   148,   149,   150,   151,   152,   153,   154,   155,     0,
      61,     0,   156,   157,     0,     0,     0,     0,     0,     0,
       0,     0,   139,     0,   140,     0,   141,     0,   142,     0,
       0,     0,   158,     0,     0,     0,   159,     0,   160,   161,
     162,   163,   890,     0,   143,   144,     0,   145,   146,     0,
       0,   147,     0,     0,   148,   149,   150,   151,   152,   153,
     154,   155,     0,    61,   136,   156,   157,     0,     0,     0,
       0,     0,   137,   138,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   158,     0,     0,     0,   159,
       0,   160,   161,   162,   163,  1105,     0,     0,   139,     0,
     140,     0,   141,     0,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   136,     0,     0,
     143,   144,     0,   145,   146,   137,   138,   147,     0,     0,
     148,   149,   150,   151,   152,   153,   154,   155,     0,    61,
       0,   156,   157,     0,     0,     0,     0,     0,     0,     0,
       0,   139,     0,   140,     0,   141,     0,   142,     0,     0,
       0,   158,     0,     0,     0,   159,     0,   160,   161,   162,
     163,  1116,     0,   143,   144,     0,   145,   146,     0,     0,
     147,     0,     0,   148,   149,   150,   151,   152,   153,   154,
     155,     0,    61,   136,   156,   157,     0,     0,     0,     0,
       0,   137,   138,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   158,     0,     0,     0,   159,     0,
     160,   161,   162,   163,  1128,     0,     0,   139,     0,   140,
       0,   141,     0,   142,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   136,     0,     0,   143,
     144,     0,   145,   146,   137,   138,   147,     0,     0,   148,
     149,   150,   151,   152,   153,   154,   155,     0,    61,     0,
     156,   157,     0,     0,     0,     0,     0,     0,     0,     0,
     139,     0,   140,     0,   141,     0,   142,     0,     0,     0,
     158,     0,     0,     0,   159,     0,   160,   161,   162,   163,
    1130,     0,   143,   144,     0,   145,   146,     0,     0,   147,
       0,     0,   148,   149,   150,   151,   152,   153,   154,   155,
       0,    61,  -326,   156,   157,     0,     0,     0,     0,     0,
    -326,  -326,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   414,     0,     0,     0,   415,     0,   160,
     161,   162,   163,  1156,     0,     0,  -326,     0,  -326,     0,
    -326,     0,  -326,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   136,     0,     0,  -326,  -326,
       0,  -326,  -326,   137,   138,  -326,     0,     0,  -326,  -326,
    -326,  -326,  -326,  -326,  -326,  -326,     0,  -326,     0,  -326,
    -326,     0,     0,     0,     0,     0,     0,     0,     0,   139,
       0,   140,     0,   141,     0,   142,     0,     0,     0,  -326,
       0,     0,     0,  -326,     0,  -326,  -326,  -326,  -326,  1237,
       0,   143,   144,     0,   145,   146,     0,     0,   147,     0,
       0,   148,   149,   150,   151,   152,   153,   154,   155,     0,
      61,   136,   156,   157,     0,     0,     0,     0,     0,   137,
     138,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,   159,     0,   160,   161,
     162,   163,  1262,     0,     0,   139,     0,   140,     0,   141,
       0,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   136,     0,     0,   143,   144,     0,
     145,   146,   137,   138,   147,     0,     0,   148,   149,   150,
     151,   152,   153,   154,   155,     0,    61,     0,   156,   157,
       0,     0,     0,     0,     0,     0,     0,     0,   139,     0,
     140,     0,   141,     0,   142,     0,     0,     0,   158,     0,
       0,     0,   159,     0,   160,   161,   162,   163,     0,     0,
     143,   144,     0,   145,   146,     0,     0,   147,     0,     0,
     148,   149,   150,   151,   152,   153,   154,   155,     0,    61,
       0,   156,   157,    12,    13,    14,    15,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   158,     0,     0,     0,   159,     0,   160,   161,   162,
     163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,     0,     0,     0,
       0,     0,     0,    61,   117,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     136,     0,     0,     0,     0,     0,     0,     0,   137,   138,
       0,     0,     0,     0,     0,     0,     0,     0,   119,     0,
       0,     0,     0,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,   401,    27,   402,    29,   403,    31,
     404,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,   406,   407,    50,   408,
     409,    53,    54,   410,    56,    57,   411,   412,   413,   151,
     152,   153,   154,   155,     0,    61,     0,   156,   157,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,     0,     0,   414,     0,   506,
     136,   415,     0,   160,   161,   162,   163,     0,   137,   138,
       0,     0,   796,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,   401,    27,   402,    29,   403,    31,
     404,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,   406,   407,    50,   408,
     409,    53,    54,   410,    56,    57,   411,   412,   413,   151,
     152,   153,   154,   155,     0,    61,     0,   156,   157,     0,
       0,     0,     0,     0,    12,    13,    14,    15,    16,    17,
       0,     0,     0,     0,     0,     0,     0,   982,     0,   136,
       0,   159,     0,   160,   161,   162,   163,   137,   138,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,   401,    27,   402,    29,   403,    31,   404,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,   406,   407,    50,   408,   409,
      53,    54,   410,    56,    57,   411,   412,   413,   151,   152,
     153,   154,   155,     0,    61,     0,   156,   157,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,     0,
       0,     0,     0,     0,     0,     0,   158,     0,   136,     0,
     159,     0,   160,   161,   162,   163,   137,   138,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,   401,    27,   402,    29,   403,    31,   404,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,   406,   407,    50,   408,   409,    53,
      54,   410,    56,    57,   411,   412,   413,   151,   152,   153,
     154,   155,   535,    61,     0,   156,   157,     0,     0,    12,
      13,    14,    15,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   414,   536,     0,     0,   415,
       0,   160,   161,   162,   163,     0,     0,   537,     0,     0,
       0,     0,     0,     0,     0,     0,  -787,     0,     0,    18,
      19,    20,    21,    22,    23,    24,   538,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   539,    56,    57,
      58,    59,    60,     0,     0,     0,     0,     0,  1198,    61,
       0,     0,     0,     0,   540,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,  -245,     0,     0,     0,  -777,
       0,     0,     0,   541,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    12,
      13,    14,    15,    16,    17,    61,     0,     0,     0,     0,
       0,     0,     0,     0,   136,     0,   975,     0,     0,     0,
       0,     0,   137,   138,     0,     0,     0,   976,     0,  -777,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,   401,    27,
     402,    29,   403,    31,   404,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
     406,   407,    50,   408,   409,    53,    54,   410,    56,    57,
     411,   412,   413,   151,   152,   153,   154,   155,     0,    61,
       0,   156,   157,     0,     0,   566,     0,   352,   567,     0,
       0,     0,     0,   136,   568,     0,   569,   570,     0,     0,
       0,   158,   571,     0,   572,   159,     0,   160,   161,     0,
     573,     0,     0,     0,     0,   574,   575,   576,     0,     0,
       0,     0,   577,     0,     0,     0,     0,   139,     0,   140,
       0,   141,     0,   142,     0,     0,     0,     0,     0,     0,
     578,   579,     0,     0,     0,   580,     0,     0,     0,   143,
     144,   581,   145,   146,   582,   583,   147,   584,   585,   148,
     149,   150,   346,   566,     0,   352,   567,     0,    61,     0,
       0,   136,   568,     0,   569,   570,     0,     0,     0,     0,
     571,     0,   572,     0,     0,     0,     0,     0,   573,     0,
     158,     0,     0,     0,   575,   576,   586,     0,     0,     0,
     577,     0,     0,     0,     0,   139,     0,   140,     0,   141,
       0,   142,  -291,   136,     0,     0,     0,     0,   578,   579,
       0,   137,   138,   580,     0,     0,     0,   143,   144,   581,
     145,   146,   582,   583,   147,   584,   585,   148,   149,   150,
     346,     0,     0,     0,     0,     0,    61,   139,     0,   140,
       0,   141,     0,   142,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,   143,
     144,     0,   145,   146,   586,     0,   147,     0,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   136,    61,     0,
     156,   157,     0,     0,     0,   137,   138,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -291,
     158,     0,     0,     0,   159,     0,   160,   161,   162,   163,
       0,   139,     0,   140,     0,   141,     0,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     136,     0,     0,   143,   144,     0,   145,   146,   137,   138,
     147,     0,   796,   148,   149,   150,   151,   152,   153,   154,
     155,     0,    61,     0,   156,   157,     0,     0,     0,     0,
       0,     0,     0,     0,   139,     0,   140,     0,   141,     0,
     142,     0,     0,     0,   158,     0,     0,     0,   159,   224,
     160,   161,   162,   163,     0,     0,   143,   144,     0,   145,
     146,     0,     0,   147,     0,     0,   148,   149,   150,   151,
     152,   153,   154,   155,   136,    61,     0,   156,   157,     0,
       0,     0,   137,   138,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   982,     0,     0,
       0,   159,     0,   160,   161,   162,   163,     0,   139,     0,
     140,     0,   141,     0,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   136,     0,     0,
     143,   144,     0,   145,   146,   137,   138,   147,     0,     0,
     148,   149,   150,   151,   152,   153,   154,   155,     0,    61,
       0,   156,   157,     0,     0,     0,     0,     0,     0,     0,
       0,   139,     0,   140,     0,   141,     0,   142,     0,     0,
       0,   158,     0,     0,     0,   159,     0,   160,   161,   162,
     163,     0,     0,   143,   144,     0,   145,   146,     0,     0,
     147,     0,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   136,    61,     0,   156,   157,     0,     0,     0,   137,
     138,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   414,     0,     0,     0,   415,     0,
     160,   161,   162,   163,     0,   139,     0,   140,     0,   141,
       0,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,     0,
     145,   146,     0,     0,   147,     0,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   807,    61,     0,   156,   157,
       0,     0,    12,    13,    14,    15,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,   536,
       0,     0,   159,     0,   160,   161,     0,     0,     0,     0,
     537,     0,     0,     0,     0,     0,     0,     0,     0,  -787,
       0,     0,    18,    19,    20,    21,    22,    23,    24,   538,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     539,    56,    57,    58,    59,    60,     0,     0,     0,     0,
       0,   903,    61,     0,     0,     0,     0,   808,   -24,   -24,
     -24,   -24,   -24,   -24,     0,     0,     0,   -24,     0,     0,
       0,     0,   -24,     0,     0,   -24,     0,     0,     0,   -24,
       0,     0,     0,     0,     0,     0,   -24,   -24,     0,     0,
       0,     0,     0,   -24,     0,   -24,     0,     0,    18,    19,
      20,    21,    22,    23,    24,   -24,     0,    26,    27,    28,
       0,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,   603,     0,     0,     0,     0,     0,    61,   -25,
     -25,   -25,   -25,   -25,   -25,     0,     0,     0,   -25,     0,
       0,     0,     0,   -25,     0,     0,   -25,     0,     0,     0,
     -25,     0,     0,     0,     0,     0,     0,   -25,   -25,     0,
       0,     0,     0,     0,   -25,     0,   -25,     0,     0,    18,
      19,    20,    21,    22,     0,    24,   -25,     0,    26,    27,
      28,     0,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,     0,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,  1221,     0,     0,     0,     0,     0,    61,
    -787,  -787,  -787,  -787,  -787,  -787,     0,     0,     0,     0,
       0,     0,     0,     0,  -787,     0,     0,  -787,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -787,  -787,  -787,  -787,  -787,  -787,  -787,     0,  -787,  -787,
    -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,
    -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,
    -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,  -787,
    -787,  -787,  -787,  -787,  1059,     0,     0,     0,     0,     0,
    -787,    12,    13,    14,    15,    16,    17,     0,     0,     0,
       0,  -787,     0,     0,     0,  -241,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,   345,     0,     0,     0,     0,
       0,    61,    12,    13,    14,    15,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,   346,   563,     0,     0,
       0,     0,    61,     0,    12,    13,    14,    15,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,   346,    11,
       0,     0,     0,     0,    61,     0,    12,    13,    14,    15,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     132,     0,     0,     0,     0,     0,    61,    12,    13,    14,
      15,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,   530,     0,     0,     0,     0,     0,    61,    12,    13,
      14,    15,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,   761,     0,     0,     0,     0,     0,    61,    12,
      13,    14,    15,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   539,    56,    57,
      58,    59,    60,   788,     0,     0,     0,     0,     0,    61,
      12,    13,    14,    15,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,   905,     0,     0,     0,     0,     0,
      61,    12,    13,    14,    15,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,   923,     0,     0,     0,     0,
       0,    61,    12,    13,    14,    15,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     539,    56,    57,    58,    59,    60,  1038,     0,     0,     0,
       0,     0,    61,    12,    13,    14,    15,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,  1099,     0,     0,
       0,     0,     0,    61,    12,    13,    14,    15,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,  1201,     0,
       0,     0,     0,     0,    61,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   624,
       0,     0,     0,     0,     0,    61,  -116,     0,     0,     0,
       0,  -116,     0,     0,     0,     0,     0,     0,     0,     0,
    -116,     0,     0,  -116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -116,     0,     0,     0,     0,     0,
       0,  -116,     0,  -116,     0,     0,    18,    19,    20,    21,
      22,   737,    24,  -116,     0,    26,    27,    28,  -116,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,     0,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
       0,     0,     0,     0,     0,     0,    61,     0,    18,    19,
      20,    21,    22,    23,    24,   359,     0,    26,    27,    28,
       0,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,     0,     0,     0,     0,     0,     0,    61,     0,
     603,     0,    18,    19,    20,    21,    22,     0,    24,     0,
       0,    26,    27,    28,     0,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
       0,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,     0,    18,    19,    20,
      21,    22,    61,    24,   608,     0,    26,    27,    28,     0,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,     0,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,     0,     0,     0,     0,     0,     0,    61,     0,     0,
       0,    18,    19,    20,    21,    22,     0,    24,     0,     0,
      26,    27,    28,     0,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,     0,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    12,    13,    14,    15,    16,
      17,    61,     0,     0,     0,     0,     0,     0,     0,     0,
     136,     0,   975,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    19,    20,    21,    22,
      23,    24,  -779,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    12,
      13,    14,    15,    16,    17,    61,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   536,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   537,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,    21,    22,    23,    24,   538,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   539,    56,    57,
      58,    59,    60,    12,    13,    14,    15,    16,    17,    61,
       0,     0,     0,     0,     0,     0,     0,     0,   136,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    12,  1248,  1249,
      15,    16,    17,    61,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1250,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1251,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,  1252,    20,
      21,    22,  1253,    24,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,  1254,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,  1255,    56,    57,    58,    59,
      60,    12,    13,    14,    15,    16,    17,    61,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,    19,    20,    21,    22,    23,    24,    96,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    12,    13,    14,    15,    16,
      17,    61,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   346,
       0,     0,     0,     0,     0,    61,    12,    13,    14,    15,
      16,    17,     0,     0,     0,     0,  -787,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      12,    13,    14,    15,    16,    17,    61,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    12,    13,    14,    15,    16,    17,
      61,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    12,    13,
      14,    15,    16,    17,    61,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,   539,    56,    57,    58,
      59,    60,     0,     0,     0,     0,     0,     0,    61,    18,
      19,    20,    21,    22,    23,    24,     0,     0,    26,    27,
      28,     0,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,     0,    18,    19,    20,    21,    22,    61,
      24,     0,     0,    26,    27,    28,     0,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,     0,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,     0,     0,
       0,     0,     0,     0,    61
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const unsigned char yyconflp[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   107,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    97,     0,     0,     0,     0,     0,     0,    99,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    81,
       0,     0,     0,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   101,
       0,     0,     0,   103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,     0,
      59,    61,    63,     0,    65,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   137,     0,     0,     0,   139,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     3,     0,     5,     7,     9,
       0,    11,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    15,     0,    17,    19,    21,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    67,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,     0,    35,    37,    39,     0,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,     0,    47,
      49,    51,     0,    53,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,     0,    71,    73,
      75,     0,    77,    85,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,    89,    91,    93,     0,    95,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   111,   113,     0,
       0,     0,     0,     0,   115,     0,   117,     0,     0,   119,
     121,     0,     0,     0,   123,   125,     0,   127,   129,     0,
       0,     0,   131,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,     0,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short int yyconfl[] =
{
       0,   767,     0,   767,     0,   767,     0,   767,     0,   767,
       0,   767,     0,   768,     0,   768,     0,   768,     0,   768,
       0,   768,     0,   768,     0,   750,     0,   750,     0,   750,
       0,   769,     0,   769,     0,   769,     0,   769,     0,   769,
       0,   769,     0,   765,     0,   765,     0,   765,     0,   765,
       0,   765,     0,   765,     0,   787,     0,   787,     0,   787,
       0,   787,     0,   787,     0,   787,     0,   730,     0,   730,
       0,   730,     0,   730,     0,   730,     0,   730,     0,   629,
       0,   629,     0,   629,     0,   766,     0,   766,     0,   766,
       0,   766,     0,   766,     0,   766,     0,   611,     0,   637,
       0,   637,     0,   637,     0,   777,     0,   638,     0,   638,
       0,   550,     0,   550,     0,   550,     0,   550,     0,   550,
       0,   550,     0,   550,     0,   550,     0,   550,     0,   550,
       0,   550,     0,   550,     0,   550,     0,   764,     0,   764,
       0
};

static const short int yycheck[] =
{
       1,     2,   160,     6,    99,   196,   458,   173,   558,    10,
      76,   702,   333,   548,   505,   205,   199,   713,   374,   715,
     688,   492,   180,   558,   365,   405,   290,   291,   612,   215,
     351,   430,   218,   415,   414,   919,   222,   971,   914,   488,
     489,   218,   458,   835,   129,   222,   748,   695,   124,   134,
     199,   194,   440,   524,   823,   414,   179,   364,   365,     1,
       1,     4,   602,  1054,   983,   984,     1,     1,   611,   287,
      38,   289,   428,    65,  1066,    76,     1,    80,    22,   729,
      81,    44,     1,    33,    85,    33,    20,     1,     1,     1,
     882,    68,   914,    11,   189,    53,   207,    99,     1,    86,
     791,   846,   102,   979,     1,   108,  1040,     1,    22,  1234,
      22,   112,   113,    86,   115,     1,     1,     1,    86,     1,
     121,     1,   122,   123,   102,   793,   104,   598,   120,     1,
       1,   133,   119,   110,   292,   293,   294,   929,   930,     1,
     141,    99,   522,   811,    62,     1,     6,   120,   271,  1141,
     273,    11,  1144,     1,  1279,  1280,   119,   979,     1,     0,
     102,   520,   521,   353,    99,     1,   911,  1086,   358,    86,
       1,   389,   822,   764,   124,   119,   124,   120,   119,   121,
      99,   123,   365,   125,   125,    99,    22,   121,   189,   190,
     191,   192,   193,   194,   195,  1186,  1187,   122,   133,   742,
     119,   600,    62,   122,   123,   119,   207,   119,   121,   123,
     123,   123,   125,    99,   133,    75,     1,     4,   121,   133,
      80,    81,   125,   968,   121,   119,     4,     1,   125,   123,
     102,   552,   553,   119,   119,   119,   557,   123,  1030,   121,
    1232,   121,   122,   125,   565,   105,   914,   133,   108,   121,
     121,   123,   123,   125,     1,   115,    94,  1191,    96,   121,
    1029,   123,   385,   119,   814,  1121,   122,   362,     4,   860,
    1146,   119,   458,   653,   122,   123,   119,   657,   658,   814,
      53,     4,   472,   119,  1276,   665,   122,   363,   148,   127,
     121,   474,   123,   120,   653,   296,     1,   298,   657,   839,
     840,   689,   690,     1,   793,    28,     1,   308,   309,    96,
     453,   979,   455,   729,     1,    80,   914,   638,  1174,   869,
    1176,   766,   811,  1025,  1026,   474,  1118,   914,   188,    53,
     119,  1027,   980,    14,   869,   919,   121,   124,   123,   126,
     127,  1225,   120,   108,     1,   119,   441,   121,   122,   123,
     461,   462,    76,     1,  1288,  1211,  1212,   468,   469,  1235,
      96,   832,   574,   684,   685,     1,   120,   838,     1,   821,
     124,     4,   119,    96,   440,   122,    99,   961,   734,  1171,
       1,   979,   568,   106,   469,    66,  1242,   944,   124,     1,
     126,   127,   979,   605,     1,    11,    86,   779,   621,   400,
     586,   124,   403,   126,   127,   821,   822,   102,   594,     1,
     133,  1107,   857,   414,   415,  1111,   121,   122,   641,   760,
     120,   119,  1214,   121,   122,    43,   121,    45,   123,   900,
       1,   695,    86,  1101,   121,   122,   437,    55,   837,   440,
     441,     1,   443,   444,   445,   936,   447,   896,   121,   122,
     451,   311,   453,   760,   455,   456,  1013,  1014,   949,   914,
     461,   462,   465,   574,   121,   122,    49,   468,   469,   102,
      86,   104,   538,   121,   122,   119,   620,   478,   479,  1175,
     546,    64,     1,   343,     1,   121,   122,     4,   121,   122,
     123,   602,     1,     0,   605,   639,   356,   119,   609,  1294,
     121,   122,    21,  1298,   120,    14,     1,  1057,    73,   121,
     122,   688,    86,    22,   121,   122,   611,   518,    37,   520,
     521,    99,  1057,    53,   979,     1,   119,    57,   529,   121,
     122,    38,   987,    63,    99,   536,   537,   538,    14,  1123,
    1124,   106,   120,   729,   119,   546,    22,    17,   119,   550,
     121,   411,    22,     1,    60,   133,    53,    66,   559,   119,
      48,   121,    57,    53,    59,    72,    56,   653,    63,   119,
     430,   657,  1063,   574,    22,    11,    73,   760,   438,    86,
     440,   441,   121,   122,   774,    73,    76,   445,    86,   447,
      66,    86,   452,  1009,  1010,  1286,   453,   824,   455,   826,
      48,   602,    99,    98,   605,    53,     1,     2,   609,   106,
     119,    99,   707,   122,    99,    10,   793,   120,   106,   121,
     122,   106,  1002,   689,   690,    73,   692,   628,   120,    23,
     121,   122,   743,  1217,   811,   821,   822,   119,   733,   825,
     120,  1225,   120,   119,   121,  1097,   121,   122,   133,   835,
     914,    99,   653,   120,   975,   976,   657,   122,   106,   122,
     123,   122,   123,    57,    57,    59,    59,  1047,   120,    63,
      63,   119,    51,   533,   122,   123,   677,   678,    57,   680,
      59,  1097,   120,    62,    63,  1269,    81,     1,   689,   690,
      85,   692,    86,    86,   871,    57,   882,    59,    86,    92,
     964,    63,   468,   469,    98,    98,    17,    86,    22,   854,
     855,   308,   309,   677,   678,   979,   980,   112,   113,    98,
     115,  1173,   839,   840,    86,   122,   121,   893,   839,   840,
     921,   965,   966,   119,    48,   120,    98,   914,   120,    53,
     600,   102,   743,   929,   930,  1295,   141,   842,   843,    99,
      14,    94,   612,    96,    42,   758,   106,  1173,     4,    73,
    1295,   621,  1147,  1148,   122,   766,   767,  1279,  1280,  1018,
    1019,   120,  1263,     4,   777,   841,  1022,  1023,   779,   122,
     123,   641,     4,   133,   127,    99,    28,   689,   690,  1053,
    1054,   122,   106,   123,   189,   190,   191,   192,   193,   194,
     195,   122,   979,   122,   981,   119,   983,   984,   122,     4,
     987,   120,  1303,   125,   378,   379,   119,     8,     9,    10,
       1,   122,    13,  1009,  1010,   983,   827,   122,   120,   689,
     690,    22,    37,    11,    25,   119,   122,  1101,   839,   840,
     841,    22,   702,    33,  1030,    36,    37,   123,   119,   123,
     125,    66,    98,   854,   855,   125,   857,   122,   859,   104,
     122,   122,    45,   123,   120,    86,   120,    48,   120,   119,
     123,   872,    53,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,    14,
     123,   121,    73,     8,   119,    34,    11,   120,    13,   965,
     966,   296,   119,   298,   764,  1169,  1170,    22,   119,  1086,
      25,  1097,   119,   308,   309,   119,     1,  1181,    99,     4,
      22,    36,  1186,  1187,    37,   106,    22,   123,    67,   102,
     124,   791,  1118,    33,   123,   123,    75,    22,   119,   120,
     121,   122,   123,   944,   125,    42,   123,    22,    33,   120,
    1271,  1272,  1273,  1274,   120,   120,   123,     1,   119,   123,
      20,   100,   101,    48,   965,   966,   105,     4,    53,    20,
      33,  1235,   111,   112,   113,   114,   977,   837,    22,    22,
     981,   982,   983,   984,    33,  1171,    16,  1173,    73,   128,
     129,   122,   122,   122,    76,   119,   135,    56,   125,   102,
     860,   124,   122,    58,    48,   400,   123,    20,   403,    53,
      20,    49,  1013,  1014,    99,  1016,   124,    33,   102,   414,
     415,   106,    55,   121,    16,   119,   119,   119,  1214,    73,
     119,    23,   119,   119,   119,   120,   121,   122,    33,   124,
     125,   120,   437,    35,   125,    64,   441,    33,   443,   444,
     445,    43,   447,    22,   123,    99,   451,    16,   453,   919,
     455,   456,   106,    18,    22,    57,   118,    59,   122,    33,
     102,    63,    22,   123,    20,   119,    35,   121,   122,   123,
     120,   125,   124,   478,   479,  1086,     1,    22,   119,   125,
     125,   119,    33,   122,    86,   118,    33,   120,    57,   123,
      59,   961,    33,   123,    63,   122,    98,    22,   122,   969,
     970,   971,   119,    86,   974,    15,   168,   977,   120,    19,
     120,   122,   773,   518,   122,   520,   521,    86,   206,    74,
      30,   852,    74,    48,   529,   158,   159,   105,    53,    98,
     626,   536,   537,  1010,   864,  1146,  1147,  1148,   635,   438,
      50,  1152,  1153,   767,   529,   550,   569,  1223,    73,   609,
       8,     9,    10,   979,   559,    13,   987,  1235,  1208,    17,
      70,    71,   115,     8,     1,   641,   810,    25,    13,   364,
    1040,    29,  1185,   871,    99,  1101,   594,    22,    36,  1281,
      25,   106,  1052,   733,   217,    22,  1123,   726,  1124,   270,
     828,    36,   568,   518,   119,  1208,   121,   122,   123,   868,
     125,   222,   518,   189,   519,   115,   116,   117,   118,     1,
    1223,    48,  1223,   189,   298,   248,    53,  1087,    -1,    -1,
     130,   131,    -1,   628,    -1,    -1,   136,    -1,   290,   291,
      22,    -1,    -1,    -1,    -1,    -1,    73,  1248,  1249,  1250,
    1251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   653,    -1,
      -1,    -1,   657,  1123,    -1,    -1,    48,  1127,    -1,    -1,
      -1,    53,    99,    -1,    -1,   298,    -1,    -1,     1,   106,
     303,    -1,   677,   678,   307,   680,    -1,    -1,    -1,    -1,
      -1,    73,   119,  1294,   121,   122,   123,  1298,   125,    22,
      -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    17,    -1,    99,    -1,    -1,
      22,    -1,  1182,    25,   106,    48,    -1,    29,    -1,    -1,
      53,  1191,    -1,    -1,    36,    37,   388,   119,   390,   121,
     122,   123,    -1,   125,   367,    -1,    -1,    -1,    -1,    -1,
      73,   374,    -1,    -1,   377,   378,   379,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,  1225,    17,    -1,    -1,    -1,
      -1,   766,   767,    -1,    25,    -1,    99,   400,    29,    -1,
      -1,    -1,   405,   106,   779,    36,    -1,    -1,    -1,    -1,
      -1,   414,   415,    -1,    -1,    -1,   119,    -1,   121,   122,
     123,    -1,   125,     1,    -1,   428,   458,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    -1,    56,    57,    -1,    59,    -1,
      -1,    -1,    63,    -1,    22,   448,  1286,    -1,  1288,    -1,
      -1,    -1,   827,    -1,  1294,    76,    77,    78,  1298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   500,   501,
      48,    -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,   854,
     855,    -1,   857,    -1,   859,   488,   489,    -1,   491,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,   872,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   516,    -1,   518,    14,   520,   521,   522,
      -1,    99,    -1,   526,    22,    23,    -1,    -1,   106,    -1,
      -1,    -1,    -1,    31,    32,    -1,    -1,   569,    -1,    -1,
      -1,   119,    -1,   121,   122,   123,    -1,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    59,    -1,    61,   567,    63,    -1,   570,    66,   944,
      -1,    -1,    -1,   576,    -1,    -1,    -1,    -1,    -1,   582,
      -1,    79,    80,    -1,    82,    83,    -1,    -1,    86,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    -1,   100,   101,    -1,    -1,   981,   982,   983,   984,
      -1,    -1,    -1,   616,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,   127,
     128,   129,    -1,    -1,    15,    -1,    17,    18,  1013,  1014,
      -1,  1016,    23,    24,    -1,    26,    27,   650,    -1,    -1,
     653,    32,    -1,    34,   657,   658,   688,   660,    -1,    40,
      -1,    -1,   665,   695,    -1,    46,    47,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    57,    -1,    59,    -1,
      61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      71,    -1,    -1,    -1,    75,    -1,    -1,   729,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,  1086,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
     723,    -1,    -1,   726,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   734,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,   793,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1146,    -1,    -1,    -1,   778,   779,  1152,  1153,   811,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   821,
     822,    -1,    -1,   825,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,   835,    75,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   816,    -1,   818,    -1,    -1,    -1,    -1,
     823,   824,    -1,   826,    -1,    -1,    -1,    -1,    -1,   100,
     101,    -1,    -1,   836,   105,    -1,   107,   108,   109,   871,
     111,   112,   113,   114,    -1,    -1,    -1,    -1,    -1,    -1,
     882,    -1,    -1,    -1,    -1,    -1,    -1,   128,   129,    -1,
      -1,   132,   133,   134,   135,    -1,    -1,    -1,    -1,    -1,
     873,    -1,    -1,  1248,  1249,  1250,  1251,    -1,    -1,    -1,
      -1,    -1,   914,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   896,    -1,    -1,    -1,   929,   930,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   914,     1,    -1,   917,   918,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,
      -1,    -1,   964,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    32,    -1,    -1,    -1,   979,   980,    -1,
      39,    -1,    41,   956,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      59,    -1,    61,    -1,    63,    -1,   979,  1009,  1010,   982,
      -1,    -1,    -1,    -1,   987,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    82,    83,    -1,    23,    86,  1030,  1002,
      89,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1053,  1054,    -1,    -1,    -1,  1029,    -1,    -1,    -1,
      57,   120,    59,    -1,    61,   124,    63,   126,   127,   128,
     129,    -1,    -1,    -1,  1047,    -1,    -1,    -1,    -1,    -1,
    1053,  1054,    79,    80,    -1,    82,    83,    -1,    -1,    86,
      -1,    -1,    89,    90,    91,  1097,    -1,    -1,    -1,  1101,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1082,
    1083,    -1,  1085,    -1,    -1,    -1,  1118,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,    -1,  1131,    -1,
      -1,    -1,  1135,    -1,    -1,    -1,    -1,  1169,  1170,  1171,
      -1,  1173,    -1,  1146,    -1,    -1,    -1,    -1,    -1,  1181,
      -1,    -1,  1155,    -1,  1186,  1187,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1214,  1186,  1187,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1204,  1205,  1235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1226,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1235,    -1,    -1,     4,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,  1254,    -1,    -1,    23,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,  1289,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,     8,     9,    10,    11,
      12,    13,    -1,    15,    -1,    -1,    -1,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   128,   129,   130,   131,
     132,   133,   134,   135,   136,     1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    98,    -1,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,     1,   124,   125,
     126,   127,   128,   129,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    -1,    98,    -1,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,     1,
     124,   125,   126,   127,   128,   129,     8,     9,    10,    11,
      12,    13,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    -1,    98,    -1,   100,   101,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,   124,    23,   126,   127,   128,   129,    -1,    -1,
      -1,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    -1,    98,    -1,
     100,   101,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
     120,    -1,    -1,    -1,   124,    23,   126,   127,   128,   129,
      -1,    -1,    -1,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,    -1,    16,   124,    -1,   126,   127,
     128,   129,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      31,    32,    -1,    -1,    35,    36,    -1,    -1,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    57,    -1,    59,    -1,
      61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    82,    83,    -1,    -1,    86,    -1,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    -1,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    16,   124,    -1,   126,   127,   128,   129,    23,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    31,    32,    -1,
      -1,    35,    36,    -1,    -1,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    57,    -1,    59,    -1,    61,    -1,    63,
      -1,    -1,    -1,    14,    -1,    69,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    79,    80,    -1,    82,    83,
      31,    32,    86,    -1,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    -1,    98,    -1,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    59,    -1,
      61,    -1,    63,    -1,    -1,    66,   120,    -1,    -1,    -1,
     124,    -1,   126,   127,   128,   129,     1,    -1,    79,    80,
      -1,    82,    83,    -1,    -1,    86,    -1,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    23,   100,
     101,    -1,    -1,    -1,    -1,    -1,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,   124,    -1,   126,   127,   128,   129,     1,
      -1,    -1,    57,    -1,    59,    -1,    61,    -1,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,    79,    80,    -1,    82,    83,    31,
      32,    86,    -1,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    59,    -1,    61,
      -1,    63,    -1,    -1,    -1,   120,    -1,    -1,    -1,   124,
      -1,   126,   127,   128,   129,     1,    -1,    79,    80,    -1,
      82,    83,    -1,    -1,    86,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    23,   100,   101,
      -1,    -1,    -1,    -1,    -1,    31,    32,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,   124,    -1,   126,   127,   128,   129,     1,    -1,
      -1,    57,    -1,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    79,    80,    -1,    82,    83,    31,    32,
      86,    -1,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    98,    -1,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    59,    -1,    61,    -1,
      63,    -1,    -1,    -1,   120,    -1,    -1,    -1,   124,    -1,
     126,   127,   128,   129,     1,    -1,    79,    80,    -1,    82,
      83,    -1,    -1,    86,    -1,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    -1,    98,    23,   100,   101,    -1,
      -1,    -1,    -1,    -1,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,   124,    -1,   126,   127,   128,   129,     1,    -1,    -1,
      57,    -1,    59,    -1,    61,    -1,    63,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      -1,    -1,    79,    80,    -1,    82,    83,    31,    32,    86,
      -1,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      -1,    98,    -1,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    -1,    59,    -1,    61,    -1,    63,
      -1,    -1,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,
     127,   128,   129,     1,    -1,    79,    80,    -1,    82,    83,
      -1,    -1,    86,    -1,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    -1,    98,    23,   100,   101,    -1,    -1,
      -1,    -1,    -1,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,
     124,    -1,   126,   127,   128,   129,     1,    -1,    -1,    57,
      -1,    59,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,
      -1,    79,    80,    -1,    82,    83,    31,    32,    86,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    -1,    59,    -1,    61,    -1,    63,    -1,
      -1,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,   127,
     128,   129,     1,    -1,    79,    80,    -1,    82,    83,    -1,
      -1,    86,    -1,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    23,   100,   101,    -1,    -1,    -1,
      -1,    -1,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,   124,
      -1,   126,   127,   128,   129,     1,    -1,    -1,    57,    -1,
      59,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      79,    80,    -1,    82,    83,    31,    32,    86,    -1,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    -1,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,   120,    -1,    -1,    -1,   124,    -1,   126,   127,   128,
     129,     1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,
      86,    -1,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    98,    23,   100,   101,    -1,    -1,    -1,    -1,
      -1,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,   124,    -1,
     126,   127,   128,   129,     1,    -1,    -1,    57,    -1,    59,
      -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    79,
      80,    -1,    82,    83,    31,    32,    86,    -1,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    -1,    98,    -1,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    -1,    59,    -1,    61,    -1,    63,    -1,    -1,    -1,
     120,    -1,    -1,    -1,   124,    -1,   126,   127,   128,   129,
       1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,    86,
      -1,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      -1,    98,    23,   100,   101,    -1,    -1,    -1,    -1,    -1,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,
     127,   128,   129,     1,    -1,    -1,    57,    -1,    59,    -1,
      61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    79,    80,
      -1,    82,    83,    31,    32,    86,    -1,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    -1,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    59,    -1,    61,    -1,    63,    -1,    -1,    -1,   120,
      -1,    -1,    -1,   124,    -1,   126,   127,   128,   129,     1,
      -1,    79,    80,    -1,    82,    83,    -1,    -1,    86,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    23,   100,   101,    -1,    -1,    -1,    -1,    -1,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,   127,
     128,   129,     1,    -1,    -1,    57,    -1,    59,    -1,    61,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,    79,    80,    -1,
      82,    83,    31,    32,    86,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    -1,    98,    -1,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      59,    -1,    61,    -1,    63,    -1,    -1,    -1,   120,    -1,
      -1,    -1,   124,    -1,   126,   127,   128,   129,    -1,    -1,
      79,    80,    -1,    82,    83,    -1,    -1,    86,    -1,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,    -1,    -1,   124,    -1,   126,   127,   128,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    99,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    -1,    98,    -1,   100,   101,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      23,   124,    -1,   126,   127,   128,   129,    -1,    31,    32,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    -1,    98,    -1,   100,   101,    -1,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    23,
      -1,   124,    -1,   126,   127,   128,   129,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    -1,    98,    -1,   100,   101,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    23,    -1,
     124,    -1,   126,   127,   128,   129,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,     1,    98,    -1,   100,   101,    -1,    -1,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    25,    -1,    -1,   124,
      -1,   126,   127,   128,   129,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    -1,    -1,    -1,    -1,     1,    98,
      -1,    -1,    -1,    -1,   103,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    22,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,     8,
       9,    10,    11,    12,    13,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    31,    32,    -1,    -1,    -1,    36,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,    -1,    -1,    15,    -1,    17,    18,    -1,
      -1,    -1,    -1,    23,    24,    -1,    26,    27,    -1,    -1,
      -1,   120,    32,    -1,    34,   124,    -1,   126,   127,    -1,
      40,    -1,    -1,    -1,    -1,    45,    46,    47,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    57,    -1,    59,
      -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    71,    -1,    -1,    -1,    75,    -1,    -1,    -1,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    15,    -1,    17,    18,    -1,    98,    -1,
      -1,    23,    24,    -1,    26,    27,    -1,    -1,    -1,    -1,
      32,    -1,    34,    -1,    -1,    -1,    -1,    -1,    40,    -1,
     120,    -1,    -1,    -1,    46,    47,   126,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    57,    -1,    59,    -1,    61,
      -1,    63,    22,    23,    -1,    -1,    -1,    -1,    70,    71,
      -1,    31,    32,    75,    -1,    -1,    -1,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    98,    57,    -1,    59,
      -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    79,
      80,    -1,    82,    83,   126,    -1,    86,    -1,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    23,    98,    -1,
     100,   101,    -1,    -1,    -1,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
     120,    -1,    -1,    -1,   124,    -1,   126,   127,   128,   129,
      -1,    57,    -1,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    79,    80,    -1,    82,    83,    31,    32,
      86,    -1,    35,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    98,    -1,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    59,    -1,    61,    -1,
      63,    -1,    -1,    -1,   120,    -1,    -1,    -1,   124,   125,
     126,   127,   128,   129,    -1,    -1,    79,    80,    -1,    82,
      83,    -1,    -1,    86,    -1,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    23,    98,    -1,   100,   101,    -1,
      -1,    -1,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,   124,    -1,   126,   127,   128,   129,    -1,    57,    -1,
      59,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      79,    80,    -1,    82,    83,    31,    32,    86,    -1,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    -1,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,   120,    -1,    -1,    -1,   124,    -1,   126,   127,   128,
     129,    -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,
      86,    -1,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    23,    98,    -1,   100,   101,    -1,    -1,    -1,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,   124,    -1,
     126,   127,   128,   129,    -1,    57,    -1,    59,    -1,    61,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      82,    83,    -1,    -1,    86,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,     1,    98,    -1,   100,   101,
      -1,    -1,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    25,
      -1,    -1,   124,    -1,   126,   127,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    -1,    -1,    -1,
      -1,     1,    98,    -1,    -1,    -1,    -1,   103,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    25,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    45,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,     1,    -1,    -1,    -1,    -1,    -1,    98,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    17,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    25,    -1,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    45,    -1,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    -1,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,     1,    -1,    -1,    -1,    -1,    -1,    98,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,     1,    -1,    -1,    -1,    -1,    -1,
      98,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,     1,    -1,    -1,    -1,    -1,
      -1,    98,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     1,    -1,    -1,
      -1,    -1,    98,    -1,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,     1,
      -1,    -1,    -1,    -1,    98,    -1,     8,     9,    10,    11,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
       1,    -1,    -1,    -1,    -1,    -1,    98,     8,     9,    10,
      11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,     1,    -1,    -1,    -1,    -1,    -1,    98,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,     1,    -1,    -1,    -1,    -1,    -1,    98,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,     1,    -1,    -1,    -1,    -1,    -1,    98,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,     1,    -1,    -1,    -1,    -1,    -1,
      98,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,     1,    -1,    -1,    -1,    -1,
      -1,    98,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,     1,    -1,    -1,    -1,
      -1,    -1,    98,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,     1,    -1,    -1,
      -1,    -1,    -1,    98,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,     1,    -1,
      -1,    -1,    -1,    -1,    98,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,     1,
      -1,    -1,    -1,    -1,    -1,    98,     8,    -1,    -1,    -1,
      -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    45,    -1,    -1,    48,    49,    50,    51,
      52,     1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    48,    49,
      50,    51,    52,    53,    54,     1,    -1,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
       1,    -1,    48,    49,    50,    51,    52,    -1,    54,    -1,
      -1,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    48,    49,    50,
      51,    52,    98,    54,     1,    -1,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    -1,    54,    -1,    -1,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,     8,     9,    10,    11,    12,
      13,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,     8,
       9,    10,    11,    12,    13,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,     8,     9,    10,    11,    12,    13,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,     8,     9,    10,
      11,    12,    13,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,     8,     9,    10,    11,    12,    13,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,     8,     9,    10,    11,    12,
      13,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    98,     8,     9,    10,    11,
      12,    13,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
       8,     9,    10,    11,    12,    13,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,     8,     9,    10,    11,    12,    13,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,     8,     9,
      10,    11,    12,    13,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    -1,    -1,    -1,    98,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    48,    49,    50,    51,    52,    98,
      54,    -1,    -1,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    -1,
      -1,    -1,    -1,    -1,    98
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,    38,    72,    86,   138,   139,   142,   151,   158,   163,
     166,     1,     8,     9,    10,    11,    12,    13,    48,    49,
      50,    51,    52,    53,    54,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    98,   405,   406,   408,   409,   410,   413,   405,     0,
      53,   168,   274,   424,   154,   405,   120,   188,   424,   188,
     119,   120,   140,   119,   163,   166,    11,    86,   167,   188,
     189,   190,   405,   119,   119,   168,    55,   275,   276,   405,
     424,   201,   203,   405,   119,   159,   155,   157,   119,     1,
     122,   422,     1,   121,    86,   121,   122,    99,   120,   133,
     421,    60,   202,   143,   164,   167,    86,   161,   174,   175,
     168,   405,     1,   405,   152,   276,    23,    31,    32,    57,
      59,    61,    63,    79,    80,    82,    83,    86,    89,    90,
      91,    92,    93,    94,    95,    96,   100,   101,   120,   124,
     126,   127,   128,   129,   248,   359,   360,   362,   364,   365,
     366,   367,   369,   371,   372,   373,   374,   377,   391,   394,
     395,   411,   412,   413,   359,   412,   204,   205,   405,     8,
       9,    10,    13,    25,    29,    36,   141,   144,   146,   147,
     208,   282,   285,   286,   287,   174,   160,   162,   119,     1,
       4,   423,   203,   203,   405,   120,   376,   120,   120,   346,
     347,   424,   120,   359,   125,   359,   392,   393,   365,     4,
      98,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   370,   120,   122,
      28,    34,    67,    75,   100,   101,   105,   107,   108,   109,
     111,   112,   113,   114,   128,   129,   132,   133,   134,   135,
     396,   397,   399,   401,    15,    19,    30,    50,    70,    71,
     115,   116,   117,   118,   130,   131,   136,   398,   400,   402,
      51,    62,   412,    68,   110,   369,     4,    96,   124,   126,
     127,   420,   120,   121,   122,   362,   365,   121,     1,   119,
      86,   206,   424,    15,    19,    28,    30,    34,   100,   101,
     105,   107,   108,   109,   110,   128,   129,   130,   131,   132,
     134,   135,   136,   294,   401,   402,   404,   405,   421,   405,
     405,   209,   210,   405,   405,     1,    92,   214,   215,   217,
     405,   405,    17,   311,   148,   416,   119,   423,   161,     1,
     192,   193,   409,   156,   171,   169,   373,   120,   349,   350,
     359,   248,   373,   378,   120,   378,   122,   102,     1,   121,
     125,   359,    14,   360,   362,   361,   362,    42,   364,   363,
     364,   233,   234,   412,   233,   365,   365,   365,   405,     1,
      18,    57,    59,    61,    63,    66,    79,    80,    82,    83,
      86,    89,    90,    91,   120,   124,   359,   379,   380,   381,
     382,   384,   385,   389,   390,   405,   413,   122,   375,     1,
      97,   348,   359,   359,   205,   205,    65,   120,   207,   424,
     120,   299,   424,     4,     4,     1,   119,   121,    28,   211,
     424,     4,   299,     1,   119,   121,     4,   299,   414,   423,
      43,    45,    55,   149,   289,   292,   424,   423,     1,   119,
     194,   421,   174,   172,   173,   176,   208,   282,    25,    36,
     148,   153,   170,   208,   281,   286,   122,   359,     1,   121,
     122,   123,   348,   122,   359,   393,     1,   393,   122,   362,
     364,     4,   359,   405,   359,   385,   122,   359,   385,   386,
     388,   390,     1,   359,   379,   389,   102,   125,   119,   419,
       1,   121,   123,   125,   348,   346,   121,   122,   122,   120,
       1,   212,   213,   405,   211,     1,    25,    36,    55,    86,
     103,   122,   189,   300,   301,   302,   418,   424,   297,   405,
     421,   424,   405,   405,   210,   210,   359,   405,   295,   296,
     421,   424,   215,     1,   215,   405,    15,    18,    24,    26,
      27,    32,    34,    40,    45,    46,    47,    52,    70,    71,
      75,    81,    84,    85,    87,    88,   126,   216,   217,   311,
     312,   313,   317,   318,   330,   333,   342,   344,   345,   373,
     403,   412,   150,     1,   191,   266,   267,   409,     1,   218,
     219,   409,    56,    57,    59,    63,    76,    77,    78,   274,
     283,   290,   293,   193,     1,   193,   203,    86,   120,   195,
     196,   423,   148,    37,   177,   178,   180,   405,   405,    11,
     165,   119,   122,   350,     1,   350,   359,   422,   412,    33,
     123,   119,   419,     1,   119,   121,   122,   387,   123,   125,
     102,   125,   359,   381,   382,    66,   384,   359,   390,     1,
     390,   385,   422,   122,     1,   359,   212,     1,   121,   122,
     104,   200,   424,   122,   405,   405,   189,   122,   123,     1,
     119,   122,    45,   189,     1,   123,   298,   315,   425,   405,
     299,   299,   299,   298,   405,   299,   359,   372,   373,   216,
     412,   357,   359,   323,   267,   326,     1,   331,   332,   358,
     359,    86,   351,   120,   359,   120,   120,   373,   123,   119,
     415,   318,    14,   319,   121,   422,   346,     1,   220,   221,
     407,   408,   409,   121,   417,   267,   219,   417,   421,   367,
     368,   424,   119,   359,   119,   119,   119,   202,   292,   119,
     169,     1,   197,   198,   199,   405,   418,   120,    17,    22,
      22,    37,   180,   202,    22,   288,   289,   292,   123,   124,
     383,   359,   388,   388,   385,   359,   122,   213,     1,   213,
     405,   299,   299,   123,   303,    16,    35,    43,   231,   233,
     248,   260,   304,   305,   309,   310,   301,     1,   103,   301,
     189,   123,   232,   233,   295,    33,    28,   106,   343,   421,
      42,   414,   314,   414,     1,    20,   121,   123,   120,   359,
      38,    86,   349,   313,    22,   320,   343,    97,   348,     1,
     119,   120,   224,   417,   409,   123,   123,   356,   359,    86,
     119,   119,   145,    22,     1,   121,   122,   102,   200,     4,
     199,   197,    20,    20,   143,   423,   359,   379,    33,   295,
     304,    33,   124,    33,    16,   122,   303,   304,   298,   321,
     359,   359,   334,   312,   313,   357,   332,   315,   316,   317,
       1,   332,   405,   371,   122,   122,     1,   422,   316,   359,
     346,   422,   221,     1,   221,     1,   189,   225,   226,     1,
     421,   421,   227,   228,   416,   227,   119,   291,    76,    56,
     146,   284,   198,     1,   198,   199,   405,   200,   122,   179,
     181,    12,    17,   177,   183,   185,   125,   383,   298,   310,
     307,   308,   405,   359,   124,     1,   258,   259,   337,   338,
     339,   356,   329,     1,    21,    37,   341,   316,    44,   327,
     122,   123,   422,   122,   123,     1,   119,   122,   222,   223,
     227,   268,   274,    16,    23,    25,    36,    39,    41,    54,
      69,    96,   120,   126,   127,   229,   230,   231,   232,   233,
     237,   238,   240,   241,   243,   244,   248,   260,   359,   412,
     420,   425,    99,   359,   359,   368,   311,   316,   316,   184,
     186,    58,   419,     1,   119,   125,   102,   308,     1,   121,
     123,   322,     1,   119,   419,     1,   102,    20,   359,   324,
      20,   352,   353,   354,   367,   424,   233,   226,     1,   226,
     227,    49,   261,   424,    73,    99,   106,   277,   278,   424,
      48,   278,   279,   124,   124,   247,   424,   299,   299,     1,
     189,   249,   250,   251,   252,   424,    33,   230,   232,   242,
     243,   248,   405,     1,   239,   405,   242,   248,    98,   242,
     244,   359,   120,   124,   235,   102,    55,   385,   119,   119,
     119,   119,   119,   119,   182,   312,   182,   187,   308,     1,
     308,    33,   405,   125,   259,     1,   259,   340,    14,    66,
     335,   336,   339,     1,   339,   356,     1,   356,   414,   328,
     357,   316,   122,   123,   121,   120,   278,    64,     1,   385,
       1,   280,   269,   424,     1,   231,   233,   237,   245,   246,
     246,    33,   298,    22,   123,    22,    18,     1,   119,   419,
     228,   122,     1,   121,   122,   102,     1,   236,   359,   359,
     359,   242,   272,   424,   312,    16,   233,   305,   306,   123,
      33,   414,    22,   414,   316,    20,   325,   415,   352,   354,
     359,   120,   262,   424,   359,   119,     1,   121,   125,   125,
     228,   228,   237,   253,   254,   405,   412,   252,     1,   252,
     405,     1,   405,   359,     1,   121,   122,   125,   119,   233,
     233,   316,   312,   415,   414,   415,   122,   123,   122,     1,
     233,     1,   263,   264,   424,    56,    76,   270,   273,   274,
     246,   246,    33,   278,    33,   123,   359,     1,   359,   273,
     415,   415,   316,   355,   367,   122,   122,    22,     9,    10,
      25,    36,    49,    53,    74,    86,   189,   265,   274,   368,
     359,   228,     1,   256,   257,   258,   233,   254,   415,   121,
     122,   405,   405,   405,   405,   359,   123,   119,    86,     1,
     119,   419,   123,   367,   299,   299,   299,   299,   228,   271,
     257,   257,   255,   336,   120,   295,   278,   359,   120,   249,
     298,   249,   122,   122,   419
};


/* Prevent warning if -Wmissing-prototypes.  */
int yyparse (void);

/* Error token number */
#define YYTERROR 1

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */


#define YYRHSLOC(Rhs, K) ((Rhs)[K].yystate.yyloc)
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)

/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# define YY_LOCATION_PRINT(File, Loc)			\
    fprintf (File, "%d.%d-%d.%d",			\
             (Loc).first_line, (Loc).first_column,	\
             (Loc).last_line,  (Loc).last_column)
#endif


#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#define YYLEX yylex ()

YYSTYPE yylval;

YYLTYPE yylloc;

int yynerrs;
int yychar;

static const int YYEOF = 0;
static const int YYEMPTY = -2;

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)							     \
   do { YYRESULTTAG yyflag = YYE; if (yyflag != yyok) return yyflag; }	     \
   while (0)

#if YYDEBUG

#if ! defined (YYFPRINTF)
#  define YYFPRINTF fprintf
#endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  fprintf (yyoutput, ": ");

# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

#else /* !YYDEBUG */

# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call expandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data. */
#define YYHEADROOM 2

#if (! defined (YYSTACKEXPANDABLE) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
	     && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))
#define YYSTACKEXPANDABLE 1
#else
#define YYSTACKEXPANDABLE 0
#endif

/** State numbers, as in LALR(1) machine */
typedef int yyStateNum;

/** Rule numbers, as in LALR(1) machine */
typedef int yyRuleNum;

/** Grammar symbol */
typedef short int yySymbol;

/** Item references, as in LALR(1) machine */
typedef short int yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;
typedef struct yyGLRStateSet yyGLRStateSet;

struct yyGLRState {
  yybool yyisState;
  yybool yyresolved;
  yyStateNum yylrState;
  yyGLRState* yypred;
  size_t yyposn;
  union {
    yySemanticOption* yyfirstVal;
    YYSTYPE yysval;
  } yysemantics;
  YYLTYPE yyloc;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  size_t yysize, yycapacity;
};

struct yySemanticOption {
  yybool yyisState;
  yyRuleNum yyrule;
  yyGLRState* yystate;
  yySemanticOption* yynext;
};

union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrflag;
  int yyerrState;
  /* To compute the location of the error token.  */
  yyGLRStackItem yyerror_range[3];

  yySymbol* yytokenp;
  jmp_buf yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  int yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

static void yyinitGLRStack (yyGLRStack* yystack, size_t yysize);
static void yyexpandGLRStack (yyGLRStack* yystack);
static void yyfreeGLRStack (yyGLRStack* yystack);

static void
yyFail (yyGLRStack* yystack, const char* yyformat, ...)
{
  yystack->yyerrflag = 1;
  if (yyformat != NULL)
    {
      char yymsg[256];
      va_list yyap;
      va_start (yyap, yyformat);
      vsprintf (yymsg, yyformat, yyap);
      yyerror (yymsg);
    }
  longjmp (yystack->yyexception_buffer, 1);
}

#if YYDEBUG || YYERROR_VERBOSE
/** A printable representation of TOKEN.  Valid until next call to
 *  tokenName. */
static inline const char*
yytokenName (yySymbol yytoken)
{
  if (yytoken == YYEMPTY)
    return "";

  return yytname[yytoken];
}
#endif

/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain. Assumes
 *  YYLOW1 < YYLOW0.  */
static void yyfillin (yyGLRStackItem *, int, int) ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  yyGLRState* s;
  int i;
  s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
      YYASSERT (s->yyresolved);
      yyvsp[i].yystate.yyresolved = yytrue;
      yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      yyvsp[i].yystate.yyloc = s->yyloc;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
   YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
   For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$). Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT. */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, int yyrhslen, yyGLRStackItem* yyvsp,
	      YYSTYPE* yyvalp,
	      YYLTYPE* yylocp,
	      yyGLRStack* yystack
              )
{
  yybool yynormal ATTRIBUTE_UNUSED = (yystack->yysplitPoint == NULL);
  int yylow;

# undef yyerrok
# define yyerrok (yystack->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING (yystack->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = *(yystack->yytokenp) = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, N, yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)						     \
  return yyerror ("syntax error: cannot back up"),	     \
	 yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  YYLLOC_DEFAULT (*yylocp, yyvsp - yyrhslen, yyrhslen);

  switch (yyn)
    {
        case 2:
#line 245 "parse.y"
    { error ("empty input file"); ;}
    break;

  case 3:
#line 247 "parse.y"
    {
        if (co->ignore_garbage_after_dot)
          {
            discard_input ();
            YYACCEPT;
          }
      ;}
    break;

  case 4:
#line 258 "parse.y"
    { initialize_module (TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype) ? TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : NULL_TREE, TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))), 0); ;}
    break;

  case 5:
#line 260 "parse.y"
    { start_main_program (); ;}
    break;

  case 6:
#line 262 "parse.y"
    { finish_main_program (); ;}
    break;

  case 7:
#line 264 "parse.y"
    { finalize_module (0); ;}
    break;

  case 8:
#line 269 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 9:
#line 271 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 10:
#line 273 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 11:
#line 278 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 12:
#line 280 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 15:
#line 290 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 16:
#line 292 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 17:
#line 296 "parse.y"
    { check_forward_decls (0); ;}
    break;

  case 18:
#line 298 "parse.y"
    { ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ;}
    break;

  case 19:
#line 300 "parse.y"
    { ((*yyvalp).itype) = od_label; ;}
    break;

  case 20:
#line 302 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 21:
#line 307 "parse.y"
    {
#ifndef EGCS97
        pop_obstacks ();
#endif
        ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype);
      ;}
    break;

  case 22:
#line 317 "parse.y"
    { ((*yyvalp).itype) = od_const; ;}
    break;

  case 23:
#line 319 "parse.y"
    { current_type_list = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 24:
#line 321 "parse.y"
    { declare_types (); ((*yyvalp).itype) = od_type; ;}
    break;

  case 25:
#line 323 "parse.y"
    { ((*yyvalp).itype) = od_var; ;}
    break;

  case 26:
#line 328 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_interface); initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 27:
#line 330 "parse.y"
    { start_unit_implementation (); ;}
    break;

  case 28:
#line 332 "parse.y"
    { check_forward_decls (1); ;}
    break;

  case 31:
#line 336 "parse.y"
    { ((*yyvalp).ttype) = current_module->name; finalize_module (1); ;}
    break;

  case 32:
#line 338 "parse.y"
    {
        if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype) && current_module->name != (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))
          error ("implementation of module `%s' following interface of module `%s'",
                 IDENTIFIER_NAME (current_module->name), IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
      ;}
    break;

  case 33:
#line 344 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2); ;}
    break;

  case 34:
#line 346 "parse.y"
    {
        if (co->interface_only)
          exit_compilation ();
      ;}
    break;

  case 36:
#line 352 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 4); ;}
    break;

  case 38:
#line 358 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_interface); ;}
    break;

  case 39:
#line 360 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2); ;}
    break;

  case 40:
#line 362 "parse.y"
    { clear_forward_decls ();  /* don't complain in poplevel */ ;}
    break;

  case 41:
#line 367 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_export); start_module_interface (); ;}
    break;

  case 42:
#line 369 "parse.y"
    { create_gpi_files (); ;}
    break;

  case 43:
#line 374 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), NULL_TREE, 3); ;}
    break;

  case 45:
#line 379 "parse.y"
    { chk_dialect ("units without `implementation' part are", U_M_PASCAL); ;}
    break;

  case 47:
#line 385 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_module); ;}
    break;

  case 48:
#line 390 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype) ? TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 51:
#line 400 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 52:
#line 402 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 55:
#line 409 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 56:
#line 414 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 57:
#line 416 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 59:
#line 421 "parse.y"
    { check_forward_decls (0); ;}
    break;

  case 60:
#line 423 "parse.y"
    { ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ;}
    break;

  case 61:
#line 425 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 62:
#line 429 "parse.y"
    { current_module->implementation = 1; ;}
    break;

  case 63:
#line 431 "parse.y"
    { check_forward_decls (1); ;}
    break;

  case 69:
#line 444 "parse.y"
    { chk_dialect_name ("to begin do", E_O_PASCAL); start_constructor (0); ;}
    break;

  case 70:
#line 446 "parse.y"
    { finish_constructor (); ;}
    break;

  case 71:
#line 451 "parse.y"
    { chk_dialect_name ("to end do", E_O_PASCAL); start_destructor (); ;}
    break;

  case 72:
#line 453 "parse.y"
    { finish_destructor (); ;}
    break;

  case 73:
#line 458 "parse.y"
    { finish_constructor (); ;}
    break;

  case 74:
#line 463 "parse.y"
    { start_constructor (0); ;}
    break;

  case 76:
#line 469 "parse.y"
    { start_constructor (0); ;}
    break;

  case 79:
#line 473 "parse.y"
    { start_destructor (); ;}
    break;

  case 80:
#line 475 "parse.y"
    { finish_destructor (); ;}
    break;

  case 83:
#line 482 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 84:
#line 487 "parse.y"
    { ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 85:
#line 492 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 86:
#line 494 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 87:
#line 496 "parse.y"
    {
        ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype));
        error ("comma missing after `%s'", IDENTIFIER_NAME (TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))));
        yyerrok;
      ;}
    break;

  case 88:
#line 502 "parse.y"
    { error ("extra comma following identifier list"); ;}
    break;

  case 90:
#line 508 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 91:
#line 510 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 93:
#line 516 "parse.y"
    { yyerrok; ;}
    break;

  case 94:
#line 518 "parse.y"
    { error ("module specifications need an export part"); ;}
    break;

  case 95:
#line 520 "parse.y"
    { warning ("missing semicolon"); yyerrok; ;}
    break;

  case 96:
#line 522 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 97:
#line 527 "parse.y"
    { export_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 98:
#line 532 "parse.y"
    { error ("missing `='"); ;}
    break;

  case 100:
#line 538 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 102:
#line 541 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 103:
#line 546 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_all); ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 105:
#line 552 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 106:
#line 554 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 107:
#line 556 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 108:
#line 558 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 109:
#line 563 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 110:
#line 565 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 111:
#line 567 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); TREE_READONLY (((*yyvalp).ttype)) = 1; ;}
    break;

  case 113:
#line 573 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_id ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 115:
#line 579 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 116:
#line 585 "parse.y"
    { do_extra_import (); ;}
    break;

  case 122:
#line 601 "parse.y"
    { warning ("missing semicolon"); yyerrok; ;}
    break;

  case 123:
#line 606 "parse.y"
    { import_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype) ? IMPORT_QUALIFIED : IMPORT_ISO, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 125:
#line 612 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_qualified); ;}
    break;

  case 127:
#line 618 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 128:
#line 620 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 129:
#line 625 "parse.y"
    { ((*yyvalp).itype) = od_uses; ;}
    break;

  case 132:
#line 632 "parse.y"
    { warning ("missing comma"); yyerrok; ;}
    break;

  case 133:
#line 637 "parse.y"
    { import_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, IMPORT_USES, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 135:
#line 643 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("file name specification with `in' is", BORLAND_DELPHI); ;}
    break;

  case 137:
#line 649 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 138:
#line 651 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 139:
#line 653 "parse.y"
    { error ("missing comma"); ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 140:
#line 655 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 141:
#line 660 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 142:
#line 667 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 143:
#line 669 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 144:
#line 671 "parse.y"
    { error ("non-label in label_list"); ;}
    break;

  case 145:
#line 673 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 146:
#line 675 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 149:
#line 682 "parse.y"
    { chk_dialect ("non-numeric labels are", B_D_M_PASCAL); ;}
    break;

  case 152:
#line 694 "parse.y"
    { ((*yyvalp).ttype) = numeric_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 156:
#line 707 "parse.y"
    { declare_constant ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 157:
#line 710 "parse.y"
    {
        lex_const_equal = -1;
        declare_variables (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), VQ_BP_CONST, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 159:
#line 721 "parse.y"
    { yyerrok; ;}
    break;

  case 161:
#line 724 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 162:
#line 726 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 164:
#line 732 "parse.y"
    {
        lex_const_equal = -1;
        if (!EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))
          {
            if (PASCAL_TYPE_UNDISCRIMINATED_SCHEMA ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))
              chk_dialect ("undiscriminated schemata on the right side of a type definition are", GNU_PASCAL);
            build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
          }
      ;}
    break;

  case 165:
#line 742 "parse.y"
    {
        ((*yyvalp).itype) = immediate_size_expand;
        immediate_size_expand = 0;
        size_volatile++;
      ;}
    break;

  case 166:
#line 748 "parse.y"
    {
        build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), build_schema_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), NULL_TREE);
        immediate_size_expand = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype);
        size_volatile--;
      ;}
    break;

  case 167:
#line 754 "parse.y"
    { build_schema_type (error_mark_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 168:
#line 756 "parse.y"
    { ((*yyvalp).ttype) = start_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 169:
#line 758 "parse.y"
    {
        lex_const_equal = -1;
        finish_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype) != NULL_TREE);
        yyerrok;
      ;}
    break;

  case 170:
#line 767 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 171:
#line 769 "parse.y"
    { error ("invalid schema discriminants"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 173:
#line 775 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 174:
#line 777 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 175:
#line 779 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 177:
#line 785 "parse.y"
    { ((*yyvalp).ttype) = build_discriminants ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 179:
#line 791 "parse.y"
    { type_attributes (&((*yyvalp).ttype), TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 180:
#line 798 "parse.y"
    {
#ifndef EGCS97
        pop_obstacks ();
#endif
        ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype);
      ;}
    break;

  case 182:
#line 809 "parse.y"
    { ((*yyvalp).ttype) = pascal_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), TYPE_QUALIFIER_BINDABLE); ;}
    break;

  case 184:
#line 815 "parse.y"
    { ((*yyvalp).ttype) = pascal_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), TYPE_QUALIFIER_RESTRICTED); ;}
    break;

  case 185:
#line 817 "parse.y"
    { ((*yyvalp).ttype) = build_discriminated_schema_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 189:
#line 822 "parse.y"
    { chk_dialect ("procedural variables and types are", B_D_M_PASCAL); ;}
    break;

  case 191:
#line 825 "parse.y"
    { defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype); ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) ? pack_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 192:
#line 830 "parse.y"
    { defining_packed_type += ((*yyvalp).itype) = !co->ignore_packed;  /* can be nested */ ;}
    break;

  case 193:
#line 835 "parse.y"
    {
        if (PASCAL_TYPE_UNDISCRIMINATED_STRING (((*yyvalp).ttype)))
          {
            if (!(co->pascal_dialect & B_D_M_PASCAL))
              error_or_warning (co->pascal_dialect & E_O_PASCAL, "missing string capacity -- assuming 255");
            ((*yyvalp).ttype) = string255_type_node;
          }
      ;}
    break;

  case 194:
#line 847 "parse.y"
    {
        tree decl = lookup_name ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
        ((*yyvalp).ttype) = error_mark_node;
        if (!decl)
          error ("unknown identifier `%s'", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)));
        else if (TREE_CODE (decl) != TYPE_DECL)
          error ("type name expected, `%s' given", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)));
        else
          ((*yyvalp).ttype) = TREE_TYPE (decl);
      ;}
    break;

  case 196:
#line 862 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_id ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 197:
#line 867 "parse.y"
    { chk_dialect ("schema/string discriminants are", E_O_M_PASCAL); ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 198:
#line 869 "parse.y"
    {
        chk_dialect ("string capacity in brackets is", U_B_D_M_PASCAL);
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 0)));
      ;}
    break;

  case 199:
#line 877 "parse.y"
    {
        /* This expression might be a discriminant of another schema. */
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0)));
      ;}
    break;

  case 200:
#line 882 "parse.y"
    {
        ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0))));
        yyerrok;
      ;}
    break;

  case 201:
#line 887 "parse.y"
    { error ("missing expression"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 202:
#line 889 "parse.y"
    {
        error ("missing comma");
        ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0))));
        yyerrok;
      ;}
    break;

  case 203:
#line 895 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 206:
#line 907 "parse.y"
    { ((*yyvalp).ttype) = build_enum_type (nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 207:
#line 909 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 208:
#line 914 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 209:
#line 916 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 210:
#line 918 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 211:
#line 920 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 213:
#line 926 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_subrange_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 214:
#line 928 "parse.y"
    {
        defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype);
        chk_dialect ("packed subrange types are", B_D_PASCAL);
        ((*yyvalp).ttype) = build_pascal_subrange_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype));
      ;}
    break;

  case 215:
#line 938 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 216:
#line 940 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 217:
#line 942 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 218:
#line 944 "parse.y"
    {
        chk_dialect ("pointers to `const' types are", GNU_PASCAL);
        ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type (p_build_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1, TYPE_VOLATILE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))));
      ;}
    break;

  case 219:
#line 952 "parse.y"
    { ((*yyvalp).ttype) = get_pointer_domain_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 220:
#line 954 "parse.y"
    {
        chk_dialect ("pointers to routines are", GNU_PASCAL);
        assert (EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) || (TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE && TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))));
        ((*yyvalp).ttype) = TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 222:
#line 966 "parse.y"
    { ((*yyvalp).ttype) = build_procedural_type (void_type_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 223:
#line 968 "parse.y"
    { ((*yyvalp).ttype) = build_procedural_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 224:
#line 973 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_array_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 226:
#line 976 "parse.y"
    { ((*yyvalp).ttype) = build_file_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 227:
#line 978 "parse.y"
    { ((*yyvalp).ttype) = build_set_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 228:
#line 980 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); yyerrok; ;}
    break;

  case 229:
#line 982 "parse.y"
    { ((*yyvalp).ttype) = build_record (NULL_TREE, NULL_TREE, NULL_TREE); ;}
    break;

  case 232:
#line 989 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 233:
#line 991 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 234:
#line 993 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (error_mark_node, error_mark_node); ;}
    break;

  case 235:
#line 995 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (error_mark_node, error_mark_node); ;}
    break;

  case 236:
#line 1000 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 237:
#line 1002 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 239:
#line 1008 "parse.y"
    { ((*yyvalp).ttype) = TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 240:
#line 1013 "parse.y"
    { chk_dialect ("untyped files are", U_B_D_M_PASCAL); ((*yyvalp).ttype) = untyped_file_type_node; ;}
    break;

  case 241:
#line 1018 "parse.y"
    { ((*yyvalp).ttype) = build_record (NULL_TREE, NULL_TREE, NULL_TREE); ;}
    break;

  case 242:
#line 1020 "parse.y"
    { ((*yyvalp).ttype) = build_record ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 243:
#line 1022 "parse.y"
    { ((*yyvalp).ttype) = build_record ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 247:
#line 1033 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 248:
#line 1035 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 249:
#line 1037 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 251:
#line 1043 "parse.y"
    { ((*yyvalp).ttype) = build_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 252:
#line 1048 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_field ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 253:
#line 1050 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_field ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 254:
#line 1052 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 255:
#line 1054 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 256:
#line 1059 "parse.y"
    { chk_dialect ("type denoters (no identifiers) as variant tag type are", U_B_D_M_PASCAL); ;}
    break;

  case 257:
#line 1064 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 258:
#line 1066 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, build_field (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 260:
#line 1072 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 261:
#line 1074 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 262:
#line 1076 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 264:
#line 1082 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_field (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 266:
#line 1088 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 267:
#line 1090 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 268:
#line 1092 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 270:
#line 1098 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0)); ;}
    break;

  case 271:
#line 1100 "parse.y"
    {
        chk_dialect ("`case' ranges are", NOT_CLASSIC_PASCAL);
        ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0), string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0));
      ;}
    break;

  case 272:
#line 1105 "parse.y"
    {
        ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0), string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0));
        error ("missing `..'");
        yyerrok;
      ;}
    break;

  case 273:
#line 1111 "parse.y"
    { error ("extra `..'"); ((*yyvalp).ttype) = build_tree_list (NULL_TREE, string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0)); ;}
    break;

  case 274:
#line 1116 "parse.y"
    { ((*yyvalp).ttype) = build_type_of ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 278:
#line 1129 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 279:
#line 1131 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 281:
#line 1137 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 282:
#line 1139 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 284:
#line 1145 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), build_tree_list (void_type_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 285:
#line 1147 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 286:
#line 1152 "parse.y"
    { ((*yyvalp).ttype) = build_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 287:
#line 1154 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 288:
#line 1156 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 289:
#line 1158 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, boolean_type_node, 1); ;}
    break;

  case 290:
#line 1160 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 1); ;}
    break;

  case 291:
#line 1162 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 292:
#line 1164 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 293:
#line 1166 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 297:
#line 1179 "parse.y"
    {
        tree t, ids = ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype));
        if ((TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == POINTER_TYPE || TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE)
            && TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) == FUNCTION_TYPE)
          TREE_PRIVATE (ids) = !!allow_function_calls (0);  /* kludge */
        /* With `begin var Result: Integer; Result := ...' where `Result'
           is a built-in identifier, parser look-ahead would already get
           its special meaning before we get to declaring the variables.
           So mark the identifiers. (fjf791.pas) */
        for (t = ids; t; t = TREE_CHAIN (t))
          PASCAL_PENDING_DECLARATION (TREE_VALUE (t)) = 1;
      ;}
    break;

  case 298:
#line 1192 "parse.y"
    {
        tree t, ids = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype);
        for (t = ids; t; t = TREE_CHAIN (t))
          PASCAL_PENDING_DECLARATION (TREE_VALUE (t)) = 0;
        lex_const_equal = -1;
        ((*yyvalp).ttype) = declare_variables (ids, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
        if ((TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)) == POINTER_TYPE || TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE)
            && TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype))) == FUNCTION_TYPE)
          allow_function_calls (TREE_PRIVATE (ids));
        yyerrok;
      ;}
    break;

  case 299:
#line 1204 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; lex_const_equal = -1; ;}
    break;

  case 301:
#line 1210 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 303:
#line 1216 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 304:
#line 1218 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_name); ;}
    break;

  case 305:
#line 1220 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 307:
#line 1226 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 308:
#line 1231 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 309:
#line 1233 "parse.y"
    { ((*yyvalp).ttype) = TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 310:
#line 1238 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 312:
#line 1244 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 314:
#line 1250 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 315:
#line 1252 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 316:
#line 1254 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 317:
#line 1256 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 318:
#line 1258 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 319:
#line 1262 "parse.y"
    { lex_const_equal = -1; ;}
    break;

  case 320:
#line 1264 "parse.y"
    { chk_dialect ("initialization with `:=' is", VAX_PASCAL); ;}
    break;

  case 321:
#line 1266 "parse.y"
    { chk_dialect ("initialization with `=' is", BORLAND_DELPHI); ;}
    break;

  case 323:
#line 1272 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 324:
#line 1274 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 326:
#line 1280 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); lex_const_equal = -1; ;}
    break;

  case 327:
#line 1282 "parse.y"
    {
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype));
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
        PASCAL_ABSOLUTE_CLAUSE (((*yyvalp).ttype)) = 1;
      ;}
    break;

  case 328:
#line 1288 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 329:
#line 1295 "parse.y"
    { declare_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 330:
#line 1306 "parse.y"
    { declare_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 331:
#line 1308 "parse.y"
    { ((*yyvalp).ttype) = start_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 332:
#line 1311 "parse.y"
    {
        do_setjmp ();
        un_initialize_block (getdecls (), 0, 0);
      ;}
    break;

  case 333:
#line 1316 "parse.y"
    {
        finish_routine ();
        restore_identifiers ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 336:
#line 1329 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 337:
#line 1331 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 338:
#line 1333 "parse.y"
    { ((*yyvalp).ttype) = build_operator_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 339:
#line 1343 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 340:
#line 1345 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 341:
#line 1347 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, boolean_type_node, 1); ;}
    break;

  case 342:
#line 1349 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 1); ;}
    break;

  case 345:
#line 1359 "parse.y"
    { ((*yyvalp).ttype) = chainon (chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 346:
#line 1364 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 347:
#line 1366 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 348:
#line 1368 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_name); ;}
    break;

  case 349:
#line 1370 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 350:
#line 1372 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 351:
#line 1374 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 352:
#line 1376 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 353:
#line 1378 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 354:
#line 1380 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 356:
#line 1386 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 357:
#line 1388 "parse.y"
    {
        if (co->warn_near_far)
          warning ("`%s' directive ignored because of flat memory model", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
      ;}
    break;

  case 363:
#line 1407 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("function result variable specifications are", E_O_PASCAL); ;}
    break;

  case 365:
#line 1413 "parse.y"
    { chk_dialect ("function result variables without `=' are", GNU_PASCAL); ;}
    break;

  case 367:
#line 1419 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("operator result variables with `=' are", GNU_PASCAL); ;}
    break;

  case 368:
#line 1421 "parse.y"
    { error ("missing operator result variable"); ;}
    break;

  case 369:
#line 1426 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 370:
#line 1428 "parse.y"
    { ((*yyvalp).ttype) = check_result_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 373:
#line 1435 "parse.y"
    {
        chk_dialect ("empty parentheses are", BORLAND_DELPHI);
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, void_type_node);
      ;}
    break;

  case 374:
#line 1440 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 375:
#line 1442 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 376:
#line 1444 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, NULL_TREE)); ;}
    break;

  case 377:
#line 1446 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 379:
#line 1452 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 380:
#line 1454 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 382:
#line 1460 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 0); ;}
    break;

  case 383:
#line 1462 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 1); ;}
    break;

  case 384:
#line 1464 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1, !!(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 385:
#line 1466 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2, 1); ;}
    break;

  case 386:
#line 1468 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 387:
#line 1470 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 390:
#line 1480 "parse.y"
    { ((*yyvalp).ttype) = void_type_node; chk_dialect ("untyped parameters are", U_B_D_M_PASCAL); ;}
    break;

  case 391:
#line 1482 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 396:
#line 1494 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 397:
#line 1496 "parse.y"
    {
        defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.itype);
        PASCAL_TREE_PACKED ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.itype);
        ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 401:
#line 1511 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 402:
#line 1513 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 404:
#line 1519 "parse.y"
    {
        ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype));
        TREE_TYPE (((*yyvalp).ttype)) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype);
      ;}
    break;

  case 405:
#line 1527 "parse.y"
    {
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE);
        TREE_TYPE (((*yyvalp).ttype)) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype);
      ;}
    break;

  case 408:
#line 1542 "parse.y"
    { yyerrok; ;}
    break;

  case 410:
#line 1548 "parse.y"
    { yyerrok; ;}
    break;

  case 413:
#line 1555 "parse.y"
    { chk_dialect ("variable declarations in the statement part are", GNU_PASCAL); un_initialize_block ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 0); ;}
    break;

  case 416:
#line 1565 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 417:
#line 1567 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 422:
#line 1582 "parse.y"
    { expand_call_statement ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 423:
#line 1584 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (!PASCAL_PROCEDURAL_TYPE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 424:
#line 1586 "parse.y"
    { expand_pascal_assignment ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 425:
#line 1588 "parse.y"
    { build_predef_call (p_Return, NULL_TREE); ;}
    break;

  case 426:
#line 1590 "parse.y"
    { build_predef_call (p_Return, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 427:
#line 1592 "parse.y"
    { build_predef_call (p_Exit, NULL_TREE); ;}
    break;

  case 428:
#line 1594 "parse.y"
    { build_predef_call (p_Halt, NULL_TREE); ;}
    break;

  case 429:
#line 1596 "parse.y"
    { build_exit_statement ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 431:
#line 1599 "parse.y"
    { restore_identifiers ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 432:
#line 1601 "parse.y"
    { expand_end_cond (); ;}
    break;

  case 433:
#line 1603 "parse.y"
    { expand_start_else (); ;}
    break;

  case 434:
#line 1605 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype) && extra_warnings)
          warning ("empty statement after `else'");
        expand_end_cond ();
      ;}
    break;

  case 435:
#line 1611 "parse.y"
    {
        ((*yyvalp).ttype) = current_case_expression;
        current_case_expression = pascal_expand_start_case ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 436:
#line 1616 "parse.y"
    {
        tree duplicate;
        if (!EM (current_case_expression))
          assert (!pushcase (NULL_TREE, 0, build_decl (LABEL_DECL, NULL_TREE, NULL_TREE), &duplicate));
      ;}
    break;

  case 437:
#line 1622 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype) && !(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype))
          chk_dialect ("empty `case' statements are", MAC_PASCAL);
        expand_exit_something ();
        if (!EM (current_case_expression))
          expand_end_case ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.ttype));
        current_case_expression = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype);
        yyerrok;
      ;}
    break;

  case 438:
#line 1632 "parse.y"
    { emit_nop (); expand_start_loop_continue_elsewhere (1); ;}
    break;

  case 439:
#line 1634 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_loop_continue_here (); ;}
    break;

  case 440:
#line 1636 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_exit_loop_if_false (0, build_pascal_unary_op (TRUTH_NOT_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 441:
#line 1638 "parse.y"
    { expand_end_loop (); ;}
    break;

  case 442:
#line 1640 "parse.y"
    { expand_start_loop (1); ;}
    break;

  case 443:
#line 1642 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_exit_loop_if_false (0, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 444:
#line 1644 "parse.y"
    { expand_end_loop (); ;}
    break;

  case 445:
#line 1646 "parse.y"
    { ((*yyvalp).ttype) = start_for_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 446:
#line 1648 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yyloc)); finish_for_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 447:
#line 1650 "parse.y"
    { ((*yyvalp).ttype) = start_for_set_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 448:
#line 1652 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yyloc)); finish_for_set_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 449:
#line 1654 "parse.y"
    { pascal_expand_goto ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 450:
#line 1659 "parse.y"
    { set_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 452:
#line 1665 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 453:
#line 1667 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 454:
#line 1669 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 455:
#line 1671 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 456:
#line 1676 "parse.y"
    { ((*yyvalp).ttype) = pascal_shadow_record_fields (undo_schema_dereference ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), NULL_TREE); ;}
    break;

  case 457:
#line 1678 "parse.y"
    { ((*yyvalp).ttype) = pascal_shadow_record_fields (undo_schema_dereference ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 458:
#line 1683 "parse.y"
    { expand_start_cond ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 459:
#line 1685 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype) && extra_warnings)
          warning ("empty statement after `then'");
      ;}
    break;

  case 460:
#line 1693 "parse.y"
    {
        /* Create an implicit `otherwise' (in the rule above) to avoid warnings
           about unhandled cases. In ISO Pascal, this is a run-time error. */
        if (co->case_value_checking)
          build_predef_call (p_CaseNoMatchError, NULL_TREE);
        ((*yyvalp).itype) = 0;
      ;}
    break;

  case 461:
#line 1701 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 462:
#line 1706 "parse.y"
    { chk_dialect ("`else' in `case' statements is", B_D_M_PASCAL); ;}
    break;

  case 464:
#line 1712 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 465:
#line 1714 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 467:
#line 1720 "parse.y"
    { yyerrok; ;}
    break;

  case 468:
#line 1722 "parse.y"
    { error ("case element expected"); ;}
    break;

  case 469:
#line 1724 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 470:
#line 1726 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 471:
#line 1731 "parse.y"
    { pascal_pushcase ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 472:
#line 1733 "parse.y"
    { expand_exit_something (); ;}
    break;

  case 473:
#line 1738 "parse.y"
    { ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 474:
#line 1740 "parse.y"
    { ((*yyvalp).code) = GE_EXPR; ;}
    break;

  case 475:
#line 1742 "parse.y"
    { error ("missing `to' or `downto'"); ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 477:
#line 1748 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_lvalue_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 479:
#line 1754 "parse.y"
    { error ("using `=' instead of `:=' in assignment"); ;}
    break;

  case 480:
#line 1759 "parse.y"
    { build_predef_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 481:
#line 1761 "parse.y"
    { build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))->symbol, NULL_TREE); ;}
    break;

  case 482:
#line 1763 "parse.y"
    { build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))->symbol, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 483:
#line 1765 "parse.y"
    { build_predef_call (p_Dispose, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 484:
#line 1767 "parse.y"
    {
        current_structor_object_type = NULL_TREE;
        if (TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))) == POINTER_TYPE && PASCAL_TYPE_OBJECT (TREE_TYPE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)))))
          error ("invalid arguments to object `Dispose'");
        else
          build_predef_call (p_Dispose, tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
      ;}
    break;

  case 485:
#line 1775 "parse.y"
    { build_predef_call (p_Dispose, tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, call_method ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))))); ;}
    break;

  case 486:
#line 1777 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE, NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 487:
#line 1779 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 488:
#line 1781 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 489:
#line 1783 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-9)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 490:
#line 1788 "parse.y"
    { ((*yyvalp).ttype) = set_structor_object ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 492:
#line 1793 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); ;}
    break;

  case 493:
#line 1795 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); yyerrok; ;}
    break;

  case 494:
#line 1800 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 495:
#line 1802 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); yyerrok; ;}
    break;

  case 496:
#line 1804 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, error_mark_node); ;}
    break;

  case 497:
#line 1806 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, error_mark_node); error ("extra comma"); ;}
    break;

  case 499:
#line 1812 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 500:
#line 1814 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 501:
#line 1816 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 502:
#line 1822 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 503:
#line 1824 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 504:
#line 1826 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 505:
#line 1831 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 506:
#line 1833 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_volatile); ((*yyvalp).itype) = 1; ;}
    break;

  case 510:
#line 1844 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 511:
#line 1849 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 512:
#line 1854 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 513:
#line 1856 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 514:
#line 1863 "parse.y"
    {
        if (PEDANTIC (NOT_CLASSIC_PASCAL))
          {
            tree t = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype);
            STRIP_TYPE_NOPS (t);
            if (TREE_CODE (t) == CONVERT_EXPR || TREE_CODE (t) == NEGATE_EXPR)
              t = TREE_OPERAND (t, 0);
            if (last_parenthesized_expression == (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)
                || last_parenthesized_expression == t
                || !(TREE_CODE_CLASS (TREE_CODE (t)) == 'c' && PASCAL_TREE_FRESH_CST (t)))
              error ("ISO 7185 Pascal allows only simple constants");
          }
      ;}
    break;

  case 515:
#line 1880 "parse.y"
    {
        if (!EM (TREE_TYPE (((*yyvalp).ttype))) && TREE_CODE (TREE_TYPE (((*yyvalp).ttype))) != BOOLEAN_TYPE)
          {
            error ("condition must be of Boolean type");
            ((*yyvalp).ttype) = error_mark_node;
          }
      ;}
    break;

  case 516:
#line 1891 "parse.y"
    { ((*yyvalp).ttype) = iso_no_parentheses ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 517:
#line 1896 "parse.y"
    { ((*yyvalp).ttype) = fold (parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 518:
#line 1898 "parse.y"
    { ((*yyvalp).ttype) = fold ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 520:
#line 1904 "parse.y"
    { ((*yyvalp).ttype) = set_exp_original_code (build_pascal_unary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 521:
#line 1906 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 522:
#line 1908 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 523:
#line 1910 "parse.y"
    { ((*yyvalp).ttype) = start_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 524:
#line 1912 "parse.y"
    { if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) LOCATION_NOTE (COPYLOC ((*yylocp), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))); ((*yyvalp).ttype) = finish_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 526:
#line 1918 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 527:
#line 1920 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 528:
#line 1922 "parse.y"
    { ((*yyvalp).ttype) = start_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 529:
#line 1924 "parse.y"
    { if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) LOCATION_NOTE (COPYLOC ((*yylocp), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))); ((*yyvalp).ttype) = finish_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 531:
#line 1930 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 532:
#line 1932 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op (POW_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 533:
#line 1934 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op (POWER_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 534:
#line 1936 "parse.y"
    { ((*yyvalp).ttype) = build_is_as ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), p_is); ;}
    break;

  case 535:
#line 1938 "parse.y"
    { ((*yyvalp).ttype) = build_is_as ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), p_as); ;}
    break;

  case 536:
#line 1943 "parse.y"
    { ((*yyvalp).ttype) = set_exp_original_code (build_pascal_unary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 537:
#line 1945 "parse.y"
    {
        chk_dialect ("the address operator is", B_D_M_PASCAL);
        ((*yyvalp).ttype) = build_pascal_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), !co->typed_address);
      ;}
    break;

  case 540:
#line 1952 "parse.y"
    { ((*yyvalp).ttype) = null_pointer_node; ;}
    break;

  case 542:
#line 1955 "parse.y"
    {
        if (TREE_CODE (((*yyvalp).ttype)) == TYPE_DECL)
          {
            error ("variable access expected -- type name given");
            ((*yyvalp).ttype) = error_mark_node;
          }
        else if (MAYBE_CALL_FUNCTION (((*yyvalp).ttype)) && TREE_CODE (function_result_type (((*yyvalp).ttype))) != VOID_TYPE)
          ((*yyvalp).ttype) = maybe_call_function (((*yyvalp).ttype), 0);
        else if (CALL_METHOD (((*yyvalp).ttype)))
          ((*yyvalp).ttype) = call_method (((*yyvalp).ttype), NULL_TREE);
      ;}
    break;

  case 546:
#line 1976 "parse.y"
    { ((*yyvalp).ttype) = combine_strings ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 551:
#line 1988 "parse.y"
    { ((*yyvalp).ttype) = build_caret_string_constant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 570:
#line 1999 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 571:
#line 2001 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 572:
#line 2006 "parse.y"
    { ((*yyvalp).ttype) = iso_no_parentheses ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 573:
#line 2011 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))->symbol, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 574:
#line 2013 "parse.y"
    { ((*yyvalp).ttype) = get_builtin_variable ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 577:
#line 2020 "parse.y"
    { ((*yyvalp).ttype) = build_inherited_method ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 578:
#line 2022 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_or_component_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 579:
#line 2024 "parse.y"
    { ((*yyvalp).ttype) = last_parenthesized_expression = set_exp_original_code ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NOP_EXPR); ;}
    break;

  case 580:
#line 2026 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_pointer_reference ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 581:
#line 2028 "parse.y"
    { ((*yyvalp).ttype) = build_array_ref_or_constructor ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 582:
#line 2030 "parse.y"
    { ((*yyvalp).ttype) = build_iso_constructor ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 583:
#line 2032 "parse.y"
    { chk_dialect ("empty parentheses are", BORLAND_DELPHI | MAC_PASCAL); ((*yyvalp).ttype) = build_call_or_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 584:
#line 2034 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); ;}
    break;

  case 585:
#line 2036 "parse.y"
    {
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype));
        ((*yyvalp).ttype) = build_call_or_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 586:
#line 2041 "parse.y"
    { chk_dialect ("type casts are", B_D_M_PASCAL); ((*yyvalp).ttype) = build_type_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 587:
#line 2043 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_FormatString, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 588:
#line 2045 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); ;}
    break;

  case 589:
#line 2047 "parse.y"
    {
        ((*yyvalp).ttype) = build_predef_call (p_Assigned, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype));
      ;}
    break;

  case 590:
#line 2052 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), co->pascal_dialect & B_D_M_PASCAL); ;}
    break;

  case 591:
#line 2054 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))->symbol, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 592:
#line 2056 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_New, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 593:
#line 2058 "parse.y"
    {
        current_structor_object_type = NULL_TREE;
        if (TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))) == POINTER_TYPE && PASCAL_TYPE_OBJECT (TREE_TYPE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)))))
          {
            error ("invalid arguments to object `New'");
            ((*yyvalp).ttype) = error_mark_node;
          }
        else
          ((*yyvalp).ttype) = build_predef_call (p_New, tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
      ;}
    break;

  case 594:
#line 2069 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_New, tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 595:
#line 2074 "parse.y"
    { ((*yyvalp).ttype) = set_structor_object (iso_no_parentheses ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), 1); ;}
    break;

  case 597:
#line 2080 "parse.y"
    { ((*yyvalp).ttype) = TYPE_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 599:
#line 2086 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 600:
#line 2088 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 604:
#line 2096 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 605:
#line 2101 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 606:
#line 2103 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 607:
#line 2108 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 608:
#line 2110 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list (build_tree_list (NULL_TREE, integer_zero_node), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 609:
#line 2115 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 610:
#line 2120 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list (NULL_TREE, NULL_TREE) /* not just NULL_TREE to avoid confusion with BP initializers */, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 611:
#line 2125 "parse.y"
    { ((*yyvalp).ttype) = maybe_schema_discriminant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 612:
#line 2127 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 613:
#line 2129 "parse.y"
    { PASCAL_BP_INITIALIZER_LIST ((((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))) = 1; ;}
    break;

  case 614:
#line 2131 "parse.y"
    { chk_dialect ("constructors in `[]' are", E_O_PASCAL); ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 615:
#line 2133 "parse.y"
    { error ("invalid component value"); ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 617:
#line 2139 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 618:
#line 2141 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); error ("missing separator"); ;}
    break;

  case 620:
#line 2147 "parse.y"
    { chk_dialect ("initializers separated with `,' are", B_D_M_PASCAL); ;}
    break;

  case 621:
#line 2152 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 622:
#line 2154 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 624:
#line 2160 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 625:
#line 2162 "parse.y"
    { error ("missing index expression"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 626:
#line 2164 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 627:
#line 2166 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 628:
#line 2171 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 629:
#line 2173 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1), NULL_TREE); ;}
    break;

  case 630:
#line 2175 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 1), string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1)); ;}
    break;

  case 631:
#line 2180 "parse.y"
    { ((*yyvalp).ttype) = build_set_constructor (NULL_TREE); ;}
    break;

  case 632:
#line 2182 "parse.y"
    { ((*yyvalp).ttype) = build_set_constructor (nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 634:
#line 2188 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); yyerrok; ;}
    break;

  case 635:
#line 2190 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); error ("missing comma"); yyerrok; ;}
    break;

  case 636:
#line 2192 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 637:
#line 2197 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 638:
#line 2199 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 639:
#line 2205 "parse.y"
    { ((*yyvalp).code) = CONVERT_EXPR; ;}
    break;

  case 640:
#line 2206 "parse.y"
    { ((*yyvalp).code) = NEGATE_EXPR; ;}
    break;

  case 641:
#line 2210 "parse.y"
    { ((*yyvalp).code) = CONVERT_EXPR; ;}
    break;

  case 642:
#line 2211 "parse.y"
    { ((*yyvalp).code) = NEGATE_EXPR; ;}
    break;

  case 643:
#line 2212 "parse.y"
    { ((*yyvalp).code) = TRUTH_NOT_EXPR; ;}
    break;

  case 644:
#line 2216 "parse.y"
    { ((*yyvalp).code) = NE_EXPR; ;}
    break;

  case 645:
#line 2217 "parse.y"
    { ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 646:
#line 2218 "parse.y"
    { ((*yyvalp).code) = GE_EXPR; ;}
    break;

  case 647:
#line 2219 "parse.y"
    { ((*yyvalp).code) = EQ_EXPR; ;}
    break;

  case 648:
#line 2220 "parse.y"
    { ((*yyvalp).code) = LT_EXPR; ;}
    break;

  case 649:
#line 2221 "parse.y"
    { ((*yyvalp).code) = GT_EXPR; ;}
    break;

  case 650:
#line 2222 "parse.y"
    { ((*yyvalp).code) = IN_EXPR; ;}
    break;

  case 651:
#line 2226 "parse.y"
    { ((*yyvalp).code) = PLUS_EXPR; ;}
    break;

  case 652:
#line 2227 "parse.y"
    { ((*yyvalp).code) = PLUS_EXPR; ;}
    break;

  case 653:
#line 2228 "parse.y"
    { ((*yyvalp).code) = MINUS_EXPR; ;}
    break;

  case 654:
#line 2229 "parse.y"
    { ((*yyvalp).code) = MINUS_EXPR; ;}
    break;

  case 655:
#line 2230 "parse.y"
    { ((*yyvalp).code) = TRUTH_XOR_EXPR; ;}
    break;

  case 656:
#line 2231 "parse.y"
    { ((*yyvalp).code) = SYMDIFF_EXPR; ;}
    break;

  case 657:
#line 2235 "parse.y"
    { ((*yyvalp).code) = MULT_EXPR; ;}
    break;

  case 658:
#line 2236 "parse.y"
    { ((*yyvalp).code) = RDIV_EXPR; ;}
    break;

  case 659:
#line 2237 "parse.y"
    { ((*yyvalp).code) = TRUNC_DIV_EXPR; ;}
    break;

  case 660:
#line 2238 "parse.y"
    { ((*yyvalp).code) = (co->pascal_dialect & B_D_M_PASCAL) ? TRUNC_MOD_EXPR : FLOOR_MOD_EXPR; ;}
    break;

  case 661:
#line 2239 "parse.y"
    { ((*yyvalp).code) = LSHIFT_EXPR; ;}
    break;

  case 662:
#line 2240 "parse.y"
    { ((*yyvalp).code) = RSHIFT_EXPR; ;}
    break;

  case 663:
#line 2244 "parse.y"
    { ((*yyvalp).code) = TRUTH_OR_EXPR; ;}
    break;

  case 664:
#line 2245 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; chk_dialect ("`or else' (without underscore) is", GNU_PASCAL); ;}
    break;

  case 665:
#line 2246 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; ;}
    break;

  case 666:
#line 2247 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; chk_dialect ("`|' is", MAC_PASCAL); ;}
    break;

  case 667:
#line 2251 "parse.y"
    { ((*yyvalp).code) = TRUTH_AND_EXPR; ;}
    break;

  case 668:
#line 2252 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; chk_dialect ("`and then' (without underscore) is", GNU_PASCAL); ;}
    break;

  case 669:
#line 2253 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; ;}
    break;

  case 670:
#line 2254 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; chk_dialect ("`&' is", MAC_PASCAL); ;}
    break;

  case 671:
#line 2258 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilPlus", "+>"); ;}
    break;

  case 672:
#line 2259 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilMinus", "->"); ;}
    break;

  case 673:
#line 2260 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorPlus", "+<"); ;}
    break;

  case 674:
#line 2261 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorMinus", "-<"); ;}
    break;

  case 675:
#line 2265 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilMult", "*>"); ;}
    break;

  case 676:
#line 2266 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilRDiv", "/>"); ;}
    break;

  case 677:
#line 2267 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorMult", "*<"); ;}
    break;

  case 678:
#line 2268 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorRDiv", "/<"); ;}
    break;

  case 679:
#line 2275 "parse.y"
    { ((*yyvalp).itype) = IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))->symbol; ;}
    break;

  case 680:
#line 2277 "parse.y"
    { ((*yyvalp).itype) = p_and; ;}
    break;

  case 681:
#line 2278 "parse.y"
    { ((*yyvalp).itype) = p_or; ;}
    break;

  case 682:
#line 2279 "parse.y"
    { ((*yyvalp).itype) = p_not; ;}
    break;

  case 683:
#line 2280 "parse.y"
    { ((*yyvalp).itype) = p_xor; ;}
    break;

  case 684:
#line 2281 "parse.y"
    { ((*yyvalp).itype) = p_shl; ;}
    break;

  case 685:
#line 2282 "parse.y"
    { ((*yyvalp).itype) = p_shr; ;}
    break;

  case 686:
#line 2288 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BPlus", "+"); ;}
    break;

  case 687:
#line 2289 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BPlus", "+"); ;}
    break;

  case 688:
#line 2290 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMinus", "-"); ;}
    break;

  case 689:
#line 2291 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMinus", "-"); ;}
    break;

  case 690:
#line 2292 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMult", "*"); ;}
    break;

  case 691:
#line 2293 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("RDiv", "/"); ;}
    break;

  case 692:
#line 2294 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Div"); ;}
    break;

  case 693:
#line 2295 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Mod"); ;}
    break;

  case 694:
#line 2296 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("RPower", "**"); ;}
    break;

  case 695:
#line 2297 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("In"); ;}
    break;

  case 696:
#line 2298 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("LT", "<"); ;}
    break;

  case 697:
#line 2299 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("EQ", "="); ;}
    break;

  case 698:
#line 2300 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("GT", ">"); ;}
    break;

  case 699:
#line 2301 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("NE", "<>"); ;}
    break;

  case 700:
#line 2302 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("GE", ">="); ;}
    break;

  case 701:
#line 2303 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("LE", "<="); ;}
    break;

  case 702:
#line 2304 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("And"); ;}
    break;

  case 703:
#line 2305 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SAnd", "&"); ;}
    break;

  case 704:
#line 2306 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Or"); ;}
    break;

  case 705:
#line 2307 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SOr", "|"); ;}
    break;

  case 706:
#line 2308 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SymDiff", "<>"); ;}
    break;

  case 709:
#line 2315 "parse.y"
    { warn_about_keyword_redeclaration (((*yyvalp).ttype), 1); ;}
    break;

  case 719:
#line 2333 "parse.y"
    { warn_about_keyword_redeclaration (((*yyvalp).ttype), 1); ;}
    break;

  case 723:
#line 2345 "parse.y"
    { warn_about_keyword_redeclaration (((*yyvalp).ttype), 1); ;}
    break;

  case 764:
#line 2393 "parse.y"
    { ((*yyvalp).ttype) = check_identifier ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 770:
#line 2406 "parse.y"
    { char c = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ((*yyvalp).ttype) = make_identifier (&c, 1); ;}
    break;

  case 771:
#line 2413 "parse.y"
    { pushlevel_expand (); ;}
    break;

  case 772:
#line 2418 "parse.y"
    { poplevel_expand (0, 1); ;}
    break;

  case 773:
#line 2423 "parse.y"
    {
#ifndef EGCS97
        push_obstacks_nochange ();
        end_temporary_allocation ();
#endif
      ;}
    break;

  case 774:
#line 2433 "parse.y"
    { lex_const_equal = 0; ;}
    break;

  case 775:
#line 2438 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_protected); ;}
    break;

  case 776:
#line 2443 "parse.y"
    { yyerrok; ;}
    break;

  case 777:
#line 2445 "parse.y"
    { yyerrok; ;}
    break;

  case 784:
#line 2462 "parse.y"
    { error ("missing `)'"); ;}
    break;

  case 786:
#line 2468 "parse.y"
    { warning ("missing `.' at the end of program/unit/module"); ;}
    break;

  case 787:
#line 2473 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 788:
#line 2478 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;


    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
/* Line 750 of glr.c.  */
#line 7680 "parse.c"
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  /* `Use' the arguments.  */
  (void) yy0;
  (void) yy1;

  switch (yyn)
    {
      
    }
}

			      /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}

/** Number of symbols composing the right hand side of rule #RULE. */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

/** Left-hand-side symbol for rule #RULE. */
static inline yySymbol
yylhsNonterm (yyRuleNum yyrule)
{
  return yyr1[yyrule];
}

#define yyis_pact_ninf(yystate) \
  ((yystate) == YYPACT_NINF)

/** True iff LR state STATE has only a default reduction (regardless
 *  of token). */
static inline yybool
yyisDefaultedState (yyStateNum yystate)
{
  return yyis_pact_ninf (yypact[yystate]);
}

/** The default reduction for STATE, assuming it has one. */
static inline yyRuleNum
yydefaultAction (yyStateNum yystate)
{
  return yydefact[yystate];
}

#define yyis_table_ninf(yytable_value) \
  0

/** Set *YYACTION to the action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *CONFLICTS to a pointer into yyconfl to 0-terminated list of
 *  conflicting reductions.
 */
static inline void
yygetLRActions (yyStateNum yystate, int yytoken,
	        int* yyaction, const short int** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyaction = -yydefact[yystate];
      *yyconflicts = yyconfl;
    }
  else if (! yyis_table_ninf (yytable[yyindex]))
    {
      *yyaction = yytable[yyindex];
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
  else
    {
      *yyaction = 0;
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
}

static inline yyStateNum
yyLRgotoState (yyStateNum yystate, yySymbol yylhs)
{
  int yyr;
  yyr = yypgoto[yylhs - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yylhs - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

				/* GLRStates */

static void
yyaddDeferredAction (yyGLRStack* yystack, yyGLRState* yystate,
		     yyGLRState* rhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewItem;
  yynewItem = &yystack->yynextFree->yyoption;
  yystack->yyspaceLeft -= 1;
  yystack->yynextFree += 1;
  yynewItem->yyisState = yyfalse;
  yynewItem->yystate = rhs;
  yynewItem->yyrule = yyrule;
  yynewItem->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewItem;
  if (yystack->yyspaceLeft < YYHEADROOM)
    yyexpandGLRStack (yystack);
}

				/* GLRStacks */

/** Initialize SET to a singleton set containing an empty stack. */
static void
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates = (yyGLRState**) YYMALLOC (16 * sizeof yyset->yystates[0]);
  yyset->yystates[0] = NULL;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
}

/** Initialize STACK to a single empty stack, with total maximum
 *  capacity for all stacks of SIZE. */
static void
yyinitGLRStack (yyGLRStack* yystack, size_t yysize)
{
  yystack->yyerrflag = 0;
  yystack->yyerrState = 0;
  yynerrs = 0;
  yystack->yyspaceLeft = yysize;
  yystack->yynextFree = yystack->yyitems =
    (yyGLRStackItem*) YYMALLOC (yysize * sizeof yystack->yynextFree[0]);
  yystack->yysplitPoint = NULL;
  yystack->yylastDeleted = NULL;
  yyinitStateSet (&yystack->yytops);
}

#define YYRELOC(YYFROMITEMS,YYTOITEMS,YYX,YYTYPE) \
  &((YYTOITEMS) - ((YYFROMITEMS) - (yyGLRStackItem*) (YYX)))->YYTYPE

/** If STACK is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation. */
static void
yyexpandGLRStack (yyGLRStack* yystack)
{
#if YYSTACKEXPANDABLE
  yyGLRStack yynewStack;
  yyGLRStackItem* yyp0, *yyp1;
  size_t yysize, yynewSize;
  size_t yyn;
  yysize = yystack->yynextFree - yystack->yyitems;
  if (YYMAXDEPTH <= yysize)
    yyFail (yystack, "parser stack overflow");
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yyinitGLRStack (&yynewStack, yynewSize);
  for (yyp0 = yystack->yyitems, yyp1 = yynewStack.yyitems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*(yybool *) yyp0)
	{
	  yyGLRState* yys0 = &yyp0->yystate;
	  yyGLRState* yys1 = &yyp1->yystate;
	  if (yys0->yypred != NULL)
	    yys1->yypred =
	      YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
	  if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != NULL)
	    yys1->yysemantics.yyfirstVal =
	      YYRELOC(yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
	}
      else
	{
	  yySemanticOption* yyv0 = &yyp0->yyoption;
	  yySemanticOption* yyv1 = &yyp1->yyoption;
	  if (yyv0->yystate != NULL)
	    yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
	  if (yyv0->yynext != NULL)
	    yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
	}
    }
  if (yystack->yysplitPoint != NULL)
    yystack->yysplitPoint = YYRELOC (yystack->yyitems, yynewStack.yyitems,
				 yystack->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystack->yytops.yysize; yyn += 1)
    if (yystack->yytops.yystates[yyn] != NULL)
      yystack->yytops.yystates[yyn] =
	YYRELOC (yystack->yyitems, yynewStack.yyitems,
		 yystack->yytops.yystates[yyn], yystate);
  YYFREE (yystack->yyitems);
  yystack->yyitems = yynewStack.yyitems;
  yystack->yynextFree = yynewStack.yynextFree + yysize;
  yystack->yyspaceLeft = yynewStack.yyspaceLeft - yysize;

#else

  yyFail (yystack, "parser stack overflow");
#endif
}

static void
yyfreeGLRStack (yyGLRStack* yystack)
{
  YYFREE (yystack->yyitems);
  yyfreeStateSet (&yystack->yytops);
}

/** Assuming that S is a GLRState somewhere on STACK, update the
 *  splitpoint of STACK, if needed, so that it is at least as deep as
 *  S. */
static inline void
yyupdateSplit (yyGLRStack* yystack, yyGLRState* yys)
{
  if (yystack->yysplitPoint != NULL && yystack->yysplitPoint > yys)
    yystack->yysplitPoint = yys;
}

/** Invalidate stack #K in STACK. */
static inline void
yymarkStackDeleted (yyGLRStack* yystack, int yyk)
{
  if (yystack->yytops.yystates[yyk] != NULL)
    yystack->yylastDeleted = yystack->yytops.yystates[yyk];
  yystack->yytops.yystates[yyk] = NULL;
}

/** Undelete the last stack that was marked as deleted.  Can only be
    done once after a deletion, and only when all other stacks have
    been deleted. */
static void
yyundeleteLastStack (yyGLRStack* yystack)
{
  if (yystack->yylastDeleted == NULL || yystack->yytops.yysize != 0)
    return;
  yystack->yytops.yystates[0] = yystack->yylastDeleted;
  yystack->yytops.yysize = 1;
  YYDPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystack->yylastDeleted = NULL;
}

static inline void
yyremoveDeletes (yyGLRStack* yystack)
{
  size_t yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystack->yytops.yysize)
    {
      if (yystack->yytops.yystates[yyi] == NULL)
	{
	  if (yyi == yyj)
	    {
	      YYDPRINTF ((stderr, "Removing dead stacks.\n"));
	    }
	  yystack->yytops.yysize -= 1;
	}
      else
	{
	  yystack->yytops.yystates[yyj] = yystack->yytops.yystates[yyi];
	  if (yyj != yyi)
	    {
	      YYDPRINTF ((stderr, "Rename stack %lu -> %lu.\n",
			  (unsigned long int) yyi, (unsigned long int) yyj));
	    }
	  yyj += 1;
	}
      yyi += 1;
    }
}

/** Shift to a new state on stack #K of STACK, corresponding to LR state
 * LRSTATE, at input position POSN, with (resolved) semantic value SVAL. */
static inline void
yyglrShift (yyGLRStack* yystack, int yyk, yyStateNum yylrState, size_t yyposn,
	    YYSTYPE yysval, YYLTYPE* yylocp)
{
  yyGLRStackItem* yynewItem;

  yynewItem = yystack->yynextFree;
  yystack->yynextFree += 1;
  yystack->yyspaceLeft -= 1;
  yynewItem->yystate.yyisState = yytrue;
  yynewItem->yystate.yylrState = yylrState;
  yynewItem->yystate.yyposn = yyposn;
  yynewItem->yystate.yyresolved = yytrue;
  yynewItem->yystate.yypred = yystack->yytops.yystates[yyk];
  yystack->yytops.yystates[yyk] = &yynewItem->yystate;
  yynewItem->yystate.yysemantics.yysval = yysval;
  yynewItem->yystate.yyloc = *yylocp;
  if (yystack->yyspaceLeft < YYHEADROOM)
    yyexpandGLRStack (yystack);
}

/** Shift stack #K of YYSTACK, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE. */
static inline void
yyglrShiftDefer (yyGLRStack* yystack, int yyk, yyStateNum yylrState,
		 size_t yyposn, yyGLRState* rhs, yyRuleNum yyrule)
{
  yyGLRStackItem* yynewItem;

  yynewItem = yystack->yynextFree;
  yynewItem->yystate.yyisState = yytrue;
  yynewItem->yystate.yylrState = yylrState;
  yynewItem->yystate.yyposn = yyposn;
  yynewItem->yystate.yyresolved = yyfalse;
  yynewItem->yystate.yypred = yystack->yytops.yystates[yyk];
  yynewItem->yystate.yysemantics.yyfirstVal = NULL;
  yystack->yytops.yystates[yyk] = &yynewItem->yystate;
  yystack->yynextFree += 1;
  yystack->yyspaceLeft -= 1;
  yyaddDeferredAction (yystack, &yynewItem->yystate, rhs, yyrule);
}

/** Pop the symbols consumed by reduction #RULE from the top of stack
 *  #K of STACK, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved. Set *VALP to the resulting value,
 *  and *LOCP to the computed location (if any).  Return value is as
 *  for userAction. */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystack, int yyk, yyRuleNum yyrule,
	    YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystack->yysplitPoint == NULL)
    {
      /* Standard special case: single stack. */
      yyGLRStackItem* rhs = (yyGLRStackItem*) yystack->yytops.yystates[yyk];
      YYASSERT (yyk == 0);
      yystack->yynextFree -= yynrhs;
      yystack->yyspaceLeft += yynrhs;
      yystack->yytops.yystates[0] = & yystack->yynextFree[-1].yystate;
      return yyuserAction (yyrule, yynrhs, rhs,
			   yyvalp, yylocp, yystack);
    }
  else
    {
      int yyi;
      yyGLRState* yys;
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
	= yystack->yytops.yystates[yyk];
      for (yyi = 0; yyi < yynrhs; yyi += 1)
	{
	  yys = yys->yypred;
	  YYASSERT (yys);
	}
      yyupdateSplit (yystack, yys);
      yystack->yytops.yystates[yyk] = yys;
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
			   yyvalp, yylocp, yystack);
    }
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(K, Rule)
#else
# define YY_REDUCE_PRINT(K, Rule)	\
do {					\
  if (yydebug)				\
    yy_reduce_print (K, Rule);		\
} while (0)

/*----------------------------------------------------------.
| Report that the RULE is going to be reduced on stack #K.  |
`----------------------------------------------------------*/

static inline void
yy_reduce_print (size_t yyk, yyRuleNum yyrule)
{
  int yyi;
  YYFPRINTF (stderr, "Reducing stack %lu by rule %d (line %lu), ",
	     (unsigned long int) yyk, yyrule - 1,
	     (unsigned long int) yyrline[yyrule]);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytokenName (yyrhs[yyi]));
  YYFPRINTF (stderr, "-> %s\n", yytokenName (yyr1[yyrule]));
}
#endif

/** Pop items off stack #K of STACK according to grammar rule RULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with RULE and store its value with the
 *  newly pushed state, if FORCEEVAL or if STACK is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #K from
 *  the STACK. In this case, the (necessarily deferred) semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystack, size_t yyk, yyRuleNum yyrule,
             yybool yyforceEval)
{
  size_t yyposn = yystack->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystack->yysplitPoint == NULL)
    {
      YYSTYPE yysval;
      YYLTYPE yyloc;

      YY_REDUCE_PRINT (yyk, yyrule);
      YYCHK (yydoAction (yystack, yyk, yyrule, &yysval, &yyloc));
      yyglrShift (yystack, yyk,
		  yyLRgotoState (yystack->yytops.yystates[yyk]->yylrState,
				 yylhsNonterm (yyrule)),
		  yyposn, yysval, &yyloc);
    }
  else
    {
      size_t yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystack->yytops.yystates[yyk];
      yyStateNum yynewLRState;

      for (yys = yystack->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
	   0 < yyn; yyn -= 1)
	{
	  yys = yys->yypred;
	  YYASSERT (yys);
	}
      yyupdateSplit (yystack, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YYDPRINTF ((stderr,
		  "Reduced stack %lu by rule #%d; action deferred. Now in state %d.\n",
		  (unsigned long int) yyk, yyrule - 1, yynewLRState));
      for (yyi = 0; yyi < yystack->yytops.yysize; yyi += 1)
	if (yyi != yyk && yystack->yytops.yystates[yyi] != NULL)
	  {
	    yyGLRState* yyp, *yysplit = yystack->yysplitPoint;
	    yyp = yystack->yytops.yystates[yyi];
	    while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
	      {
		if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
		  {
		    yyaddDeferredAction (yystack, yyp, yys0, yyrule);
		    yymarkStackDeleted (yystack, yyk);
		    YYDPRINTF ((stderr, "Merging stack %lu into stack %lu.\n",
				(unsigned long int) yyk,
				(unsigned long int) yyi));
		    return yyok;
		  }
		yyp = yyp->yypred;
	      }
	  }
      yystack->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystack, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static int
yysplitStack (yyGLRStack* yystack, int yyk)
{
  if (yystack->yysplitPoint == NULL)
    {
      YYASSERT (yyk == 0);
      yystack->yysplitPoint = yystack->yytops.yystates[yyk];
    }
  if (yystack->yytops.yysize >= yystack->yytops.yycapacity)
    {
      yystack->yytops.yycapacity *= 2;
      yystack->yytops.yystates =
	(yyGLRState**) YYREALLOC (yystack->yytops.yystates,
				  (yystack->yytops.yycapacity
				   * sizeof yystack->yytops.yystates[0]));
    }
  yystack->yytops.yystates[yystack->yytops.yysize]
    = yystack->yytops.yystates[yyk];
  yystack->yytops.yysize += 1;
  return yystack->yytops.yysize-1;
}

/** True iff Y0 and Y1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols. */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
	   yyn = yyrhsLength (yyy0->yyrule);
	   yyn > 0;
	   yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
	if (yys0->yyposn != yys1->yyposn)
	  return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (Y0,Y1), (destructively) merge the
 *  alternative semantic values for the RHS-symbols of Y1 into the
 *  corresponding semantic value sets of the symbols of Y0. */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       yyn > 0;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    if (yys0 == yys1)
      break;
    else if (! yys0->yyresolved && ! yys1->yyresolved)
      {
	yySemanticOption* yyz;
	for (yyz = yys0->yysemantics.yyfirstVal; yyz->yynext != NULL;
	     yyz = yyz->yynext)
	  continue;
	yyz->yynext = yys1->yysemantics.yyfirstVal;
      }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred. */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
	return 0;
      else
	return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yySemanticOption* yyoptionList,
				   yyGLRStack* yystack, YYSTYPE* yyvalp,
				   YYLTYPE* yylocp);

static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn, yyGLRStack* yystack)
{
  YYRESULTTAG yyflag;
  if (0 < yyn)
    {
      YYASSERT (yys->yypred);
      yyflag = yyresolveStates (yys->yypred, yyn-1, yystack);
      if (yyflag != yyok)
	return yyflag;
      if (! yys->yyresolved)
	{
	  yyflag = yyresolveValue (yys->yysemantics.yyfirstVal, yystack,
				   &yys->yysemantics.yysval, &yys->yyloc
				  );
	  if (yyflag != yyok)
	    return yyflag;
	  yys->yyresolved = yytrue;
	}
    }
  return yyok;
}

static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystack,
	         YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs;

  yynrhs = yyrhsLength (yyopt->yyrule);
  YYCHK (yyresolveStates (yyopt->yystate, yynrhs, yystack));
  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  return yyuserAction (yyopt->yyrule, yynrhs,
		       yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
		       yyvalp, yylocp, yystack);
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == NULL)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, empty>\n",
	       yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
	       yyx->yyrule);
  else
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, tokens %lu .. %lu>\n",
	       yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
	       yyx->yyrule, (unsigned long int) (yys->yyposn + 1),
	       (unsigned long int) yyx->yystate->yyposn);
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
	{
	  if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
	    YYFPRINTF (stderr, "%*s%s <empty>\n", yyindent+2, "",
		       yytokenName (yyrhs[yyprhs[yyx->yyrule]+yyi-1]));
	  else
	    YYFPRINTF (stderr, "%*s%s <tokens %lu .. %lu>\n", yyindent+2, "",
		       yytokenName (yyrhs[yyprhs[yyx->yyrule]+yyi-1]),
		       (unsigned long int) (yystates[yyi - 1]->yyposn + 1),
		       (unsigned long int) yystates[yyi]->yyposn);
	}
      else
	yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static void
yyreportAmbiguity (yySemanticOption* yyx0, yySemanticOption* yyx1,
		   yyGLRStack* yystack)
{
  /* `Unused' warnings.  */
  (void) yyx0;
  (void) yyx1;

#if YYDEBUG
  YYFPRINTF (stderr, "Ambiguity detected.\n");
  YYFPRINTF (stderr, "Option 1,\n");
  yyreportTree (yyx0, 2);
  YYFPRINTF (stderr, "\nOption 2,\n");
  yyreportTree (yyx1, 2);
  YYFPRINTF (stderr, "\n");
#endif
  yyFail (yystack, "ambiguity detected");
}


/** Resolve the ambiguity represented by OPTIONLIST, perform the indicated
 *  actions, and return the result. */
static YYRESULTTAG
yyresolveValue (yySemanticOption* yyoptionList, yyGLRStack* yystack,
		YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yySemanticOption* yybest;
  yySemanticOption* yyp;
  int yymerge;

  yybest = yyoptionList;
  yymerge = 0;
  for (yyp = yyoptionList->yynext; yyp != NULL; yyp = yyp->yynext)
    {
      if (yyidenticalOptions (yybest, yyp))
	yymergeOptionSets (yybest, yyp);
      else
	switch (yypreference (yybest, yyp))
	  {
	  case 0:
	    yyreportAmbiguity (yybest, yyp, yystack);
	    break;
	  case 1:
	    yymerge = 1;
	    break;
	  case 2:
	    break;
	  case 3:
	    yybest = yyp;
	    yymerge = 0;
	    break;
	  }
    }

  if (yymerge)
    {
      int yyprec = yydprec[yybest->yyrule];
      YYCHK (yyresolveAction (yybest, yystack, yyvalp, yylocp));
      for (yyp = yybest->yynext; yyp != NULL; yyp = yyp->yynext)
	{
	  if (yyprec == yydprec[yyp->yyrule])
	    {
	      YYSTYPE yyval1;
	      YYLTYPE yydummy;
	      YYCHK (yyresolveAction (yyp, yystack, &yyval1, &yydummy));
	      yyuserMerge (yymerger[yyp->yyrule], yyvalp, &yyval1);
	    }
	}
      return yyok;
    }
  else
    return yyresolveAction (yybest, yystack, yyvalp, yylocp);
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystack)
{
  if (yystack->yysplitPoint != NULL)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystack->yytops.yystates[0];
	   yys != yystack->yysplitPoint;
	   yys = yys->yypred, yyn += 1)
	continue;
      YYCHK (yyresolveStates (yystack->yytops.yystates[0], yyn, yystack
			     ));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystack)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystack->yytops.yysize != 1 || yystack->yysplitPoint == NULL)
    return;

  for (yyp = yystack->yytops.yystates[0], yyq = yyp->yypred, yyr = NULL;
       yyp != yystack->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystack->yyspaceLeft += yystack->yynextFree - yystack->yyitems;
  yystack->yynextFree = ((yyGLRStackItem*) yystack->yysplitPoint) + 1;
  yystack->yyspaceLeft -= yystack->yynextFree - yystack->yyitems;
  yystack->yysplitPoint = NULL;
  yystack->yylastDeleted = NULL;

  while (yyr != NULL)
    {
      yystack->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystack->yynextFree->yystate.yypred = & yystack->yynextFree[-1].yystate;
      yystack->yytops.yystates[0] = &yystack->yynextFree->yystate;
      yystack->yynextFree += 1;
      yystack->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystack, int yyk,
	           size_t yyposn, YYSTYPE* yylvalp, YYLTYPE* yyllocp
		  )
{
  int yyaction;
  const short int* yyconflicts;
  yyRuleNum yyrule;
  yySymbol* const yytokenp = yystack->yytokenp;

  while (yystack->yytops.yystates[yyk] != NULL)
    {
      yyStateNum yystate = yystack->yytops.yystates[yyk]->yylrState;
      YYDPRINTF ((stderr, "Stack %d Entering state %d\n", yyk, yystate));

      YYASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
	{
	  yyrule = yydefaultAction (yystate);
	  if (yyrule == 0)
	    {
	      YYDPRINTF ((stderr, "Stack %d dies.\n", yyk));
	      yymarkStackDeleted (yystack, yyk);
	      return yyok;
	    }
	  YYCHK (yyglrReduce (yystack, yyk, yyrule, yyfalse));
	}
      else
	{
	  if (*yytokenp == YYEMPTY)
	    {
	      YYDPRINTF ((stderr, "Reading a token: "));
	      yychar = YYLEX;
	      *yytokenp = YYTRANSLATE (yychar);
	      YY_SYMBOL_PRINT ("Next token is", *yytokenp, yylvalp, yyllocp);
	    }
	  yygetLRActions (yystate, *yytokenp, &yyaction, &yyconflicts);

	  while (*yyconflicts != 0)
	    {
	      int yynewStack = yysplitStack (yystack, yyk);
	      YYDPRINTF ((stderr, "Splitting off stack %d from %d.\n",
			  yynewStack, yyk));
	      YYCHK (yyglrReduce (yystack, yynewStack,
				  *yyconflicts, yyfalse));
	      YYCHK (yyprocessOneStack (yystack, yynewStack, yyposn,
					yylvalp, yyllocp));
	      yyconflicts += 1;
	    }

	  if (yyisShiftAction (yyaction))
	    {
	      YYDPRINTF ((stderr, "On stack %d, ", yyk));
	      YY_SYMBOL_PRINT ("shifting", *yytokenp, yylvalp, yyllocp);
	      yyglrShift (yystack, yyk, yyaction, yyposn+1,
			  *yylvalp, yyllocp);
	      YYDPRINTF ((stderr, ", now in state #%d\n",
			  yystack->yytops.yystates[yyk]->yylrState));
	      break;
	    }
	  else if (yyisErrorAction (yyaction))
	    {
	      YYDPRINTF ((stderr, "Stack %d dies.\n", yyk));
	      yymarkStackDeleted (yystack, yyk);
	      break;
	    }
	  else
	    YYCHK (yyglrReduce (yystack, yyk, -yyaction, yyfalse));
	}
    }
  return yyok;
}

static void
yyreportSyntaxError (yyGLRStack* yystack,
		     YYSTYPE* yylvalp, YYLTYPE* yyllocp)
{
  /* `Unused' warnings. */
  (void) yylvalp;
  (void) yyllocp;

  if (yystack->yyerrState == 0)
    {
#if YYERROR_VERBOSE
      yySymbol* const yytokenp = yystack->yytokenp;
      int yyn;
      yyn = yypact[yystack->yytops.yystates[0]->yylrState];
      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  size_t yysize = 0;
	  const char* yyprefix;
	  char* yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += strlen (yyprefix) + strlen (yytokenName (yyx));
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
		yyprefix = " or ";
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + strlen (yytokenName (*yytokenp)));
	  yymsg = (char*) YYMALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char* yyp = yymsg;
	      sprintf (yyp, "syntax error%s%s",
		       (*yytokenp == YYEMPTY ? "" : ", unexpected "),
		       yytokenName (*yytokenp));
	      yyp += strlen (yyp);
	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			sprintf (yyp, "%s%s", yyprefix, yytokenName (yyx));
			yyp += strlen (yyp);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYFREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
      yynerrs += 1;
    }
}

/* Recover from a syntax error on YYSTACK, assuming that YYTOKENP,
   YYLVALP, and YYLLOCP point to the syntactic category, semantic
   value, and location of the look-ahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystack,
		      YYSTYPE* yylvalp,
		      YYLTYPE* yyllocp
		      )
{
  yySymbol* const yytokenp = yystack->yytokenp;
  size_t yyk;
  int yyj;

  if (yystack->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
	if (*yytokenp == YYEOF)
	  {
	    /* Now pop stack until empty and fail. */
	    while (yystack->yytops.yystates[0] != NULL)
	      {
		yyGLRState *yys = yystack->yytops.yystates[0];
		yystack->yyerror_range[1].yystate.yyloc = yys->yyloc;
		yydestruct ("Error: popping",
                            yystos[yys->yylrState],
			    &yys->yysemantics.yysval, &yys->yyloc);
		yystack->yytops.yystates[0] = yys->yypred;
		yystack->yynextFree -= 1;
		yystack->yyspaceLeft += 1;
	      }
	    yyFail (yystack, NULL);
	  }
	if (*yytokenp != YYEMPTY)
	  {
	    /* We throw away the lookahead, but the error range
	       of the shifted error token must take it into account. */
	    yyGLRState *yys = yystack->yytops.yystates[0];
	    yyGLRStackItem yyerror_range[3];
	    yyerror_range[1].yystate.yyloc = yys->yyloc;
	    yyerror_range[2].yystate.yyloc = *yyllocp;
	    YYLLOC_DEFAULT (yys->yyloc, yyerror_range, 2);
	    yydestruct ("Error: discarding",
			*yytokenp, yylvalp, yyllocp);
	  }
	YYDPRINTF ((stderr, "Reading a token: "));
	yychar = YYLEX;
	*yytokenp = YYTRANSLATE (yychar);
	YY_SYMBOL_PRINT ("Next token is", *yytokenp, yylvalp, yyllocp);
	yyj = yypact[yystack->yytops.yystates[0]->yylrState];
	if (yyis_pact_ninf (yyj))
	  return;
	yyj += *yytokenp;
	if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != *yytokenp)
	  {
	    if (yydefact[yystack->yytops.yystates[0]->yylrState] != 0)
	      return;
	  }
	else if (yytable[yyj] != 0 && ! yyis_table_ninf (yytable[yyj]))
	  return;
      }

  /* Reduce to one stack.  */
  for (yyk = 0; yyk < yystack->yytops.yysize; yyk += 1)
    if (yystack->yytops.yystates[yyk] != NULL)
      break;
  if (yyk >= yystack->yytops.yysize)
    yyFail (yystack, NULL);
  for (yyk += 1; yyk < yystack->yytops.yysize; yyk += 1)
    yymarkStackDeleted (yystack, yyk);
  yyremoveDeletes (yystack);
  yycompressStack (yystack);

  /* Now pop stack until we find a state that shifts the error token. */
  yystack->yyerrState = 3;
  while (yystack->yytops.yystates[0] != NULL)
    {
      yyGLRState *yys = yystack->yytops.yystates[0];
      yyj = yypact[yys->yylrState];
      if (! yyis_pact_ninf (yyj))
	{
	  yyj += YYTERROR;
	  if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
	      && yyisShiftAction (yytable[yyj]))
	    {
	      /* Shift the error token having adjusted its location.  */
	      YYLTYPE yyerrloc;
	      yystack->yyerror_range[2].yystate.yyloc = *yyllocp;
	      YYLLOC_DEFAULT (yyerrloc, yystack->yyerror_range, 2);
	      YY_SYMBOL_PRINT ("Shifting", yystos[yytable[yyj]],
			       yylvalp, &yyerrloc);
	      yyglrShift (yystack, 0, yytable[yyj],
			  yys->yyposn, *yylvalp, &yyerrloc);
	      yys = yystack->yytops.yystates[0];
	      break;
	    }
	}
      yystack->yyerror_range[1].yystate.yyloc = yys->yyloc;
      yydestruct ("Error: popping",
		  yystos[yys->yylrState],
	          &yys->yysemantics.yysval, &yys->yyloc);
      yystack->yytops.yystates[0] = yys->yypred;
      yystack->yynextFree -= 1;
      yystack->yyspaceLeft += 1;
    }
  if (yystack->yytops.yystates[0] == NULL)
    yyFail (yystack, NULL);
}

#define YYCHK1(YYE)							     \
  do {									     \
    switch (YYE) {							     \
    default:								     \
      break;								     \
    case yyabort:							     \
      yystack.yyerrflag = 1;						     \
      goto yyDone;							     \
    case yyaccept:							     \
      yystack.yyerrflag = 0;						     \
      goto yyDone;							     \
    case yyerr:								     \
      goto yyuser_error;						     \
    }									     \
  } while (0)


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
  yySymbol yytoken;
  yyGLRStack yystack;
  size_t yyposn;


  YYSTYPE* const yylvalp = &yylval;
  YYLTYPE* const yyllocp = &yylloc;

  yyinitGLRStack (&yystack, YYINITDEPTH);
  yystack.yytokenp = &yytoken;

  YYDPRINTF ((stderr, "Starting parse\n"));

  if (setjmp (yystack.yyexception_buffer) != 0)
    goto yyDone;

  yylval = yyval_default;

#if YYLTYPE_IS_TRIVIAL
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif


  yyglrShift (&yystack, 0, 0, 0, yylval, &yylloc);
  yytoken = YYEMPTY;
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
	 specialized to deterministic operation (single stack, no
	 potential ambiguity).  */
      /* Standard mode */
      while (yytrue)
	{
	  yyRuleNum yyrule;
	  int yyaction;
	  const short int* yyconflicts;

	  yyStateNum yystate = yystack.yytops.yystates[0]->yylrState;
          YYDPRINTF ((stderr, "Entering state %d\n", yystate));
	  if (yystate == YYFINAL)
	    goto yyDone;
	  if (yyisDefaultedState (yystate))
	    {
	      yyrule = yydefaultAction (yystate);
	      if (yyrule == 0)
		{
		  yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
		  yyreportSyntaxError (&yystack, yylvalp, yyllocp);
		  goto yyuser_error;
		}
	      YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue));
	    }
	  else
	    {
	      if (yytoken == YYEMPTY)
		{
		  YYDPRINTF ((stderr, "Reading a token: "));
		  yychar = YYLEX;
		  yytoken = YYTRANSLATE (yychar);
                  YY_SYMBOL_PRINT ("Next token is", yytoken, yylvalp, yyllocp);
		}
	      yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);
	      if (*yyconflicts != 0)
		break;
	      if (yyisShiftAction (yyaction))
		{
		  YY_SYMBOL_PRINT ("Shifting", yytoken, yylvalp, yyllocp);
		  if (yytoken != YYEOF)
		    yytoken = YYEMPTY;
		  yyposn += 1;
		  yyglrShift (&yystack, 0, yyaction, yyposn,
		              yylval, yyllocp);
		  if (0 < yystack.yyerrState)
		    yystack.yyerrState -= 1;
		}
	      else if (yyisErrorAction (yyaction))
		{
		  yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
		  yyreportSyntaxError (&yystack, yylvalp, yyllocp);
		  goto yyuser_error;
		}
	      else
		YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue));
	    }
	}

      while (yytrue)
	{
	  int yys;
	  int yyn = yystack.yytops.yysize;
	  for (yys = 0; yys < yyn; yys += 1)
	    YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn,
				       yylvalp, yyllocp));
	  yytoken = YYEMPTY;
	  yyposn += 1;
	  yyremoveDeletes (&yystack);
	  if (yystack.yytops.yysize == 0)
	    {
	      yyundeleteLastStack (&yystack);
	      if (yystack.yytops.yysize == 0)
		yyFail (&yystack, "syntax error");
	      YYCHK1 (yyresolveStack (&yystack));
	      YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
	      yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
	      yyreportSyntaxError (&yystack, yylvalp, yyllocp);
	      goto yyuser_error;
	    }
	  else if (yystack.yytops.yysize == 1)
	    {
	      YYCHK1 (yyresolveStack (&yystack));
	      YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
	      yycompressStack (&yystack);
	      break;
	    }
	}
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack, yylvalp, yyllocp);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }
 yyDone:
  /* On YYABORT, free the lookahead. */
  if (yystack.yyerrflag == 1 && yytoken != YYEMPTY)
    yydestruct ("Error: discarding lookahead",
                yytoken, yylvalp, yyllocp);

  yyfreeGLRStack (&yystack);
  return yystack.yyerrflag;
}

/* DEBUGGING ONLY */
#ifdef YYDEBUG
static void yypstack (yyGLRStack* yystack, int yyk) ATTRIBUTE_UNUSED;
static void yypdumpstack (yyGLRStack* yystack) ATTRIBUTE_UNUSED;

static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      fprintf (stderr, " -> ");
    }
  fprintf (stderr, "%d@%lu", yys->yylrState, (unsigned long int) yys->yyposn);
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == NULL)
    fprintf (stderr, "<null>");
  else
    yy_yypstack (yyst);
  fprintf (stderr, "\n");
}

static void
yypstack (yyGLRStack* yystack, int yyk)
{
  yypstates (yystack->yytops.yystates[yyk]);
}

#define YYINDEX(YYX)							     \
    ((YYX) == NULL ? -1 : (yyGLRStackItem*) (YYX) - yystack->yyitems)


static void
yypdumpstack (yyGLRStack* yystack)
{
  yyGLRStackItem* yyp;
  size_t yyi;
  for (yyp = yystack->yyitems; yyp < yystack->yynextFree; yyp += 1)
    {
      fprintf (stderr, "%3lu. ", (unsigned long int) (yyp - yystack->yyitems));
      if (*(yybool *) yyp)
	{
	  fprintf (stderr, "Res: %d, LR State: %d, posn: %lu, pred: %ld",
		   yyp->yystate.yyresolved, yyp->yystate.yylrState,
		   (unsigned long int) yyp->yystate.yyposn,
		   (long int) YYINDEX (yyp->yystate.yypred));
	  if (! yyp->yystate.yyresolved)
	    fprintf (stderr, ", firstVal: %ld",
		     (long int) YYINDEX (yyp->yystate.yysemantics.yyfirstVal));
	}
      else
	{
	  fprintf (stderr, "Option. rule: %d, state: %ld, next: %ld",
		   yyp->yyoption.yyrule,
		   (long int) YYINDEX (yyp->yyoption.yystate),
		   (long int) YYINDEX (yyp->yyoption.yynext));
	}
      fprintf (stderr, "\n");
    }
  fprintf (stderr, "Tops:");
  for (yyi = 0; yyi < yystack->yytops.yysize; yyi += 1)
    fprintf (stderr, "%lu: %ld; ", (unsigned long int) yyi,
	     (long int) YYINDEX (yystack->yytops.yystates[yyi]));
  fprintf (stderr, "\n");
}
#endif


#line 2481 "parse.y"


/* Lexical analyzer moved to gpc-lex.c */

/* Parser auxiliary routines */

/* Check the order of declarations for various standards */
static int
check_decl_order (prev, new)
     int prev, new;
{
  int prev_decl_order = prev / 2, prev_import = prev & 1;
  if (new == od_none)
    return prev;
  if (new <= prev_decl_order && new < od_routine)
    chk_dialect ("mixed order of declaration parts is", NOT_CLASSIC_PASCAL);
  if (new == od_uses)
    {
      if (prev_import)
        chk_dialect ("multiple `uses' parts are", GNU_PASCAL);
      if (prev_decl_order > od_uses)
        chk_dialect ("`uses' after other declarations is", GNU_PASCAL);
      prev_import = 1;
    }
  return (2 * new) | prev_import;
}

static tree
iso_no_parentheses (t)
     tree t;
{
  if (last_parenthesized_expression == t)
    chk_dialect ("superfluous parentheses in this place are", B_D_M_PASCAL);
  return t;
}

/* Sets the value of the 'yydebug' variable to VALUE. This is a function
   so we don't have to have YYDEBUG defined in order to build the compiler. */
void
set_yydebug (value)
     int value;
{
#if YYDEBUG != 0
  yydebug = value;
#else
  warning ("YYDEBUG not defined.");
#endif
}

#undef yyparse
int
yyparse ()
{
  init_predef ();
  return main_yyparse ();
}

static void
locations (dest, src, n)
     YYLTYPE *dest;
     const /*YYLTYPE*/ union yyGLRStackItem *src;
     int n;
{
  int i;
  for (i = n; i > 0 && !YYRHSLOC (src, i).first_line; i--) ;
  if (i == 0)
    {
      input_filename = compiler_filename;
      lineno = compiler_lineno;
      column = compiler_column;
      dest->first_file = dest->last_file = NULL;
      dest->first_line = dest->last_line = dest->first_column = dest->last_column = 0;
    }
  else
    {
      input_filename = compiler_filename = dest->last_file = YYRHSLOC (src, i).last_file;
      lineno = compiler_lineno = dest->last_line = YYRHSLOC (src, i).last_line;
      column = compiler_column = dest->last_column = YYRHSLOC (src, i).last_column;
      for (i = 1; i <= n && !YYRHSLOC (src, i).first_line; i++) ;
      dest->first_file = YYRHSLOC (src, i).first_file;
      dest->first_line = YYRHSLOC (src, i).first_line;
      dest->first_column = YYRHSLOC (src, i).first_column;
      /* This does emit a few line notes too many. But putting line notes in the
         parser in the right places causes some conflicts (especially
         assignments with nontrivial expressions on their left side are
         problematic). A better solution might be possible when we don't emit
         things so early. */
      if (current_function_decl)
#ifndef GCC_3_4
        emit_line_note (dest->first_file, dest->first_line);
#else
        {
          location_t loc_aux;
          loc_aux.file = dest->first_file;
          loc_aux.line = dest->first_line;
          emit_line_note (loc_aux);
        }
#endif
    }
  dest->option_id = 0;
  for (i = 1; i <= n; i++)
    while (YYRHSLOC (src, i).option_id > compiler_options->counter)
      {
        struct options *tmp = compiler_options;
        compiler_options = tmp->next;
        free (tmp);
      }
  if (compiler_options != co)
    activate_options (compiler_options, 0);
}

